Package: fOptions
Title: Rmetrics - Pricing and Evaluating Basic Options
Date: 2017-11-12
Version: 3042.86
Author: Diethelm Wuertz [aut],
	Tobias Setz [cre],
	Yohan Chalabi [ctb]
Maintainer: Tobias Setz <tobias.setz@live.com>
Description: Provides a collection of functions to 
    valuate basic options. This includes the generalized
	Black-Scholes option, options on futures and options on
	commodity futures.
Depends: timeDate, timeSeries, fBasics
Imports: graphics, methods, stats
Suggests: RUnit, tcltk
LazyData: yes
License: GPL (>= 2)
URL: http://www.rmetrics.org
NeedsCompilation: yes
Packaged: 2017-11-16 17:28:35 UTC; Tobias Setz
Repository: CRAN
Date/Publication: 2017-11-16 22:46:13 UTC

#
# Examples from the forthcoming Monograph:
#   Rmetrics - Financial Engineering and Computational Finance
#   A Practitioner's Guide for R and SPlus Programmers
#   written by Diethelm Wuertz
#   ISBN to be published
#
# Details:
#   Examples from Chapter 7.4
#   Heston-Nandi Option Pricing
#
# List of Examples, Exercises and Code Snippets
#
#   * Example: Computing the Price of Heston-Nandi Options
#   * Example: Computing the Greeks of Heston-Nandi Options
#   * Example: HN Options Pricing - GARCH(1,1) Simulation 
#   * Example: HN Options Pricing - Max LogLikelihood Estimation
#   * Example: HN Options Pricing - Scaling of Prices   
#   * Example: Investigate the Smile Effect
#
#   *** This list is not yet complete ***
#
# Author:
#   (C) 2002-2005, Diethelm Wuertz, GPL
#     www.rmetrics.org
#     www.itp.phys.ethz.ch
#     www.finance.ch
#


################################################################################


### Example: Computing the Price of Heston-Nandi Options

    # Calculate the price of Heston-Nandi Garch(1,1)
    # call and put options.     
    ###

    # Set the Model Parameters for the HN Garch(1,1) Option:
    model = list(lambda = -0.5, omega = 5e-6, alpha = 1e-8, 
        beta = 0.7, gamma = 10)
    S = X = 100
    Time.inDays = 250
    r.daily = 0.05/250
    ###
    
    # List the R Function:
    HNGOption
    ###
    
    # Compute the Option Price:
    # Call:
    HNGOption(TypeFlag = "c", model, S, X, Time.inDays, r.daily)
    # Put:
    HNGOption(TypeFlag = "p", model, S, X, Time.inDays, r.daily)
    ###
    
    # Compare with the Black-Scholes Formula:
    # Unconditional Variance:
    sigma2.daily = (model$alpha + model$omega) /
        (1-model$beta-model$alpha*model$gamma^2)    
    # Call:
    GBSOption("c", S = 100, X = 100, Time = 1, r = 0.05,
        b = 0.05, sigma = sqrt(sigma2.daily*250))   
    # Put:
    GBSOption("p", S = 100, X = 100, Time = 1, r = 0.05,
        b = 0.05, sigma = sqrt(sigma2.daily*250))
    ###
        
# ------------------------------------------------------------------------------


### Example: Computing the Greeks of Heston-Nandi Options
    
    # Calculate the sensitiviteis delta and gamma of 
    # Heston-Nandi Garch(1,1) call and put options.     
    ###
    
    # Option Parameters:
    S = X = 100
    Time.inDays = 125
    r.daily = 0.05/250
    model = list(lambda = -0.5, omega = 2.3e-6, alpha = 2.9e-6, 
        beta = 0.85, gamma = 184.25)
    sigma.daily = sqrt((model$alpha + model$omega) /
        (1 - model$beta - model$alpha*model$gamma^2))       
    # Print:
    S; X; Time.inDays; r.daily; sigma.daily
    model
    ###

    # Compute the Delta 
    # and compare the result with the finite dfference approaximation:
    Summary = NULL
    # Call:
    Greek = HNGGreeks("Delta", "c", model, S, X, Time.inDays, r.daily)
    C1 = HNGOption("c", model, S*0.9999, X, Time.inDays, r.daily)$price
    C2 = HNGOption("c", model, S*1.0001, X, Time.inDays, r.daily)$price
    numGreek = (C2-C1)/(0.0002*S)
    Diff = 100*(Greek-numGreek)/Greek
    Summary = rbind(Summary, c(Greek, numGreek, Diff))
    # Put:
    Greek = HNGGreeks("Delta", "p", model, S, X, Time.inDays, r.daily)
    C1 = HNGOption("p", model, S*0.9999, X, Time.inDays, r.daily)$price
    C2 = HNGOption("p", model, S*1.0001, X, Time.inDays, r.daily)$price
    numGreek = (C2-C1)/(0.0002*S)
    Diff = 100*(Greek-numGreek)/Greek
    Summary = rbind(Summary, c(Greek, numGreek, Diff))
    # Print:
    dimnames(Summary) <- 
        list(c("Call", "Put"), c("Greek", "numGreek", "Diff"))
    Summary
    ###
    
    # Do the same for the Gamma Sensitivity ...
    Summary = NULL
    # Call:
    Greek = HNGGreeks("Gamma", "c", model, S, X, Time.inDays, r.daily)
    C0 = HNGOption("c", model, S, X, Time.inDays, r.daily)$price
    C1 = HNGOption("c", model, S*0.9999, X, Time.inDays, r.daily)$price 
    C2 = HNGOption("c", model, S*1.0001, X, Time.inDays, r.daily)$price     
    numGreek = (C2 - 2*C0 + C1)/(0.0002*S/2)^2
    Diff = 100*(Greek-numGreek)/Greek   
    Summary = rbind(Summary, c(Greek, numGreek, Diff))
    # Put:
    Greek = HNGGreeks("Gamma", "p", model, S, X, Time.inDays, r.daily)
    C0 = HNGOption("p", model, S, X, Time.inDays, r.daily)$price
    C1 = HNGOption("p", model, S*0.9999, X, Time.inDays, r.daily)$price 
    C2 = HNGOption("p", model, S*1.0001, X, Time.inDays, r.daily)$price 
    numGreek = (C2 - 2*C0 + C1)/(0.0002*S/2)^2
    Diff = 100*(Greek-numGreek)/Greek   
    Summary = rbind(Summary, c(Greek, numGreek, Diff))
    # Print:
    dimnames(Summary) <- 
        list(c("Call", "Put"), c("Greek", "numGreek", "Diff"))
    Summary
    ###
    
    
# ------------------------------------------------------------------------------


### Example: HN Options Pricing - GARCH(1,1) Simulation

    # Description:
    #   Simulate time series with the same parameters as those
    #   fitted by Heston and nandi to the SP500 data ranging
    #   the three years from 01/08/1992 to 12/30/1994.
    #   DATA:
    #     Index Value at 2:30 PM
    #     No. of observations 755
    #     r - TBill rate (3.7%)
    #   RESULT:
    #           lambda   omega   alpha  beta  gamma  THETA   PERS  MLLH
    #     Sym:     0.7  1.6e-6  1.0e-6  0.92    ---   9.2%   0.92  3492
    #     Asym:    0.2  5.0e-6  1.0e-6  0.59    421   8.0%   0.77  3504 
    # Reference:
    #   S. Heston and S. Nandi, 1997
    #   A Closed-Form GARCH Option Pricing Model
    ###
    
    # Fit a Symmetric HN-GARCH(1,1) Process:
    set.seed(4711)
    model = list(lambda = 0.7, omega = 1.6e-6, alpha = 1e-6, 
        beta = 0.92, gamma = 0, rf = 0.037/252)
    ts.sym = hngarchSim(model, n = 755, n.start = 100)
    par(mfcol = c(3, 2), cex = 0.5)
    ts.plot(ts.sym, main = "Symmetric Data")
    ###
        
    # Fit an Asymmetric HN-GARCH(1,1) Process:
    set.seed(4711)
    model = list(lambda = 0.2, omega = 5.0e-6, alpha = 1e-6, 
        beta = 0.59, gamma = 421, rf = 0.037/252)
    ts.asym = hngarchSim(model, n = 755, n.start = 100)
    ts.plot(ts.asym, main = "Asymmetric Data")
    # Plot Both:
    ts.plot(ts.asym, main = "Both Data Sets")
    lines(ts.sym, col = "red")
    ###
    
    # ACF Plots:
    result = acf(abs(ts.sym), main = "ACF: Symmetric Data")
    result = acf(abs(ts.asym), main = "ACF: Asymmetric Data")
    ###
    
    
# ------------------------------------------------------------------------------


### Example: HN Options Pricing - Max LogLikelihood Estimation

    # Simulate time series with the same parameters as those
    # fitted by Heston and nandi to the SP500 data ranging
    # from 2/8/1992 to 30/12/1994, finally re-fit the parameters.
    #   DATA:
    #     Index Value at 2:30 PM
    #     No. of observations 755
    #     r - TBill rate (3.5%)
    #   RESULT:
    #           lambda   omega   alpha  beta  gamma  THETA   PERS  MLLH
    #     Sym:     0.7  1.6e-6  1.0e-6  0.92    ---   9.2%   0.92  3492
    #     Asym:    0.2  5.0e-6  1.0e-6  0.59    421   8.0%   0.77  3504 
    # Reference:
    #   S. Heston and S. Nandi, 1997
    #   A Closed-Form GARCH Option Pricing Model
    ###

    # SP500 Data from MASS Package:
    require(MASS)
    data(SP500)
    returns = SP500[505:(505+755)]/100
    model.sym = list(lambda = 0.2, omega = 1.6e-6, alpha = 1e-6, 
        beta = 0.92, gamma = 0, rf = 0.035/252)
    model.asym = list(lambda = 0.7, omega = 5e-6, alpha = 1e-6,
        beta = 0.59, gamma = 421, rf = 0.035/252)
    ###
    
    # Estimate the Symmetric HN-GARCH(1,1) Parameters: 
    fit.sym = hngarchFit(x = returns, model = model.sym, 
        symmetric = TRUE)
    fit.sym
    ### 
  
    # Estimate the Asymmetric HN-GARCH(1,1):
    fit.asym = hngarchFit(x = returns, model = model.asym, 
        symmetric = FALSE)
    fit.asym
    ###
    
    # Summarize Results:    
    data.frame(cbind(
        SYM = unlist(model.sym), 
        SYM.FIT = unlist(fit.sym$model),
        ASYM = unlist(model.asym),
        ASYM.FIT = unlist(fit.asym$model)
        ))
    ###
    
    # Diagnostic Analysis:
    par(mfcol = c(3,2), cex=0.5)
    summary(fit.sym)
    summary(fit.asym)
    ###
    
    # Moment Statistics:
    unlist(hngarchStats(model.sym))
    unlist(hngarchStats(model.asym))
    unlist(hngarchStats(fit.sym$model))
    unlist(hngarchStats(fit.asym$model))
    ###
    
    
# ------------------------------------------------------------------------------


### Example: HN Options Pricing - Scaling of Prices

    # The example shows for the HN Garch(1,1) model 
    # the scaling in price/strike and volatility*time.
    ###
    
    # Initial Parameter Setting:
    scales = c(1/2, 1, 2)
    Model = list(lambda=-0.5, omega=1e-6, alpha=1e-6, beta=0.5, gamma=0)
    par (mfrow = c(2, 2), cex = 0.7)
    ###
    
    # Price/Strike Variation:
    S  = seq(75, 125, by = 5); X = 100
    Time = 126 
    ###
    
    # HNG:  
    plot(x = c(0.75, 1.25), y = c(0, 28), type = "n", 
        xlab = "S/X", ylab = "Call Price", 
        main = "HN: Volatility*Time fixed")
    for (j in 1:length(scales)) {
        model = Model
        model$omega = Model$omega*scales[j]
        model$alpha = Model$alpha*scales[j]
        for (i in 1:length(S)) {
            x = S[i]/X
            y = HNGOption("c", model, S[i], X, Time/scales[j], 0)$price
            points(x, y, col = j, pch = (j+2)) } }
    legend(0.8, 26, legend = c("scale = 1/2", "scale = 1", "scale = 2"), 
        pch = "\3\4", bty = "n", col = 1:3)
    ###
        
    # BS:
    plot(x = c(0.75, 1.25), y = c(0, 28), type = "n", 
        xlab = "S/X", ylab = "Call Price", 
        main = "BS: Volatility*Time fixed")
    for (j in 1:length(scales)) {
        model = Model
        model$omega = Model$omega/scales[j]
        model$alpha = Model$alpha/scales[j]
        sigma = sqrt((model$alpha+model$omega)/(1-model$beta))
        print(sigma^2 * Time*scales[j])
        for (i in 1:length(S)) {
            x = S[i]/X
            y = GBSOption("c", S[i], X, Time*scales[j], r=0, b=0, 
                sigma=sigma)$price
            points(x, y, col = j, pch = (j+2)) } }  
    legend(0.8, 26, legend = c("scale = 1/2", "scale = 1", "scale = 2"), 
        pch = "\3\4", bty = "n", col = 1:3)
    ### 

    # Volatility*Time Variation:
    S = 100; X = 100
    Time = c((12:1)*21, 5, 1) 
    sigma = sqrt((Model$alpha+Model$omega)/(1-Model$beta)); 252*sigma
    ###
    
    # HNG:      
    plot(x = c(-252, 0) , y = c(1.5, 0), type = "n", xlab = "Days", 
        ylab = "Put Price / scale", main = "HN: S/X fixed")
    for ( j in 1:length(scales) ) {
        S.scaled = S*scales[j]; X.scaled = X*scales[j]  
        for (i in 1:length(Time)) {
            x = -Time[i]
            y = HNGOption("c", Model, S.scaled, X.scaled, Time[i], 0)$price /
                scales[j]
            points(x, y, col = j, pch = (j+2)) } }
    legend(-240, 0.6, legend = c("scale = 0.5", "scale = 1", "scale = 2"), 
        pch = "\3\4", bty = "n", col = 1:3)
    ### 
            
    # BS:
    plot(x = c(-252, 0) , y = c(1.5, 0), type = "n", xlab = "Days", 
        ylab = "Put Price / scale ", main = "BS: S/X fixed")
    for (j in 1:length(scales) ) {
        S.scaled = S*scales[j]; X.scaled = X*scales[j]  
        for (i in 1:length(Time)) {
            x = -Time[i]
            y = GBSOption("c", S.scaled, X.scaled, Time[i], 0, 0, sigma)$price /
                scales[j]
            points(x, y, col = j, pch = (j+2)) } }
    legend(-240, 0.6, legend = c("scale = 0.5", "scale = 1", "scale = 2"), 
        pch = "\3\4", bty = "n", col = 1:3)
    ###
            
        
# ------------------------------------------------------------------------------


### Example: Investigate the Smile Effect

    # This program calculates for the estimated symmetric and asymmetric
    # Garch(1,1) the implied volatility from the Black and Scholes Option
    # Pricing formula assuming that the real market follows ideally the
    # Heston Nandi Option Garch(1,1) model
    ### 
        
    # Show the GBSVolatility function:
    GBSVolatility
    ###

    # Compute Smile - Parameters:
    S  = 85:115; X = 100
    Time.inDays = 126 
    model = list(lambda=-0.5, omega=6e-6, alpha=4e-6, beta=0.8, gamma=0)
    sigma = sqrt(252*(model$alpha+model$omega)/(1-model$beta))
    sigma   
    ###
    
    # Pricing the Put:
    Put <- impVola <- NULL
    for (i in 1:length(S)) {
        Price = HNGOption("p", model, S[i], X, Time.inDays, 0)$price
        Put = c(Put, Price) 
        Volatility = GBSVolatility(Price, "p", S[i], X, Time.inDays/252, 0, 0)
        impVola = c(impVola, Volatility)
        cat("\n\t", i, "\t", S[i], "\t", Price, "\t", Volatility) }
    ###
        
    # Plot:
    par(mfrow = c(2, 2), cex = 0.7)
    plot(S/X, Put, 
        xlab = "S/X", ylab = "Price", main = "HN Put Price")
    plot(S/X, impVola, 
        xlab = "S/X", ylab = "Volatility", main = "BS Implied Volatility")
    ### 
    
        
################################################################################

#
# Examples from the forthcoming Monograph:
#   Rmetrics - Financial Engineering and Computational Finance
#   A Practitioner's Guide for R and SPlus Programmers
#   written by Diethelm Wuertz
#   ISBN to be published
#
# Details:
#   Examples from Chapter 7.5
#   Monte Carlo Simulations of Options 
#
# List of Examples, Exercises and Code Snippets
#
#   Example: Compute Halton low discrepancy numbers
#   Example: Compute Sobol low discrepancy numbers
#   Example: Valuate Option by Monte Carlo Simulation
#
#   *** This list is not yet complete ***
#
# Author:
#   (C) 2002-2005, Diethelm Wuertz, GPL
#     www.rmetrics.org
#     www.itp.phys.ethz.ch
#     www.finance.ch
#


################################################################################
# Low Discrepancey Sequences


### Example: Compute Halton low discrepancy numbers

    # This example calculates quasi random numbers created from
    # Halton's low discrepancy sequence. Plot the sequence, its
    # autocorrelation function and histogram. Compare the results
    # in low and high dimensions.
    ###

    # Settings:
    par(mfrow = c(3, 2), cex = 0.5)
    par(ask = TRUE)
    ###

    # Uniform Quasi Random Numbers:
    # Part 1: Calculate 20 sequences in 5 dimensions:
    runif.halton(n = 20, dimension = 5, init = TRUE)
    # Part 2a: Re-Initialize and Calculate 10 Sequences in 5 dimensions:
    runif.halton(n = 10, dimension = 5, init = TRUE)
    # Part 2b: Calculate next 10 sequences in 5 dimensions
    runif.halton(n = 10, dimension = 5, init = FALSE)
    # Extract the direction numbers from the seed:
    runif.halton.seed
    ###

    # Create uniform distributed numbers:
    x = runif.halton(n = 500, dimension = 25)
    plot(x[,1], x[,2], main = "Uniform Halton: 1 - 2")
    plot(x[,24], x[,25], main = "Uniform Halton: 24 - 25")
    # Autocorrelation:
    acf(x[ ,1], main = "Uniform Halton: d=1")
    acf(x[ ,25], main = "Uniform Halton: d=25")
    # Histogram:
    hist(x[ ,1])
    hist(x[ ,25])
    ###

    # Create normal distributed numbers:
    x = rnorm.halton(n = 500, dimension = 25)
    plot(x[,1], x[,2], main = "Normal Halton: 1 - 2")
    plot(x[,24], x[,25], main = "Normal Halton: 24 - 25")   
    # Autocorrelation:
    acf(x[ ,1], main = "Normal Halton: d=1")
    acf(x[ ,25], main = "Normal Halton: d=25")
    # Histogram:
    hist(x[ ,1])
    hist(x[ ,25])
    par(ask = FALSE)
    ###
    
    
# ------------------------------------------------------------------------------


### Example: Compute Sobol low discrepancy numbers

    # This example calculates the first 20 Sobol numbers in 5 
    # dimension. In a second step the generator is called twice, 
    # the first time with re-initialization flag set to TRUE. 
    # Print the seed and extract the direction numbers.
    ###

    # Settings:
    par(mfrow = c(3, 2), cex = 0.5)
    par(ask = TRUE)
    ###

    # Uniform Quasi Random Numbers:
    # Part 1: Calculate 20 sequences in 5 dimensions:
    runif.sobol(n = 20, dimension = 5, scrambling = 0, init = TRUE)
    # Part 2a: Re-Initialize and Calculate 10 Sequences in 5 dimensions:
    runif.sobol(n = 10, dimension = 5, scrambling = 0, init = TRUE)
    # Part 2b: Calculate next 10 sequences in 5 dimensions
    runif.sobol(n = 10, dimension = 5, scrambling = 0, init = FALSE)
    # Extract the direction numbers from the seed:
    runif.sobol.seed
    ###

    # Create uniform distributed numbers:
    x = runif.sobol(n = 500, dimension = 25, scrambling = 0)
    plot(x[,1], x[,2], main = "Uniform Sobol: 1 - 2")
    plot(x[,24], x[,25], main="Uniform Sobol: 24 - 25")
    # Autocorrelation:
    acf(x[ ,1], main = "Uniform Sobol: d=1")
    acf(x[ ,25], main = "Uniform Sobol: d=25")
    # Histogram:
    hist(x[ ,1])
    hist(x[ ,25])
    ###

    # Create normal distributed numbers: 
    x = rnorm.sobol(n = 500, dimension = 25, scrambling = 1)
    plot(x[,1], x[,2], main = "Normal Sobol: 1 - 2")
    plot(x[,24], x[,25], main = "Normal Sobol: 24 - 25")
    # Autocorrelation:
    acf(x[ ,1], main = "Normal Sobol: d=1")
    acf(x[ ,25], main = "Normal Sobol: d=25")
    # Histogram:
    hist(x[ ,1])
    hist(x[ ,25])
    par(ask = FALSE)
    ###


################################################################################
# Monte Carlo Option Pricing 


### Example: Valuate Option by Monte Carlo Simulation

    # How to perform a Monte Carlo Simulation?
    ###
    
    # First Step:   
    # Write a function to generate the option's innovations. 
    # Use scrambled normal Sobol numbers:
    sobolInnovations = function(mcSteps, pathLength, init, ...) 
    {
        # Create Normal Sobol Innovations:
        innovations = rnorm.sobol(mcSteps, pathLength, init, ...)
        # Return Value:
        innovations 
    }
    ###
    
    # Second Step: 
    # Write a function to generate the option's price paths.  
    # Use a Wiener path:
    wienerPath = function(eps) 
    {   
        # Note, the option parameters must be globally defined!
        # Generate the Paths:
        path = (b-sigma*sigma/2)*delta.t + sigma*sqrt(delta.t)*eps
        # Return Value:
        path 
    }
    ###
      
    # Third Step:   
    # Write a function for the option's payoff
    # Example 1: use the payoff for a plain Vanilla Call or Put:
    plainVanillaPayoff = function(path) 
    { 
        # Note, the option parameters must be globally defined!
        # Compute the Call/Put Payoff Value:
        ST = S*exp(sum(path))
        if (TypeFlag == "c") payoff = exp(-r*Time)*max(ST-X, 0)
        if (TypeFlag == "p") payoff = exp(-r*Time)*max(0, X-ST)
        # Return Value:
        payoff 
    }  
    # Example 2: use the payoff for an arithmetic Asian Call or Put:
    arithmeticAsianPayoff = function(path) 
    { 
        # Note, the option parameters must be globally defined!
        # Compute the Call/Put Payoff Value:
        SM = mean(S*exp(cumsum(path)))
        if (TypeFlag == "c") payoff = exp(-r*Time)*max(SM-X, 0)
        if (TypeFlag == "p") payoff = exp(-r*Time)*max(0, X-SM)
        # Return Value:
        payoff 
    }
    ###

    # Final Step:   
    # Set Global Parameters for the plain Vanilla/Arithmetic Asian Options:
    TypeFlag <<- "c"; S <<- 2; X <<- 2
    Time <<- 1/12; sigma <<- 0.5; r <<- 0.05; b <<- 0.05
    # Do the Asian Simulation with scrambled random numbers:
    # Short run:
    mc = MonteCarloOption(delta.t = 1/360, pathLength = 30, mcSteps = 1000, 
        mcLoops = 50, init = TRUE, innovations.gen = sobolInnovations, 
        path.gen = wienerPath, payoff.calc = arithmeticAsianPayoff, 
        antithetic = TRUE, standardization = FALSE, trace = TRUE, 
        scrambling = 2, seed = 4711)  
    # Plot the MC Iteration Path:
    par(mfrow = c(1, 1), cex = 0.7)
    mcPrice = cumsum(mc)/(1:length(mc))
    plot(mcPrice, type = "l", main = "Arithmetic Asian Option", 
        xlab = "Monte Carlo Loops", ylab = "Option Price")
    # Turnbull Wakeman Asian Approximation:
    TurnbullWakemanAsianApproxOption(TypeFlag = "c", S = 2, SA = 2, 
      X = 2, Time = 1/12, time = 1/12, tau = 0 , r = 0.05, b = 0.05, 
      sigma = 0.5)
    ###
    
    # A Long Run:
    if {FALSE}
    mc = MonteCarloOption(delta.t = 1/360, pathLength = 360, mcSteps = 1000, 
        mcLoops = 1000, init = TRUE, innovations.gen = sobolInnovations, 
        path.gen = wienerPath, payoff.calc = arithmeticAsianPayoff, 
        antithetic = TRUE, standardization = FALSE, trace = TRUE, 
        scrambling = 2, seed = 4711)
    # Compare with:
    # 0.24668  This Monte Carlo Run
    # 0.24979  Turnbull Wakeman Approximation
    # 0.248    Geman Eydeland
    # 0.247    Euler PDE
    # 0.247    Post-Widder PDE
    # 0.24642  Fourier Transformation
    # 0.24640  Linetzky's Approach
    ###
    
 
################################################################################

#
# Examples from the forthcoming Monograph:
#   Rmetrics - Financial Engineering and Computational Finance
#   A Practitioner's Guide for R and SPlus Programmers
#   written by Diethelm Wuertz
#   ISBN to be published
#
# Details:
#   Examples from Chapter 7.1
#   The Basics of Option Pricing
#
# List of Examples, Exercises and Code Snippets
#      
#   * Example: Plot Profit/Loss versus Asset Price Graphs  
#   * Example: Generalized Black-Scholes Option Prices
#   * Example: Plots 2-D Graphs of GBS Option Prices
#   * Example: Plots 3-D Graphs of GBS Option Prices
#   * Example: Generalized Black-Scholes Option Sensitivities
#   * Example: Plots 2-D Graphs of GBS Option Sensitivities
#   * Example: Plots 3-D Graphs of GBS Option Sensitivities
#   * Example: Americam Calls on Dividend Paying Stocks
#   * Example: Barone-Adesi and Whaley Approximation
#   * Example: Bjerksund and Stensland Approximation
#   * Example: Binomial Tree Option Model
#   * Example: Trinomial Tree Option Model  
#
#   *** This list is not yet complete ***
#
# Author:
#   (C) 2002-2005, Diethelm Wuertz, GPL
#     www.rmetrics.org
#     www.itp.phys.ethz.ch
#     www.finance.ch
#


################################################################################
# Generalized Black Scholes Options


### Example: Plot Profit/Loss versus Asset Price Graphs

    # Plot graphs displaying the profit/loss versus the
    # asset price for the following four situations:
    # Buying a call, writing a call, buying a put, and
    # writing a put.

    # Buying a Call:
    par(mfrow = c(3, 2))
    plot(x = c(50, 150), y = c(0, 0), xlim = c(50, 150), ylim = c(-16, 16), 
        type = "l", main = "Buying a Call", xlab = "Asset Price", 
        ylab = " Loss / Profit")
    lines(x = c(50, 100), y = c(-8, -8))
    lines(x = c(100, 130), y = c(-8, 14))

    # Writing a Call:
    plot(x = c(50, 150), y = c(0, 0), xlim = c(50, 150), ylim = c(-16, 16), 
        type = "l", main = "Writing a Call", xlab = "Asset Price", 
        ylab = " Loss / Profit")
    lines(x = c(50, 100), y = c(8, 8))
    lines(x = c(100, 130), y = c(8, -14))

    # Buying a Put:
    plot(x = c(50, 150), y = c(0, 0), xlim = c(50, 150), ylim = c(-16, 16), 
        type = "l", main = "Buying a Put", xlab = "Asset Price", 
        ylab = " Loss / Profit")
    lines(x = c(100, 150), y = c(-8, -8))
    lines(x = c(70, 100), y = c(14, -8))
    
    # Writing a Put:
    plot(x = c(50, 150), y = c(0, 0), xlim = c(50, 150), ylim = c(-16, 16), 
        type = "l", main = "Writing a Put", xlab = "Asset Price", 
        ylab = " Loss / Profit")
    lines(x = c(100, 150), y = c(8, 8))
    lines(x = c(70, 100), y = c(-14, 8))


# ------------------------------------------------------------------------------


### Example: Calculate the option prices for

    # 1) an European Options on a Stock with Cash Dividends,
    # 2) an Option on Stock Indexes,
    # 3) an Option on Futures, and
    # 4) a Currency Option.

    # European Option on a Stock with Cash Dividends:
    S = 100 - 2*exp(-0.10*0.25) - 2*exp(-0.10*0.50)
    r = 0.10
    GBSOption("c", S = S, X = 90, Time = 0.75, r = r, b = r, 
        sigma = 0.25) 
    
    # Option on Stock Indexes:
    r = 0.10
    q = 0.05
    GBSOption("p", S = 100, X = 95, Time = 0.5, r = r, b = r-q, 
        sigma = 0.20) 

    # Option on Futures:
    FuturesPrice = 19
    b = 0
    GBSOption("c", S = FuturesPrice, X = 19, Time = 0.75, r = 0.1, 
        b = b, sigma = 0.28) 
    GBSOption("p", S = FuturesPrice, X = 19, Time = 0.75, r = 0.1, 
        b = b, sigma = 0.28) 
    
    # Currency Option:
    r = 0.06
    rf = 0.08
    GBSOption("c", S = 1.56, X = 1.60, Time = 0.5, r = r, b = r-rf, 
        sigma = 0.12) 


# ------------------------------------------------------------------------------


### Example: Plot the scaled Price of a Generalized Black Scholes Call
    
    #   Use the function GBSoption()} to plot the scaled call
    #   price c/X
    #   1) as a function of S/X, the scaled asset price (note
    #          doubling the asset price and strike price yields the
    #      same option values), use as parameter sigma^2 T for
    #      a low and a high interest rate r,
    #   2) as a function of $\sigma^2 T$, the volatility and
    #      Time to maturity (note doubling the volatility and
    #      decreasing the time to maturity by a factor of four 
    #      yields the same option values), use as parameter S/X 
    #      for a low and a high interest rate $r$.:
    ###
    
    # BS Call Prices as a Function of S/X:  
    par(mfrow = c(2, 2), cex = 0.7)
    # Figure 1:
    S = seq(from = 0.4, to = 1.2, by = 0.05)
    plot(S, S, ylim = c(0, 0.5), type = "n", 
         main = "r=0.01", xlab = "S/X", ylab = "c/X")
    for (Time in seq(from = 1/12, to = 2, by = 1/12)) {
        c = GBSOption("c", S = S, X = 1, Time = Time, r = 0.01, 
            b = 0.01, sigma = 0.4)$price
        col = "steelblue3"; if (Time == 1) col = "red"
        lines (S, c, col = col) }       
    # Figure 2:
    S = seq(from = 0.4, to = 1.2, by = 0.05)
    plot(S, S, ylim = c(0, 0.5), type = "n", 
        main = "r=0.10", xlab = "S/X", ylab = "c/X")
    for (Time in seq(from = 1/12, to = 2, by = 1/12)) {
        c = GBSOption("c", S = S, X = 1, Time = Time, r = 0.10, 
            b = 0.10, sigma = 0.4)$price
        col = "steelblue3"; if (Time == 1) col = "red"
        lines (S, c, col = col) }
                           
    # BS Call Prices as a Function of Time to Maturity: 
    # Figure 3:
    Time = seq(from = 1/12, to = 2, by = 1/12)
    plot(Time, Time, ylim = c(0, 0.5), type = "n", 
        main = "r=0.01", xlab = "Time", ylab = "c/X")
    for (S in seq(from = 0.4, to = 1.2, by = 0.05)) {
        c = GBSOption("c", S = S, X = 1, Time = Time, r = 0.01, 
            b = 0.01, sigma = 0.4)$price
        col = "steelblue3"; if (S == 1) col = "red"
        lines (Time, c, col = col) }        
    # Figure 4:
    Time = seq(from = 1/12, to = 2, by = 1/12)
    plot(Time, Time, ylim = c(0, 0.5), type = "n", 
        main = "r=0.10", xlab = "Time", ylab = "c/X")
    for (S in seq(from=0.4, to=1.2, by=0.05)) {
        c = GBSOption("c", S = S, X = 1, Time = Time, r = 0.10, 
            b = 0.10, sigma = 0.4)$price
        col = "steelblue3"; if (S == 1) col = "red" 
        lines (Time, c, col = col) }


# ------------------------------------------------------------------------------


### Example: Perspective plot of GBS Call and Put Prices 

    # Write the perspective plot function:
    GBSOption3DPlot = 
    function (TypeFlag = c("c", "p"), S, X, Time, r, b, sigma, theta = 30, 
    phi = 30, expand = 0.75, col = "lightblue", ltheta = 120, shade = 0.75, 
    ticktype = "detailed", cex = 0.6, main = "GBS Option Price", ...)
    {   # A function written by Diethelm Wuertz
         
        # Description:
        #   Plot the premium values for a Generalized Black-Scholes 
        #   option either for a call or a put option.
        
        # References:
        #   Haug E.G., The Complete Guide to Option Pricing Formulas
        
        # FUNCTION:
        
        # Plotting Premium - 3D: 
        # x=S, y=Time, z=Premium  
        TypeFlag = TypeFlag[1] 
        premium3D = function(S, Time, TypeFlag, X, r, b, sigma) {
            GBSOption(TypeFlag, S, X, Time, r, b, sigma)$price }
        
        # Prices:
        Price = outer(S, Time, FUN=premium3D, TypeFlag, X, r, b, sigma)
        
        # Perspective Plot:
        persp(x=S, y=Time, z=Price, xlab="S", ylab="Time", zlab=TypeFlag, 
            theta=theta, phi=phi, expand=expand, col=col, ltheta=ltheta,
            shade=shade, ticktype=ticktype, cex=cex, main=main, ...) 
        
        # Return Value:
        invisible(list(S = S, Time = Time, Price = Price))  
    }


    # BS Call - Plot3D Premium: 
    par(mfrow = c(2, 1), cex = 1/3)
    GBSOption3DPlot("c", S = seq(from = 75, to = 125, 
        length = 40), X = 100, Time = seq(from = 1/52, to = 1, 
        length = 40), r = 0.1, b = 0.1, sigma = 0.4)    
        
    # BS Put - Plot3D Premium:
    GBSOption3DPlot("p", S = seq(from = 75, to = 125, 
        length = 40), X = 100, Time = seq(from = 1/52, to = 1, 
            length = 40), r = 0.1, b = 0.1, sigma = 0.4)


# ------------------------------------------------------------------------------


### Example: Calculate the sensitivities for some selected options

    # Delta - Haug [1997], Chapter 1.3.1:
    GBSGreeks("Delta", "c", S = 105, X = 100, Time = 0.5, r = 0.1, 
        b = 0, sigma = 0.36)
    GBSGreeks("Delta", "p", S = 105, X = 100, Time = 0.5, r = 0.1, 
        b = 0, sigma = 0.36)  
    
    # Theta - Haug [1997], Chapter 1.3.5:
    GBSGreeks("Theta", "p", S = 430, X = 405, Time = 1/12, r = 0.07, 
        b = 0.07-0.05, sigma = 0.20)
    GBSGreeks("Theta", "p", S = 430, X = 405, Time = 1/365, r = 0.07, 
        b = 0.07-0.05, sigma = 0.20)

    # Vega - Haug [1997], Chapter 1.3.4:
    GBSGreeks("Vega", "c", S = 55, X = 60, Time = 0.75, r = 0.10, 
        b = 0.10, sigma = 0.30)

    # Rho - Haug [1997], Chapter 1.3.6:
    GBSGreeks("Rho", "c", S = 72, X = 75, Time = 1, r = 0.09, 
        b = 0.09, sigma = 0.19)

    # Lambda - Haug [1997], Chapter 1.3.2:
    GBSGreeks("Lambda", "p", S = 105, X = 100, Time = 0.5, r = 0.1, 
        b = 0, sigma = 0.36) 

    # Gamma - Haug [1997], Chapter 1.3.3:
    GBSGreeks("Gamma", "c", S = 55, X = 60, Time = 0.75, r = 0.10, 
        b = 0.10, sigma = 0.30)

        
# ------------------------------------------------------------------------------


### Example: Investigate Premium and Sensitivities of a Currency Option

    #   As a simple illustration of how the Greeks can be used consider
    #   someone holding an at-the-money currency call on USD put on DEM
    #   with the following characteristics: underlying price 1.7000,
    #   strike price 1.700$, time to maturity 270 days, DEM (domestic)
    #   interest rate 6% p.a., USD (foreign) interest rate 3% p.a.,
    #   and volatility 10% p.a.. Calculate the option value and the
    #   sensitivities for these parameters and then plot the sensitivities 
    #   in the range between 1.4000 and 2.0000 for times to maturity of 
    #   1, 30, 90, and 270 days to get an overview about the whole range 
    #   of prices of the underlying.
    #   Suppose after one week the underlying price were to rise to
    #   1.7500 DEM, interest rates were to fall 1%, and volatility
    #   were to rise 2%. what effect would this combination have on the
    #   price of the option? Analyze the separate impacts, and calculate 
    #   the combined effect to the option rise. 
    ###
    
    # Characterisitics of the BS Option:
    GBSCharacteristics("c", S = 1.7000, X = 1.7000, 
        Time = 270/365, r = 0.06, b = 0.06-0.03, sigma = 0.10)

    # Plot Greeks:
    par(mfrow = c(2, 2), cex = 0.7)
    S = seq(from = 1.4000, to = 2.0000, length = 250)
    Selection = c("Delta", "Theta", "Vega", "Rho")
    PlotYmin  = c(    0.0,    -0.6,   0.0,    0.0)
    PlotYmax  = c(    1.0,     0.0,   0.6,    1.2)
    for (i in 1:4){
        plot(S, S, ylim = c(PlotYmin[i], PlotYmax[i]), type = "n", 
             xlab = "S", ylab = Selection[i], main = Selection[i])
        for (Days in c(1, 30, 90, 270)) {
            greek = GBSGreeks(Selection[i], "c", S = S, X = 1.7000, 
                Time = Days/365, r = 0.06, b = 0.06-0.03, sigma = 0.1)
            lines (S, greek) } }

    # Analyzing the Separate Impacts:
    Characteristics = 
        GBSCharacteristics("c", S = 1.7000, X = 1.7000, 
        Time = 270/365, r = 0.06, b = 0.06-0.03, sigma = 0.10)
    Changes = list (
        DueToPrice = (1.7500 - 1.7000) * Characteristics$delta,
        DueToTime = 7/365 * Characteristics$theta,
        DueToVolatility = (0.12 - 0.10) * Characteristics$vega,
        DueToInterest = (0.05 - 0.06) * Characteristics$rho)
    print(Changes)
    TotalChange = Changes$DueToPrice + Changes$DueToTime + 
        Changes$DueToVolatility + Changes$DueToInterest
    print(TotalChange)
    OldPremium = Characteristics$premium
    print(OldPremium)
    NewPremium = GBSOption("c", S = 1.7500, X = 1.7000, 
        Time = 263/365, r = 0.05, b = 0.05-0.03, sigma = 0.12)$price
    print(NewPremium)
    RealTotalChange = NewPremium - OldPremium
    print(RealTotalChange)  

 
# ------------------------------------------------------------------------------


# Example: Perspective plot of GBS Greeks for Call and Put Prices 

    #   Plot the sensitivities Delta, Theta, Vega, Rho, Lambda and 
    #   Gamma as a function of the scaled asset price S/X and the 
    #   time-scaled volatility sigma^2 T. 
    ###
    
    # Write the perspective plot function:
    GBSGreeks3DPlot = 
    function (Selection = c("Delta", "Theta", "Vega", "Rho", "Lambda", "Gamma",
    "CofC"), TypeFlag = c("c", "p"), S, X, Time, r, b, sigma, theta = 30, 
    phi = 30, expand = 0.75, col = "lightblue", ltheta = 120, shade = 0.75, 
    ticktype = "detailed", cex = 0.6, main = "GBS Option Sensitivity", ...)
    {   # A function written by Diethelm Wuertz
         
        # Description:
        #   Plot the Greeks for a Generalized Black-Scholes 
        #   option either for a call or a put option.
        
        # References:
        #   Haug E.G., The Complete Guide to Option Pricing Formulas
        
        # FUNCTION:
        
        # Plotting Greeks - 3D: 
        # x = S, y = Time, z = Greek    
        
        # Selection:
        # "delta", "theta", "vega", "rho", "lambda", "gamma", "cofc"
        greeks3D = function(S, Time, Selection, TypeFlag, X, r, b, sigma) 
            { GBSGreeks(Selection, TypeFlag, S, X, Time, r, b, sigma)}
        
        # Sensitivities:
        Greeks = outer(S, Time, FUN=greeks3D, Selection, TypeFlag, X, 
            r, b, sigma)
        
        # Perspective Plot:
        persp(x=S, y=Time, z=Greeks, xlab="S", ylab="Time", zlab=Selection, 
            theta=theta, phi=phi, expand=expand, col=col, ltheta=ltheta,
            shade=shade, ticktype=ticktype, cex=cex, main=main, ...) 
        
        # Return Value:
        invisible(list(S = S, Time = Time, Sensitivity = Greeks))
    }


    # BS - Plot3D Greeks:
    
    # pdf(file = "xmpGBSgreeks3D.pdf", width = 7, height = 9)
    par(mfrow = c(3, 2), cex = 1/3)
    for (Selection in c("delta", "theta", "vega", "rho", "lambda", "gamma"))
        GBSGreeks3DPlot(Selection, "c", 
            S = seq(from = 75, to = 125, length = 25), X = 100,
            Time = seq(from = 1/52, to = 1, length = 25), r = 0.1, 
            b = 0.1, sigma = 0.40)
    # dev.off()

  
################################################################################
# Approximations for American Options


### Example: Price American Stock Options with Known Dividends
     
    #   American Calls on stocks paying a single dividend can 
    #   be priced by the Roll-Geske-Whaley formula.
    #   Consider an American-style call option on a stock that
    #   will pay a dividend of $4$ in exactly three months. The 
    #   stock price is $80$, the strike price is $82$, time to 
    #   maturity is 4 months, the risk-free interest rate is 6%, 
    #   and the volatility is 30%. Note, that the result will 
    #   be 4.3860, whereas the value of a similar European call 
    #   would be $3.5107. What happens when no dividends are 
    #   paid, D=0?
    
    # American Stock Options with known Dividends:
    RollGeskeWhaleyOption(S = 80, X = 82, time1 = 1/4, Time2 = 1/3, 
        r = 0.06, D = 4, sigma = 0.30)
    
    # What happens when D=0?    
    RollGeskeWhaleyOption(S = 80, X = 82, time1 = 1/4, Time2 = 1/3, 
        r = 0.06, D = 0, sigma = 0.30)

        
# ------------------------------------------------------------------------------


### Example: Price American Options Using the BAW Approximation
    
    #   The quadratic approximation method by Barone-Adesi and
    #   Whaley can be used to price American call and put options 
    #   on an underlying asset with cost-of-carry rate b.
    #
    #   Compare option values of the BAW approximation with the 
    #   Black-76 formula, European style. 
    #
    #   Choose r=0.1, b=0, and X=100 with volatilities sigma of 
    #   15%, 25%, and 35%, and prices taking values S of 90, 100, 
    #   and 110 for two time periods, Time=0.1 and Time=0.5, 
    #   respectively.
    ###
    
    # American Calls:
    FuturesPrice = rep(c(90,90,90, 100,100,100, 110,110,110), times = 2)
    Time = c(rep(0.1, times = 9), rep(0.5, times = 9))
    Sigma = rep(c(0.15, 0.25, 0.35), times=6)
    CallPrice = PutPrice = rep(0, times=18)
    for (i in 1:18) {
        CallPrice[i] = BAWAmericanApproxOption("c", S = FuturesPrice[i], 
            X = 100, Time = Time[i], r = 0.1, b = 0, sigma = Sigma[i]) 
        PutPrice[i] = BAWAmericanApproxOption("p", S = FuturesPrice[i], 
            X = 100, Time = Time[i], r = 0.1, b = 0, sigma = Sigma[i]) }        
    cbind(FuturesPrice, Time, Sigma, CallPrice, PutPrice)
   
    # Compare with Black76Option:
    CallPrice = PutPrice = rep(0, times = 18)
    for (i in 1:18) {
        CallPrice[i] = Black76Option("c", FT = FuturesPrice[i], 
            X = 100, Time = Time[i], r = 0.1, sigma = Sigma[i])$price
        PutPrice[i] = Black76Option("p", FT=FuturesPrice[i], 
            X = 100, Time = Time[i], r = 0.1, sigma = Sigma[i])$price }     
    cbind(FuturesPrice, Time, Sigma, CallPrice, PutPrice)   
    
    
# ------------------------------------------------------------------------------


### Example: Price American Options Using the BS Approximation

    #   The Bjerksund and Stensland approximation an be used to
    #   price American Options on stocks, futures and currencies. 
    #   Consider a call option with nine months to expiry. The
    #   stock price is 42, the strike price is 40, the risk free 
    #   rate is 4% p.a., the dividend yield is 8% p.a., the volatility 
    #   is 35% p.a..
    ###

    # Price American Options using the BS Approximation:
    BSAmericanApproxOption("c", S = 42, X = 40, Time = 0.75, r = 0.04, 
        b = 0.04-0.08, sigma = 0.35)

    # Compare with a similar European Call:
    GBSOption("c", S = 42, X = 40, Time = 0.75, r = 0.04, 
        b = 0.04-0.08, sigma = 0.35)
    
        
################################################################################
# Option Trees


### Example: Binomial Tree Option
     
    # Reference:
    #   J.C. Hull [1996], Chapter 16
    #   E.G. Haug [1997], Chapter 1.3, page 11-16
    #   Leisen D.P., Reimer M., [1996] 
    ###

    # Cox-Ross-Rubinstein Binomial Tree Option Model:
    # Example 14.1 from Hull's Book:
    CRRBinomialTreeOption(TypeFlag = "pa", S = 50, X = 50, 
        Time = 5/12, r = 0.1, b = 0.1, sigma = 0.4, n = 5)
    # Example 3.1.1 from Haug's Book:
    CRRBinomialTreeOption(TypeFlag = "pa", S = 100, X = 95, 
        Time = 0.5, r = 0.08, b = 0.08, sigma = 0.3, n = 5)
    # A European Call - Compare with Black Scholes: 
    CRRBinomialTreeOption(TypeFlag = "ce", S = 100, X = 100, 
        Time = 1, r = 0.1, b = 0.1, sigma = 0.25, n = 50)
    GBSOption(TypeFlag = "c", S = 100, X = 100, 
        Time = 1, r = 0.1, b = 0.1, sigma = 0.25)$price 
         
    # CRR - JR - TIAN Model Comparison
    # Hull's Example as Function of "n":
    par(mfrow = c(2, 1), cex = 0.7)
    steps = 50
    CRROptionValue =  JROptionValue = TIANOptionValue = 
        rep(NA, times = steps)
    for (n in 3:steps) { 
        CRROptionValue[n] = CRRBinomialTreeOption(TypeFlag = "pa", S = 50, 
            X = 50, Time = 0.4167, r = 0.1, b = 0.1, sigma = 0.4, n = n)
        JROptionValue[n] = JRBinomialTreeOption(TypeFlag = "pa", S = 50, 
            X = 50, Time = 0.4167, r = 0.1, b = 0.1, sigma = 0.4, n = n)    
        TIANOptionValue[n] = TIANBinomialTreeOption(TypeFlag = "pa", S = 50, 
            X = 50, Time = 0.4167, r = 0.1, b = 0.1, sigma = 0.4, n = n) }          
    plot(CRROptionValue[3:steps], type = "l", col = "red", 
        ylab = "Option Value")
    lines(JROptionValue[3:steps], col = "green")
    lines(TIANOptionValue[3:steps], col = "blue")
    # Add Result from BAW Approximation:
    BAWValue =  BAWAmericanApproxOption(TypeFlag = "p", S = 50, X = 50, 
        Time = 0.4167, r = 0.1, b = 0.1, sigma = 0.4)
    abline(h = BAWValue, lty = 3)
    title(main = "Convergence")
    data.frame(CRROptionValue, JROptionValue, TIANOptionValue)
  
    
    # Plot CRR Option Tree:
    # Again Hull's Example:
    CRRTree = BinomialTreeOption(TypeFlag = "pa", S = 50, X = 50, 
        Time = 0.4167, r = 0.1, b = 0.1, sigma = 0.4, n = 5)
    BinomialTreePlot(CRRTree, dy = 1, cex = 0.8, ylim = c(-6, 7),
        xlab = "n", ylab = "Option Value")
    title(main = "Option Tree")

# ------------------------------------------------------------------------------


# Exercise: Trinomial Tree

    #   Write a function to compute the call and put price of an 
    #   European or American style option using a trinomial tree
    #   approach.

    TrinomialTreeOption  = 
    function(AmeEurFlag, CallPutFlag, S, X, Time, r, b, sigma, n)
    {   # A function implemented by Diethelm Wuertz           
         
        # Description:
        #   Calculates option prices from the Trinomial tree model.
         
        # Arguments:
        #   AmeEurFlag - a character value, either "a" or "e" for 
        #       a European or American style option
        #   CallPutFlag - a character value, either "c" or "p" for 
        #       a call or put option
        #   S, X, Time, r, b, sigma - the usual option parameters
        #   n - an integer value, the depth of the tree
         
        # Value:
        #   Returns the price of the options.
     
        # Details:
        #   Trinomial trees in option pricing are similar to
        #   binomial trees. Trinomial trees can be used to 
        #   price both European and American options on a single 
        #   underlying asset.
        #   Because the asset price can move in three directions 
        #   from a given node, compared with only two in a binomial
        #   tree, the number of time steps can be reduced to attain
        #   the same accuracy as in the binomial tree. 
     
        # Reference:
        #   E.G Haug, The Complete Guide to Option Pricing Formulas
        #   Chapter 3.2
    
        # FUNCTION:
        
        # Settings:            
        OptionValue  =  rep(0, times=2*n+1)  
        
        # Call-Put Flag:
        if (CallPutFlag == "c") z  =  +1 
        if (CallPutFlag == "p") z  =  -1  
        
        # Time Interval: 
        dt  =  Time/n
        
        # Up-and-down jump sizes:
        u  =  exp(+sigma * sqrt(2*dt))
        d  =  exp(-sigma * sqrt(2*dt)) 
        
        # Probabilities of going up and down:  
        pu  =  ((exp(b * dt/2) - exp( -sigma * sqrt(dt/2))) / 
               (exp(sigma * sqrt(dt/2)) - exp(-sigma * sqrt(dt/2)))) ^ 2
        pd  =  (( exp(sigma * sqrt(dt/2)) - exp( b * dt/2)) / 
            (exp(sigma * sqrt(dt/2)) - exp(-sigma * sqrt(dt/2)))) ^ 2
            
        # Probability of staying at the same asset price level:
        pm  =  1 - pu - pd
        Df  =  exp(-r*dt)   
        for (i in 0:(2*n)) {
            OptionValue[i+1]  =  max(0, z*(S*u^max(i-n, 0) * 
                d^max(n*2-n-i, 0) - X))}
        for (j in (n-1):0) {
            for (i in 0:(j*2)) {
                # European Type:
                if (AmeEurFlag == "e") {
                    OptionValue[i+1]  =  (
                        pu * OptionValue[i+3] + 
                        pm * OptionValue[i+2] + 
                        pd * OptionValue[i+1]) * Df }
                # American Type:
                if (AmeEurFlag == "a") {
                    OptionValue[i+1]  =  max((z*(S*u^max(i-j, 0) * 
                        d ^ max(j*2-j-i, 0) - X)), (
                        pu * OptionValue[i+3] + 
                        pm * OptionValue[i+2] + 
                        pd * OptionValue[i+1]) * Df) } } }
        TrinomialTree  =  OptionValue[1]
        
        # Return Value:
        TrinomialTree
    }

    # Example:  
    TrinomialTreeOption(AmeEurFlag = "a", CallPutFlag = "p", S = 100, 
        X = 110, Time = 0.5, r = 0.1, b = 0.1, sigma = 0.27, n = 30)


################################################################################    
        

#
# Examples from the forthcoming Monograph:
# 	Rmetrics - Financial Engineering and Computational Finance
#   A Practitioner's Guide for R and SPlus Programmers
#   written by Diethelm Wuertz
#   ISBN to be published
#
# Details:
#   Examples from Chapter 7.3
#   Exponential Brownian Motion 
#
# List of Examples, Exercises and Code Snippets
#
#   *** This list is not yet complete ***
#
# Author:
#	(C) 2002-2005, Diethelm Wuertz, GPL
# 	  www.rmetrics.org
# 	  www.itp.phys.ethz.ch
# 	  www.finance.ch
#


################################################################################


# xmpEBMTables        Tables from Continuous Sampled Options by Wuertz
# xmpEBMFigures       Figures from Continuous Sampled Options by Wuertz
# xmpEBMExamples      Examples from Continuous Sampled Options by Wuertz



################################################################################
# Tables:


### Example: Table 1 - Moment Matched Asian Option Prices
    
    # Take the same parameter settings as used in Zhang's Table
    Zhang = ZhangTable()
    options(digits = 4)
    Zhang
    ###
    
    # Calculate entries for Table 1:
    CallRST = BoundsOnAsianOption(table = Zhang, method = "RST")$price
    CallLN  = MomentMatchedAsianOption(table = Zhang, method = "LN")$price 
    CallRG  = MomentMatchedAsianOption(table = Zhang, method = "RG")$price
    CallJI  = MomentMatchedAsianOption(table = Zhang, method = "JI")$price
    CallT   = BoundsOnAsianOption(table = Zhang, method = "T")$price            
    CallZ   = ZhangTable()[,6]
    ###
    
    # Print Call Option Values: 
    Table.1 = data.frame(cbind(Zhang[, 1:5], 
        CallRST, CallLN, CallRG, CallJI, CallT, CallZ))
    Table.1
    ###
    
    # Save Table.1 and beautify Spreadsheet file:
    # write.table(Table.1, "TableApprox.csv", sep=";")
    ###
    
    # Compute Inside Bounds:
    inside = c(
        LN = sum((CallRST < CallLN)+ (CallLN < CallT) == 2),
        RG = sum((CallRST < CallRG)+ (CallRG < CallT) == 2),
        JI = sum((CallRST < CallJI)+ (CallJI < CallT) == 2))
    inside
    ###

    
# ------------------------------------------------------------------------------


### Example: Table 2 - Gram Charlier Moment Matched Asian Option Prices
    
    # Take the same parameter settings as used in Zhang's Table
    Zhang = ZhangTable()
    options(digits = 4)
    Zhang
    ###
    
    # Calculate entries for Table 1:
    CallRST = BoundsOnAsianOption(table = Zhang, method = "RST")$price
    CallLN  = GramCharlierAsianOption(table = Zhang, method = "LN")$price 
    CallRG  = GramCharlierAsianOption(table = Zhang, method = "RG")$price
    CallJI  = GramCharlierAsianOption(table = Zhang, method = "JI")$price
    CallT   = BoundsOnAsianOption(table = Zhang, method = "T")$price            
    CallZ   = ZhangTable()[,6]
    ###
    
    # Print Call Option Values: 
    Table.2 = data.frame(cbind(Zhang[, 1:5], 
        CallRST, CallLN, CallRG, CallJI, CallT, CallZ))
    Table.2
    ###
    
    # Save Table.2 and beautify Spreadsheet file:
    # write.table(Table.2, "TableApprox.csv", sep=";")
    ###
    
    # Compute Inside Bounds:
    inside = c(
        LN = sum((CallRST < CallLN) + (CallLN < CallT) == 2),
        RG = sum((CallRST < CallRG) + (CallRG < CallT) == 2),
        JI = sum((CallRST < CallJI) + (CallJI < CallT) == 2))
    inside
    ###
    

################################################################################
# Figures


### Example: Create Figure 1  

    # Chart Asian call price deviations by Moment Matching - Create 3 x 3 Graph
    # Investigate the deviations from a reference line which is the mean
    # of the lower and upper price bounds.
	###
   
    # Create Table Function:
    createTable = 
    function(S, X, Time, r, sigma) 
    {
        CallRST = BoundsOnAsianOption(
            TypeFlag = "c", S, X, Time, r, sigma, method = "RST")$price 
        CallLN = MomentMatchedAsianOption(
            TypeFlag = "c", S, X, Time, r, sigma, method = "LN")$price 
        CallRG = MomentMatchedAsianOption(
            TypeFlag = "c", S, X, Time, r, sigma, method = "RG")$price  
        CallJI = MomentMatchedAsianOption(
            TypeFlag = "c", S, X, Time, r, sigma, method = "JI")$price 
        CallT = BoundsOnAsianOption(
            TypeFlag = "c", S, X, Time, r, sigma, method = "T")$price
        data.frame(cbind(S, X, Time, r, sigma, 
            CallRST, CallLN, CallRG, CallJI, CallT)) 
    }  
    ###
   
    # Create Plot Function:
    createPlot = 
    function(Table, x, ylim, xlab, main) 
    {
        RefLine = ( Table[,6] + Table[,10] ) / 2 
        plot(x = x, y = 100*(Table[,6]/RefLine - 1), type = "l", ylim = ylim, 
            xlab = xlab, ylab = "Call Price - % Deviation", main = main, 
            cex.main = 1)
        col = c(2, 3, 4, 1)
        lty = c(2, 3, 4, 1) # dashed - dotted - dashdotted - solid
        for (i in 7:10) {
            lines(x = x, y = 100*(Table[,i]/RefLine - 1), 
                col = col[i-6], lty = lty[i-6])
        }
    } 
    ### 
        
    # Create Tables: 
    options(digits = 9)
    V = rep(1, times = 40)
    # Calculate First Row Tables:
    r = seq(0.01, 0.10, length=length(V))
    Table11 = createTable(
        S = 100*V, X = 100*V, Time = V, r = r, sigma = 0.02*V)
    r = seq(0.01, 0.20, length = length(V))
    Table12 = createTable(
        S = 100*V, X = 100*V, Time = V, r = r, sigma = 0.20*V)
    r = seq(0.001, 0.20, length = length(V))
    Table13 = createTable(
        S = 100*V, X = 100*V, Time = V, r = r, sigma = 2.00*V)
    # Calculate Second Row Tables:
    X = seq(80, 120, length=length(V))
    Table21 = createTable(
        S = 100*V, X = X, Time = V, r = 0.05*V, sigma = V)
    Table22 = createTable(
        S = 100*V, X = X, Time = V, r = 0.09*V, sigma = 0.30*V)
    Table23 = createTable(
        S = 100*V, X = X, Time = V, r = 0.15*V, sigma = 0.10*V)
    # Calculate Third Row Tables:
    sigma = seq(0.05, 1.50, length=length(V))
    Table31 = createTable(
        S = 100*V, X = 80*V, Time = V, r = 0.09*V, sigma = sigma)
    Table32 = createTable(
        S = 100*V, X = 100*V, Time = V, r = 0.09*V, sigma = sigma)
    Table33 = createTable(
        S = 100*V, X = 120*V, Time = V, r = 0.09*V, sigma = sigma)
    ###
        
    # Create Plots:
    par(mfrow = c(4, 3), cex = 0.7)
    # First Row Plots:
    createPlot(Table = Table11, x = 2*Table11[,4]/0.05^2-1, 
        ylim = c(-0.05, 0.05), 
        xlab = expression(paste("Interest:  ", 2 * r / sigma^2 - 1)),
        main = expression(paste(sigma^2 * T / 4 == 10^{-4}, "   ", X / S == 1))) 
    createPlot(Table = Table12, x = 2*Table12[,4]/0.30^2-1, 
        ylim = c(-0.50, 0.50), 
        xlab = expression(paste("Interest:  ", 2 * r / sigma^2 - 1)),
        main = expression(paste(sigma^2 * T / 4 == 0.01, "    ", X / S == 1)))  
    createPlot(Table = Table13, x = 2*Table13[,4]/1.00^2-1, 
        ylim = c(-50.0, 50.0), 
        xlab = expression(paste("Interest:  ", 2 * r / sigma^2 - 1)),
        main = expression(paste(sigma^2 * T /4 == 1, "     ", X / S == 1)))
    # Second Row Plots: 
    createPlot(Table = Table21, x = Table21[,2]/Table21[,1], 
        ylim = c(-10.0, 5.0), 
        xlab = expression(paste("Strike:  ", X / S)),
        main = expression(paste(rT == 0.05, "      ", sigma^2 * T == 1))) 
    createPlot(Table = Table22, x = Table22[,2]/Table22[,1], 
        ylim = c(-2.0, 1.0), 
        xlab = expression(paste("Strike:  ", X / S)),
        main = expression(paste(rT == 0.09, "      ", sigma^2 * T  == 0.09)))   
    createPlot(Table = Table23, x = Table23[,2]/Table23[,1], 
        ylim = c(-10.0, 5.0), 
        xlab = expression(paste("Strike:  ", X / S)),
        main = expression(paste(rT == 0.15, "      ", sigma^2 * T == 0.01)))
    ## Third Row Plots: 
    createPlot(Table = Table31, x = Table31[,5], 
        ylim = c(-15.0, 15.0), 
        xlab = expression(paste("Volatility:  ", sigma^2 * T / 4)), 
        main = expression(paste(X / S == 0.8, "      ", rT == 0.09)))
    createPlot(Table = Table32, x = Table32[,5], 
        ylim = c(-15.0, 15.0), 
        xlab = expression(paste("Volatility:  ", sigma^2 * T / 4)),  
        main = expression(paste(X / S == 1.0, "      ", rT == 0.09)))
    createPlot(Table = Table33, x = Table33[,5], 
        ylim = c(-15.0, 15.0),
        xlab = expression(paste("Volatility:  ", sigma^2 * T / 4)),
        main = expression(paste(X / S == 1.2, "      ", rT == 0.09)))
    ###
    

# ------------------------------------------------------------------------------


### Example: Create Figure 2:

    # Calculate state price density of Asian options in the log-Normal,
    # reciprocal-Gamma and Johnson Type-I approximations
    ###
    
    # Create Density Plots
    par(mfrow = c(2, 2), cex = 0.7)
    Time = 1; r = 0.045; sigma = 0.30
    nu = 2*r / sigma^2 -1
    tau = sigma^2 * Time / 4
    x = seq(0.4, 2.8, length = 100) 
    ###
       
    ## Calculate Densities and Normalize with tau:
    d1 = MomentMatchedAsianDensity(x, Time, r, sigma, method = "LN") / tau
    d2 = MomentMatchedAsianDensity(x, Time, r, sigma, method = "RG") / tau
    d3 = MomentMatchedAsianDensity(x, Time, r, sigma, method = "JI") / tau
    ### 
           
    # Make a Linear Density Plot:
    plot(x, d2, type = "l", 
        ylab = "Density", main = "Moment Matched Densities")  
    lines(x, d1, col = "red", lty = 2)
    lines(x, d2, col = "green", lty = 3)
    lines(x, d3, col = "blue", lty = 4)
    ###
       
    ## Make a Log-Log Density Plot:
    plot(log(x), log(d2), type = "l", 
        ylab = "log(Density)", main = "Moment Matched Densities")  
    lines(log(x), log(d1), col = "red", lty = 2)
    lines(log(x), log(d2), col = "green", lty = 3)
    lines(log(x), log(d3), col = "blue", lty = 4)
    ###
    
    
# ------------------------------------------------------------------------------


### Example: Create Figure 3:

    # Calculate moment matched Asian call prices 
    # using Gram-Charlier's Series Expansion
    ###
    
    # Create Gram-Charlier Table Function:
    createTableGC = 
    function(S, X, Time, r, sigma) {
      CallRST = BoundsOnAsianOption(TypeFlag = "c", S = S, X = X, 
        Time = Time, r = r, sigma = sigma, method = "RST")$price 
      CallLN = GramCharlierAsianOption(TypeFlag = "c", S = S, X = X, 
        Time = Time, r = r, sigma = sigma, method = "LN")$price  
      CallRG = GramCharlierAsianOption(TypeFlag = "c", S = S, X = X, 
        Time = Time, r = r, sigma = sigma, method = "RG")$price 
      CallJI = GramCharlierAsianOption(TypeFlag = "c", S = S, X = X, 
        Time = Time, r = r, sigma = sigma, method = "JI")$price
      CallT = BoundsOnAsianOption(TypeFlag = "c", S = S, X = X, 
        Time = Time, r = r, sigma = sigma, method = "T")$price
      data.frame(S, X, Time, r, sigma, 
          CallRST, CallLN, CallRG, CallJI, CallT) 
    }  
    ###
    
    # Calculate Option Prices:
    options(digits = 9)
    # Calculate First Row Tables:
    V = rep(1, times = 40)
    X = seq(80, 120, length = length(V))
    r = seq(0.001, 1.50, length = length(V))
    sigma  = seq(0.05, 1.0, length = length(V))
    Table11 = createTable(
        S = 100*V, X = 100*V, Time = V, r = r/4, sigma = 0.5*V)    
    Table12 = createTable(
        S = 100*V, X = 100*V, Time = V, r = 0.09*V, sigma = sigma)
    Table13 = createTable(
        S = 100*V, X = X, Time = V, r = 0.09*V, sigma = 0.5*V)
    Table21 = createTableGC(
        S = 100*V, X = 100*V, Time = V, r = r/4, sigma = 0.5*V)    
    Table22 = createTableGC(
        S = 100*V, X = 100*V, Time = V, r = 0.09*V, sigma = sigma)
    Table23 = createTableGC(
        S = 100*V, X = X, Time = V, r = 0.09*V, sigma = 0.5*V)
    ###
     
    # Create Plot Function:    
    createPlot = 
    function(Table, x, ylim, xlab, main) {
        plot(x = x, y = Table[,6], type = "l", xlab = xlab, 
            ylim = ylim, ylab = "Call Price", main = main, cex.main = 1.0)
        col = c(2, 3, 4, 1)
        lty = c(2, 3, 4, 1) # dashed - dotted - dashdotted - solid
        for (i in 7:10) lines(x = x, y = Table[,i], 
            col = col[i-6], lty = lty[i-6])  
    }
    ###
      
    # Plot the Charts:
    par(mfrow = c(4, 3), cex = 0.7)
    # Moment Matched Plots:
    createPlot(Table = Table11, x = 2*Table11[,4]/0.5^2-1, ylim = c(5, 25),
        xlab = expression(paste("Interest:  ", 2 * r / sigma^2 - 1)),
        main = expression(paste(sigma^2 * T  == 1/4, "      ", X / S == 1)))  
    createPlot(Table = Table12, x = Table12[,5]^2/4, ylim = c(5, 25),
        xlab = expression(paste("Volatility:  ", sigma^2 * T / 4)),  
        main = expression(paste(X / S == 1, "      ", rT == 0.09))) 
    createPlot(Table = Table13, x = Table13[,2]/Table13[,1], ylim = c(5, 25),
        xlab = expression(paste("Strike:  ", X / S)),
        main = expression(paste(rT == 0.09, "      ", sigma^2 * T  == 1/4))) 
    # Gram-Charlier Plots:
    createPlot(Table = Table21, x = 2*Table21[,4]/0.5^2-1, ylim = c(5, 25),
        xlab = expression(paste("Interest:  ", 2 * r / sigma^2 - 1)),
        main = expression(paste(sigma^2 * T  == 1/4, "      ", X / S == 1)))  
    createPlot(Table = Table22, x = Table22[,5]^2/4, ylim = c(5, 25),
        xlab = expression(paste("Volatility:  ", sigma^2 * T / 4)),  
        main = expression(paste(X / S == 1, "      ", rT == 0.09))) 
    createPlot(Table = Table23, x = Table23[,2]/Table23[,1], ylim = c(5, 25),
        xlab = expression(paste("Strike:  ", X / S)),
        main = expression(paste(rT == 0.09, "      ", sigma^2 * T  == 1/4))) 
    ###
    

# ------------------------------------------------------------------------------


### Example: Create Figure 4 

	# Plot First four Moments, Skewness and Kurtosis of Asian Density
	###

	# Settings:
   	par(mfrow = c(3, 2), cex = 0.7)
   	zlab = c("M1", "M2", "M3", "M4")
   	titles = paste(c("First", "Second", "Third", "Fourth"), "Moment")
   	###
   	 	
   	# Plot the first four Moments:
   	for (M in 1:4) {
		n = 51
		x = sigma2Time = seq(0.0001, 0.5, length = n)
		sigma = sqrt(sigma2Time)
		y = seq(-0.19, 0.25, length = n)
		r = y + sigma2Time/2
		moments = matrix(rep(0, n*n), n)
		for (i in 1:n) {
			for (j in 1:n) {  
				# Use Dufresne's Formula
				moments[i, j] = AsianOptionMoments(
					M = M, Time = 1, r = r[j], sigma=sigma[i], method = "D")[M] 
		   }
		}
		persp(x = sigma, y = r, z = moments, theta = 315, phi = 30, 
			col = "steelblue3", scale = TRUE, ltheta = 0, axes = TRUE, 
			box = TRUE, shade = 0.75) 
		# persp(x=sigma, y=r, z=moments, xlab="s^2*T", ylab="r*T", zlab=zlab[M])
		title(main = titles[M])
	} 
	###
	
	# Add Skewness and Kurtosis
    titles = zlab = c("Skewness", "Kurtosis") 
	n = 51
	x = sigma2Time = seq(0.01, 0.5, length = n)
	sigma = sqrt(sigma2Time)
	y = seq(-0.19, 0.25, length=n)
	r = y + sigma2Time/2
	# Calculate Moments:
	M1 = M2 = M3 = M4 = matrix(rep(0, n*n), n)
	for (i in 1:n) {
   	 	for (j in 1:n) {
   	   		m = AsianOptionMoments(
   	   			M = 4, Time = 1, r = r[j], sigma = sigma[i], method = "D")
   	   		M1[i,j] = m[1]
   	   		M2[i,j] = m[2]
   	   		M3[i,j] = m[3]
   	   		M4[i,j] = m[4] 
		} 
	}   
   	# Moments around the Mean:	
   	m1 = M1
   	m2 = M2 - M1^2 
   	m3 = M3 - 3*M2*M1 + 2*M1^3 
   	m4 = M4 - 4*M3*M1 + 6*M2*M1^2 - 3*M1^4 	
   	# Calculate Mean, StdDev, Skewness Kurtosis:
   	stdev = sqrt(m2)	
   	skewness = m3 / stdev^3
   	kurtosis = m4 / stdev^4
   	# Plot Skewness:
   	persp(x=sigma, y=r, z=skewness, xlab="s^2*T", ylab="r*T", zlab=zlab[1])
   	title(main=titles[1])
   	# Plot Kurtosis:
   	persp(x=sigma, y=r, z=kurtosis, xlab="s^2*T", ylab="r*T", zlab=zlab[2])
   	title(main = titles[2])
   	####
    
   	
################################################################################
# Moment Matched Approach:
	

### Example: Usefule Examples for Pricing Asian Options by Moment Matching
	
	# Description:
	#   Example 1: 
	#       Calculate moment matched Asian call prices together with lower
	#       and upper bounds, this reproduces Table 5 of Zhang [2002]
	#   Example 2: 
	#       Calculate long and short tenor moment matched Asian call prices, 
	#       this reproduces Table 7 of Zhang [2002]
	#   Example 3:
	#       Calculate moment matched Asian call price deviations and chart 
	#       the deviations from the mean lower/upper bound reference line,
	#       this creates Figure 1 in Wuertz[2003]
	#   Example 4:
	#       Calculate state price density of Asian options in the log-Normal,
	#       reciprocal-Gamma and Johnson Type-I approximations
	#   Example 5:
	#       Calculate moment matched Asian call prices by integrating 
	#       over approximated densities
	#   Example 6:
	#       Calculate state price density from the second derivative of 
	#       Asian call prices as function of X/S 
	###
	

# ------------------------------------------------------------------------------


### Example 1:

	# Calculate Log-Normal Gram-Charlier series Expanded Option Prices:
	# Calculate Option Call Prices:
	###
	
	# Table:
   	ZhangTable()
    options(digits = 5)
    CallRST = BoundsOnAsianOption(
                table = ZhangTable(), method = "RST")$price 
    CallLN  = MomentMatchedAsianOption(
                table = ZhangTable(), method = "LN")$price 
    CallRG  = MomentMatchedAsianOption(
                table = ZhangTable(), method = "RG")$price
    CallJI  = MomentMatchedAsianOption(
                table = ZhangTable(), method = "JI")$price
    CallT   = BoundsOnAsianOption(
                table = ZhangTable(), method = "T")$price  
    CallZ   = ZhangTable()[,6]

    # Print Call Option Values:    
    Table = data.frame(cbind(ZhangTable()[,1:5], 
      CallRST, CallLN, CallRG, CallJI, CallT, CallZ))
    Table
    # write.table(Table, "TableApprox.csv", sep=",")
   

# ------------------------------------------------------------------------------


### Example 2:

	# Calculate Values of long-tenor and short-tenor Asian call 
	# options, this reproduces Table 6 and 7 in: J.E. Zhang,
	# "A semianalytical method for pricing and hedging ...", [2001].
	###
	
	# Calculate Option Call Prices:
    options(digits = 6)
    CallPM  = MomentMatchedAsianOption(table = ZhangLongTable(), 
    	method = "JI")$price 
    CallZPM = ZhangLongTable()[, 6]
    CallCT  = BoundsOnAsianOption(table = ZhangLongTable(), 
    	method = "CT")$price   
    CallZCT = ZhangLongTable()[, 7]

    # Print Call Option Values:    
    TableLong = data.frame(cbind(ZhangLongTable()[, 1:5], 
      	CallPM, CallZPM, CallCT, CallZCT))
   	TableLong
   	# write.table(TableLong, "TableLongTenor.csv", sep = ",")
   	
	# Calculate Option Call Prices:
    options(digits = 6)
    CallPM  = MomentMatchedAsianOption(table = ZhangShortTable(), 
    	method = "JI")$price 
    CallZPM = ZhangShortTable()[, 6]
    CallCT  = BoundsOnAsianOption(table=ZhangShortTable(), 
    	method = "CT")$price   
    CallZCT = ZhangShortTable()[, 7]

    # Print Call Option Values:    
    TableShort = data.frame(cbind(ZhangShortTable()[, 1:5], 
      round(cbind(CallPM, CallZPM, CallCT, CallZCT), digits = 7)))
    TableShort
    # write.table(TableShort, "TableShortTenor.csv", sep=",")
  
   
# ------------------------------------------------------------------------------


### Example 3:

	# Chart Asian call price deviations by Moment Matching - Create 3 x 3 Graph
	# Investigate the deviations from a reference line which is the mean
	# of the lower and upper price bounds.
	###
	
	# Create Table Function:
   	createTable = 
   	function(S, X, Time, r, sigma) {
		CallRST = BoundsOnAsianOption(
        	TypeFlag = "c", S, X, Time, r, sigma, method = "RST")$price 
     	CallLN  = MomentMatchedAsianOption(
        	TypeFlag = "c", S, X, Time, r, sigma, method = "LN")$price 
     	CallRG  = MomentMatchedAsianOption(
         	TypeFlag = "c", S, X, Time, r, sigma, method = "RG")$price  
     	CallJI  = MomentMatchedAsianOption(
         	TypeFlag = "c", S, X, Time, r, sigma, method = "JI")$price 
     	CallT   = BoundsOnAsianOption(
          	TypeFlag = "c", S, X, Time, r, sigma, method = "T")$price
     	data.frame(cbind(S, X, Time, r, sigma, CallRST, CallLN, CallRG, 
     		CallJI, CallT)) 
	}  

	# Create Plot Function:
   	createPlot = 
   	function(Table, x, ylim, xlab, main) {
		RefLine = ( Table[,6] + Table[,10] ) / 2 
      	plot(x = x, y = 100*(Table[,6]/RefLine - 1), type="l", ylim = ylim, 
			xlab=xlab, ylab="Call Price - % Deviation", main = main, 
			cex.main = 1)
      	col = c(2, 3, 4, 1)
      	lty = c(2, 3, 4, 1) # dashed - dotted - dashdotted - solid
      	for (i in 7:10) {
			lines(x = x, y = 100*(Table[,i]/RefLine - 1), col = col[i-6],
				lty = lty[i-6])
		}
	}  
	 
	# Option Settings: 
   	options(digits=9)
   	V = rep(1, times = 40)
	
   	# Calculate First Row Tables:
  	r       = seq(0.01, 0.10, length=length(V))
  	Table11 = createTable(S=100*V, X=100*V, Time=V, r=r, sigma=0.02*V)
  	r       = seq(0.01, 0.20, length=length(V))
  	Table12 = createTable(S=100*V, X=100*V, Time=V, r=r, sigma=0.20*V)
  	r       = seq(0.001, 0.20, length=length(V))
  	Table13 = createTable(S=100*V, X=100*V, Time=V, r=r, sigma=2.00*V)
	# Calculate Second Row Tables:
  	X       = seq(80, 120, length=length(V))
  	Table21 = createTable(S=100*V, X=X, Time=V, r=0.05*V, sigma=V)
  	Table22 = createTable(S=100*V, X=X, Time=V, r=0.09*V, sigma=0.30*V)
  	Table23 = createTable(S=100*V, X=X, Time=V, r=0.15*V, sigma=0.10*V)
	# Calculate Third Row Tables:
  	sigma   = seq(0.05, 1.50, length=length(V))
  	Table31 = createTable(S=100*V, X=80*V, Time=V, r=0.09*V, sigma=sigma)
  	Table32 = createTable(S=100*V, X=100*V, Time=V, r=0.09*V, sigma=sigma)
  	Table33 = createTable(S=100*V, X=120*V, Time=V, r=0.09*V, sigma=sigma)
		
  	# Start with Plots:
  	par(mfrow = c(4, 3), cex = 0.5)
   	# First Row Plots:
	createPlot(Table = Table11, x = 2*Table11[,4]/0.05^2-1, 
		ylim = c(-0.05, 0.05), 
		xlab = expression(paste("Interest:  ", 2 * r / sigma^2 - 1)),
		main = expression(paste(sigma^2 * T / 4 == 10^{-4}, "   ", X / S == 1))) 
	createPlot(Table = Table12, x = 2*Table12[,4]/0.30^2-1, 
		ylim = c(-0.50, 0.50), 
		xlab = expression(paste("Interest:  ", 2 * r / sigma^2 - 1)),
		main = expression(paste(sigma^2 * T / 4 == 0.01, "    ", X / S == 1)))  
	createPlot(Table = Table13, x = 2*Table13[,4]/1.00^2-1, 
		ylim = c(-50.0, 50.0), 
		xlab = expression(paste("Interest:  ", 2 * r / sigma^2 - 1)),
		main = expression(paste(sigma^2 * T /4 == 1, "     ", X / S == 1)))
   	# Second Row Plots: 
	createPlot(Table = Table21, x = Table21[,2]/Table21[,1], 
		ylim = c(-10.0, 5.0), 
		xlab = expression(paste("Strike:  ", X / S)),
		main = expression(paste(rT == 0.05, "      ", sigma^2 * T == 1))) 
	createPlot(Table = Table22, x = Table22[,2]/Table22[,1], 
		ylim = c(-2.0, 1.0), 
		xlab = expression(paste("Strike:  ", X / S)),
		main = expression(paste(rT == 0.09, "      ", sigma^2 * T  == 0.09)))   
	createPlot(Table = Table23, x = Table23[,2]/Table23[,1], 
		ylim = c(-10.0, 5.0), 
		xlab = expression(paste("Strike:  ", X / S)),
		main = expression(paste(rT == 0.15, "      ", sigma^2 * T == 0.01)))
	## Third Row Plots: 
	createPlot(Table = Table31, x = Table31[,5], 
		ylim = c(-15.0, 15.0), 
		xlab = expression(paste("Volatility:  ", sigma^2 * T / 4)), 
		main = expression(paste(X / S == 0.8, "      ", rT == 0.09)))
	createPlot(Table = Table32, x = Table32[,5], 
		ylim = c(-15.0, 15.0), 
		xlab = expression(paste("Volatility:  ", sigma^2 * T / 4)),  
		main = expression(paste(X / S == 1.0, "      ", rT == 0.09)))
	createPlot(Table = Table33, x = Table33[,5], 
		ylim = c(-15.0, 15.0),
		xlab = expression(paste("Volatility:  ", sigma^2 * T / 4)),
		main = expression(paste(X / S == 1.2, "      ", rT == 0.09)))
  	###
  	
   
# ------------------------------------------------------------------------------


### Example 4:

	# Calculate state price density of Asian options in the log-Normal,
	# reciprocal-Gamma and Johnson Type-I approximations
	###
	
	# Create Density Plots
    par(mfrow = c(2, 2))
    Time = 1; r = 0.045; sigma = 0.30
    nu = 2*r / sigma^2 -1
    tau = sigma^2 * Time / 4
    x = seq(0.4, 2.8, length=100) 
	###
	
    # Calculate Densities and Normalize with tau:
    d1 = MomentMatchedAsianDensity(x, Time, r, sigma, method = "LN") / tau
    d2 = MomentMatchedAsianDensity(x, Time, r, sigma, method = "RG") / tau
    d3 = MomentMatchedAsianDensity(x, Time, r, sigma, method = "JI") / tau
 	###
 	
    # Make a Linear Density Plot:
    plot(x, d2, type="l", ylab="Density", 
     	main="Moment Matched Density")  
    lines(x, d1, type = "l", col = "red")
    lines(x, d2, type = "l", col = "green")
    lines(x, d3, type = "l", col = "blue")
	###
	
    # Make a Log-Log Density Plot:
    plot(log(x), log(d2), type="l", ylab="log(Density)", 
     	main = "Moment Matched Density")  
    lines(log(x), log(d1), type = "l", col = "red")
    lines(log(x), log(d2), type = "l", col = "green")
    lines(log(x), log(d3), type = "l", col = "blue")
 	###  

# ------------------------------------------------------------------------------


### Example 5:

	# Calculate Asian call prices by integrating over approximated densities
	###
	
	# Test for methods = "LN", "RG", "JI", and times = 1, 3
    Method = c("LN", "RG", "JI", "LN", "RG", "JI")
    Time = c(1, 1, 1, 3, 3, 3)
    S = 100; X = 100; r = 0.09; sigma = 0.30
    Call.Integrated = Call.Direct = rep(0, times=6)
    func = function(x, S, X, Time, roh, sigma, method) { 
      	(x - X/S) * MomentMatchedAsianDensity(x, Time, roh, sigma, method)
    }
    for (i in 1:6) {
      Call.Integrated[i] = S* exp(-r*Time[i]) * integrate(
        func, lower=X/S, upper=20, S=S, X=X, Time=Time[i], roh=r, 
        sigma=sigma, method=Method[i])$value
      Call.Direct[i] = MomentMatchedAsianOption(TypeFlag="c", S=S, X=X, 
        Time=Time[i], r=r, sigma=sigma, method=Method[i])$price }
	###
	
    # Print Call Prices:
    names = paste(Method, "-", as.character(Time), sep="")
    data.frame(cbind(Time, Call.Integrated, Call.Direct), row.names=names)
 	###
 	
   
# ------------------------------------------------------------------------------


### Example 6:

	# Calculate state price density from the second derivative of 
	# Asian call prices as function of X/S 
	###
	
	## Settings:
    par(mfrow=c(2, 2), CEX = 0.7)
    method = "JI"
    S = 1; X = seq(0.400, 2.500, by = 0.005); Time = 1; r = 0.09; sigma=0.30
	###
	
	# Calculate Option Prices:
    price = rep(0, times=length(X))
    for ( i in 1:length(X) ) {
        price[i] = MomentMatchedAsianOption(TypeFlag="c", S=S, X=X[i], 
            Time=Time, r=r, sigma=sigma, method=method)$price }

    # Take the Second Derivative and Calculate Density:
    z = derivative(x=X, y=price, deriv=2)
    x = z$x; density.1 = exp(r*Time)*z$y 
	###
	
    # Calculate Density directly: 
    density.2 = MomentMatchedAsianDensity(x = x, Time = Time, r = r, 
     	sigma = sigma, method = method)    
	###
	
   	# Plot on Linear and Double-Log Scale: 
    plot (x, density.1, type="l", xlab="x", ylab="Density", 
     	main=paste(method, "- Density"))
   	lines(x, density.1, col="green")
   	lines(x, density.2, col="red")
   	plot (log(x), log(density.1), type="l", xlab="log(x)", 
      	ylab="log(Density)", main=paste(method, "- Log-Density"))
   	lines(log(x), log(density.1), col="green")
   	lines(log(x), log(density.2), col="red")
	###
	
   	# Note, that the two curves cannot be distinguished!  
    difference = 100*(density.1-density.2)/density.2
    cbind(x, density.1, density.2, difference)
    plot(x, difference, type="l", main=paste(method, "- % Difference"))
    plot(log(x), difference, type="l", main=paste(method, "- % Difference"))
 	###
 	
   
################################################################################

#
# Examples from the forthcoming Monograph:
#   Rmetrics - Financial Engineering and Computational Finance
#   A Practitioner's Guide for R and SPlus Programmers
#   written by Diethelm Wuertz
#   ISBN to be published
#
# Details:
#   Examples from Chapter 7.2
#   Pricing Formulas for Exotic Options
#
# List of Examples, Exercises and Code Snippets
#
#   Example: Chooser Options
#   Example: Multiple Assets Options
#   Example: Lookback Options
#   Example: Barrier Options
#   Example: Binary Options
#   Example: Asian Options
#
#   *** This list is not yet complete ***
#
# Author:
#   (C) 2002-2005, Diethelm Wuertz, GPL
#     www.rmetrics.org
#     www.itp.phys.ethz.ch
#     www.finance.ch
#


################################################################################
# Pricing Formulas for Exotic Options


### Example: Chooser Options

    # This script gives examples on some binary options:
    #   Simple Chooser Option
    #   Complex Chooser Option
    # Reference:
    #   E.G. Haug [1997], Chapter 2
    ###

    # Simple Chooser Option:
    SimpleChooserOption(S = 50, X = c(45, 50, 55), Time = 0.5, r = 0.08, 
      b = 0.08, sigma = 0.25, time = 0.25)
    ###
    
    # Complex Chooser Option:
    ComplexChooserOption(S = 50, Xc = 55, Xp = 48, Time = 0.25, 
      Timec = 0.5, Timep = 0.5833, r = 0.10, b = 0.10-0.05, 
      sigma = 0.35, doprint = TRUE)
    ###
    
      
# ------------------------------------------------------------------------------


### Example: Multiple Assets Options

    # This script gives examples on some multiple assets options:
    #   Two Asset Correlation Options
    #   European Exchange Options
    #   American Exchange Options
    #   Exchange Options On Exchange Options
    #   Two Risky Assets Options
    #   Spread-Option Approximation
    # Reference:
    #   E.G. Haug [1997]
    ###

    # Two Asset Correlation Options:    
    TwoAssetCorrelationOption(TypeFlag = "c", S1 = 52, S2 = 65, 
        X1 = 50, X2 = 70, Time = 0.5, r = 0.10, b1 = 0.10, b2 = 0.10, 
        sigma1 = 0.2, sigma2 = 0.3, rho = 0.75) 
    ###

    # European Exchange Options: 
    EuropeanExchangeOption(S1 = 22, S2 = 0.20, Q1 = 1, Q2 = 1, 
        Time = 0.1, r = 0.1, b1 = 0.04, b2 = 0.06, sigma1 = 0.2, 
        sigma2 = 0.25, rho = -0.5)
    ###
     
    # American Exchange Options:
    AmericanExchangeOption(S1 = 22, S2 = 0.20, Q1 = 1, Q2 = 1, 
        Time = 0.1, r = 0.1, b1 = 0.04, b2 = 0.06, sigma1 = 0.2, 
        sigma2 = 0.25, rho = -0.5)
    ###

    # Exchange Options On Exchange Options:
    for (flag in 1:4) print(
        ExchangeOnExchangeOption(TypeFlag = as.character(flag), 
            S1 = 105, S2 = 100, Q = 0.1, time1 = 0.75, Time2 = 1.0, 
            r = 0.1, b1 = 0.10, b2 = 0.10, sigma1 = 0.20, 
            sigma2 = 0.25, rho = -0.5))
    ###

    # Two Risky Assets Options:
    TwoRiskyAssetsOption(TypeFlag = "cmax", S1 = 100, S2 = 105, 
        X = 98, Time = 0.5, r = 0.05, b1 = -0.01, b2 = -0.04, 
        sigma1 = 0.11, sigma2 = 0.16, rho = 0.63)
    TwoRiskyAssetsOption(TypeFlag = "pmax", S1 = 100, S2 = 105, 
        X = 98, Time = 0.5, r = 0.05, b1 = -0.01, b2 = -0.04, 
        sigma1 = 0.11, sigma2 = 0.16, rho = 0.63)
    ###

    # Spread-Option Approximation:
    SpreadApproxOption(TypeFlag = "c", S1 = 28, S2 = 20, X = 7, 
        Time = 0.25, r = 0.05, sigma1 = 0.29, sigma2 = 0.36, 
        rho = 0.42)
    ###
     
        
# ------------------------------------------------------------------------------

 
### Example: Lookback Options
    
    # This script gives examples on some lookback options:
    #   Floating Strike Lookback Option
    #   Fixed Strike Lookback Option
    #   Partial-Time Floating Strike Lookback Option
    #   Partial-Time Fixed Strike Lookback Option
    # Reference:
    #   E.G. Haug [1997], Chapter 2
    ###
    
    # Floating Strike Lookback Option:
    FloatingStrikeLookbackOption(TypeFlag = "c", S = 120, 
      SMinOrMax = 100, Time = 0.5, r = 0.10, b = 0.10-0.06, 
      sigma = 0.30)
    ###
  
    # Fixed Strike Lookback Option:
    FixedStrikeLookbackOption(TypeFlag = "c", S = 100, 
      SMinOrMax = 100, X = 105, Time = 0.5, r = 0.10, b = 0.10, 
      sigma = 0.30)
    ###
   
    # Partial Time Floating Strike Lookback Option:
    PTFloatingStrikeLookbackOption(TypeFlag = "p", S = 90, 
      SMinOrMax = 90, time1 = 0.5, Time2 = 1, r = 0.06, b = 0.06, 
      sigma = 0.20, lambda  = 1)
   
    # Partial Time Fixed Strike Lookback Option:
    PTFixedStrikeLookbackOption(TypeFlag = "c", S = 100, X = 90, 
      time1 = 0.5, Time2 = 1, r = 0.06, b = 0.06, sigma = 0.20)

      
# ------------------------------------------------------------------------------


### Example: Barrier Options

    # This script gives examples on some barrier options:
    #   Standard Barrier Options
    #   Double-Barrier Options
    #   Partial-Time Single-Asset Barrier Options
    #   Two-Asset Barrier Options
    #   Partial-Time Two-Asset Barrier Options
    #   Look-Barrier Options
    #   Soft-Barrier Options
    # Reference:
    #   E.G. Haug [1997], Chapter 2
    ###

    # Standard Barrier Option:
    # down-and-out Barrier Call
    StandardBarrierOption(TypeFlag = "cdo", S = 100, X = 90, 
      H = 95, K = 3, Time = 0.5, r = 0.08, b = 0.04, sigma = 0.25)
    ###
   
    # Double-Barrier Option:
    DoubleBarrierOption(TypeFlag = "co", S = 100, X = 100, L = 50, 
      U = 150, Time = 0.25, r = 0.10, b = 0.10, sigma = 0.15, 
      delta1 = -0.1, delta2 = 0.1)
    ###
   
    # Partial-Time Single-Asset Barrier Option:
    PTSingleAssetBarrierOption(TypeFlag = "coB1", S = 95, X = 110, 
      H = 100, time1 = 0.5, Time2 = 1, r = 0.20, b = 0.20, 
      sigma = 0.25)
    ###
   
    # Two-Asset Barrier Option:
    TwoAssetBarrierOption(TypeFlag = "puo", S1 = 100, S2 = 100, 
      X = 110, H = 105, Time = 0.5, r = 0.08, b1 = 0.08, b2 = 0.08, 
      sigma1 = 0.2, sigma2 = 0.2, rho = -0.5)
    ###
   
    # Partial-Time Two-Asset Barrier Option:
    PTTwoAssetBarrierOption(TypeFlag = "pdo", S1 = 100, S2 = 100, 
      X = 100, H = 85, time1 = 0.5, Time2 = 1, r = 0.1, b1 = 0.1, 
      b2 = 0.1, sigma1 = 0.25, sigma2 = 0.30, rho = -0.5)
    ###
   
    # Look-Barrier Option:
    LookBarrierOption(TypeFlag = "cuo", S = 100, X = 100, H = 130, 
      time1 = 0.25, Time2 = 1, r = 0.1, b = 0.1, sigma = 0.15)
    LookBarrierOption(TypeFlag = "cuo", S = 100, X = 100, H = 110, 
      time1 = 1, Time2 = 1, r = 0.1, b = 0.1, sigma = 0.30)
    ###
    
    # Soft-Barrier Option:
    SoftBarrierOption(TypeFlag = "cdo", S = 100, X = 100, L = 70, 
      U = 95, Time = 0.5, r = 0.1, b = 0.05, sigma = 0.20)
    ###
 


# ------------------------------------------------------------------------------


### Example: Binary Options
 
    # This script gives examples on some binary options:
    #   Gap Option
    #   Cash-Or-Nothing Option
    #   Two-Asset Cash-Or-Nothing Option
    #   Asset-Or-Nothing Option
    #   Super-Share Option
    # Reference:
    #   E.G. Haug [1997]
    ###
    
    # Gap Option:
    GapOption("c", S = 50, X1 = 50, X2 = 57, Time = c(0.25, 0.50, 1), 
        r = 0.09, b = 0.09, sigma = 0.20)
    ###

    # Cash-Or-Nothing Option:
    CashOrNothingOption("p", S = 100, X = 80, K = 10, Time = 0.75, 
        r = 0.06, b = 0, sigma = c(0.15, 0.25, 0.35))
    ###
        
    # Two-Asset Cash-Or-Nothing Option:
    for (TypeFlag in c("c", "p", "ud", "du"))
    print(TwoAssetCashOrNothingOption(TypeFlag, S1 = 100, S2 = 100, 
        X1 = 110, X2 = 90, K = 10, Time = 0.5, r = 0.10, b1 = 0.05, 
        b2 = 0.06, sigma1 = 0.20, sigma2 = 0.25, rho = 0))
    ###
        
    # Asset-Or-Nothing Option:
    AssetOrNothingOption("p", S = 70, X = 65, Time = 0.5, r = 0.07, 
        b = 0.07-0.05, sigma = 0.27)        
    ###
    
    # Super-Share Option:
    SuperShareOption(S = 100, XL = 90, XH = 110, Time = 0.25, 
        r = 0.10, b = 0, sigma = 0.20)              
    ###


# ------------------------------------------------------------------------------


### Example: Asian Options

    # This script gives examples on some Asian options:
    #   Geometric Average Rate Option
    #   Approximations for the Arithmetic Average Rate Option
    #     Turnbull's and Wakeman's Approximation
    #     Levy's Approximation
    # Reference:
    #   E.G. Haug [1997], Chapter 2
    ###

    # Geometric Average Rate Option:
    GeometricAverageRateOption("p", S = 80, X = 85, 
      Time = 0.25, r = 0.05, b = 0.08, sigma = 0.20)
    ###

    # Turnbull Wakeman Approximation:
    TurnbullWakemanAsianApproxOption("p", S = 90, SA = 88, 
      X = 95, Time = 0.50, time = 0.25, tau = 0.0, r = 0.07, 
      b = 0.02, sigma = 0.25)
    ###
      
    # Levy Asian Approximation:   
    LevyAsianApproxOption("c", S = 100, SA = 100, X = 105, 
      Time = 0.75, time = 0.50, r = 0.10, b = 0.05, sigma = 0.15)
    ###
        
      
################################################################################    

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################
# FUNCTION:             DESCRIPTION:
#  runif.pseudo           Uniform Pseudo Random number sequence
#  rnorm.pseudo           Normal Pseudo Random number sequence
#  runif.halton           Uniform Halton low discrepancy sequence
#  rnorm.halton           Normal Halton low discrepancy sequence
#  runif.sobol            Uniform Sobol low discrepancy sequence
#  rnorm.sobol            Normal Sobol low discrepancy sequence
################################################################################


runif.pseudo <- 
  function(n, dimension, init = NULL) 
{
    # Description:
    #   Uniform Pseudo Random number sequence

    matrix(runif(n*dimension), ncol = dimension)
}


# ------------------------------------------------------------------------------


rnorm.pseudo <- 
  function(n, dimension, init = TRUE) 
{

    # Description:
    #   Normal Pseudo Random number sequence

    matrix(rnorm(n*dimension), ncol = dimension)
}


# -----------------------------------------------------------------------------


runif.halton <- 
  function (n, dimension, init = TRUE)
{   
    # A function implemented by Diethelm Wuertz

    # Description:
    #   Uniform Halton Low Discrepancy Sequence

    # Details:
    #   DIMENSION : dimension <= 200
    #       N : LD numbers to create

    # FUNCTION:

    # Restart Settings:
    if (init) {
        ## YC : this code should not needed since we have now global Env
        # .warn = options()$warn
        # options(warn = -1)
        # rm(".runif.halton.seed")
        # options(warn = .warn)
        .setfOptionsEnv(.runif.halton.seed = list(base = rep(0, dimension), offset = 0))
    }
    optEnv <- .getfOptionsEnv(".runif.halton.seed")

    # SUBROUTINE HALTON(QN, N, DIMEN, BASE, OFFSET, INIT, TRANSFORM)
    result <- .Fortran("halton",
                       qn = numeric(n*dimension),
                       as.integer(n),
                       as.integer(dimension),
                       base = as.integer(optEnv$base),
                       offset=as.integer(optEnv$offset),
                       as.integer(init),
                       0L,
                       PACKAGE = "fOptions")

    # For the next numbers save:
    .setfOptionsEnv(.runif.halton.seed = result[c("base", "offset")])

    matrix(result[["qn"]], ncol = dimension)
}


# ------------------------------------------------------------------------------


rnorm.halton <- function (n, dimension, init = TRUE)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Normal Halton Low Discrepancy Sequence

    # Details:
    #   DIMENSION : dimension <= 200
    #       N : LD numbers to create

    # FUNCTION:

    # Restart Settings:
    if (init) {
###         .warn = options()$warn
###         options(warn = -1)
###         rm(".rnorm.halton.seed")
###         options(warn = .warn)
        .setfOptionsEnv(.rnorm.halton.seed = list(base = rep(0, dimension), offset = 0))
    }
    optEnv <- .getfOptionsEnv(".rnorm.halton.seed")

    # SUBROUTINE HALTON(QN, N, DIMEN, BASE, OFFSET, INIT, TRANSFORM)
    result <- .Fortran("halton",
                       qn = numeric(n * dimension),
                       as.integer(n),
                       as.integer(dimension),
                       base = as.integer(optEnv$base),
                       offset=as.integer(optEnv$offset),
                       as.integer(init),
                       1L,
                       PACKAGE = "fOptions")

    # For the next numbers save:
    .setfOptionsEnv(.rnorm.halton.seed = result[c("base", "offset")])

    matrix(result[["qn"]], ncol = dimension)
}


# -----------------------------------------------------------------------------


runif.sobol <- function (n, dimension, init = TRUE, scrambling = 0, seed = 4711)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Uniform Sobol Low Discrepancy Sequence

    # Details:
    #   DIMENSION : dimension <= 200
    #           N : LD numbers to create
    #  SCRAMBLING : One of the numbers 0,1,2,3
    #

    # FUNCTION:
    stopifnot(0 <= (scrambling <- as.integer(scrambling)), scrambling <= 3)

    # Restart Settings:
    if (init) {
        .setfOptionsEnv(.runif.sobol.seed = list(quasi = rep(0, dimension), ll = 0,
                        count = 0, sv = rep(0, dimension*30), seed = seed))
    }
    optEnv <- .getfOptionsEnv(".runif.sobol.seed")

    # SSOBOL(QN,N,DIMEN,QUASI,LL,COUNT,SV,scrambling,SEED,INIT,TRANSFORM)
    result <- .Fortran("sobol",
                       qn = numeric(n * dimension),
                       as.integer(n),
                       as.integer(dimension),
                       quasi = as.double (optEnv$quasi),
                       ll    = as.integer(optEnv$ll),
                       count = as.integer(optEnv$count),
                       sv    = as.integer(optEnv$sv),
                       scrambling,
                       seed  = as.integer(optEnv$seed),
                       as.integer(init),
                       0L,
                       PACKAGE = "fOptions")

    # For the next numbers save:
    .setfOptionsEnv(.runif.sobol.seed = result[c("quasi","ll","count","sv","seed")])

    matrix(result[["qn"]], ncol = dimension)
}


# ------------------------------------------------------------------------------


rnorm.sobol <- function (n, dimension, init = TRUE, scrambling = 0, seed = 4711)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Normal Sobol Low Discrepancy Sequence

    # Details:
    #   DIMENSION : dimension <= 200
    #           N : LD numbers to create
    #  SCRAMBLING : One of the numbers 0,1,2,3

    # FUNCTION:

    stopifnot(0 <= (scrambling <- as.integer(scrambling)), scrambling <= 3)
    # Restart Settings:
    if (init) {
        .setfOptionsEnv(.rnorm.sobol.seed = list( quasi = rep(0, dimension), ll = 0,
                        count = 0, sv = rep(0, dimension*30), seed = seed))
    }
    optEnv <- .getfOptionsEnv(".rnorm.sobol.seed")

    # SSOBOL(QN,N,DIMEN,QUASI,LL,COUNT,SV,scrambling,SEED,INIT,TRANSFORM)
    result <- .Fortran("sobol",
                       qn = numeric(n * dimension),
                       as.integer(n),
                       as.integer(dimension),
                       quasi = as.double (optEnv$quasi),
                       ll    = as.integer(optEnv$ll),
                       count = as.integer(optEnv$count),
                       sv    = as.integer(optEnv$sv),
                       scrambling,
                       seed  = as.integer(optEnv$seed),
                       as.integer(init),
                       1L,
                       PACKAGE = "fOptions")

    # For the next numbers save:
    .setfOptionsEnv(.rnorm.sobol.seed = result[c("quasi","ll","count","sv","seed")])

    matrix(result[["qn"]], ncol = dimension)
}


################################################################################

#### doRUnit.R --- Run RUnit tests
####------------------------------------------------------------------------

### Origianlly follows Gregor Gojanc's example in CRAN package  'gdata'
### and the corresponding section in the R Wiki:
###  http://wiki.r-project.org/rwiki/doku.php?id=developers:runit

### MM: Vastly changed:  This should also be "runnable" for *installed*
##              package which has no ./tests/
## ----> put the bulk of the code e.g. in  ../inst/unitTests/runTests.R :

if(require("RUnit", quietly = TRUE)) {

  ## --- Setup ---

  wd <- getwd()
  pkg <- sub("\\.Rcheck$", '', basename(dirname(wd)))

  library(package=pkg, character.only = TRUE)

  path <- system.file("unitTests", package = pkg)

  stopifnot(file.exists(path), file.info(path.expand(path))$isdir)

  source(file.path(path, "runTests.R"), echo = TRUE)
}

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA

# Copyrights (C)
# for this R-port:
#   1999 - 2007, Diethelm Wuertz, GPL
#   Diethelm Wuertz <wuertz@itp.phys.ethz.ch>
#   info@rmetrics.org
#   www.rmetrics.org
# for the code accessed (or partly included) from other R-ports:
#   see R's copyright and license files
# for the code accessed (or partly included) from contributed R-ports
# and other sources
#   see Rmetrics's copyright file


################################################################################
# FUNCTION:             DESCRIPTION:
#  runif.pseudo           Uniform Pseudo Random number sequence
#  rnorm.pseudo           Normal Pseudo Random number sequence
#  runif.halton           Uniform Halton low discrepancy sequence
#  rnorm.halton           Normal Halton low discrepancy sequence
#  runif.sobol            Uniform Sobol low discrepancy sequence
#  rnorm.sobol            Normal Sobol low discrepancy sequence
################################################################################


test.pseudo =
function()
{
    # Pseudo Random Numbers:
    #   Uniform and Normal pseudo random number sequences

    # RVs:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")

    # Graphics Frame:
    par(mfrow = c(2, 2), cex = 0.75)

    # Histogram Uniform:
    runif.pseudo(n = 10, dimension = 5)
    r = runif.pseudo(n = 1000, dimension = 1)
    hist(r, probability = TRUE, main = "Uniform Pseudo", xlab = "x",
        col = "steelblue", border = "white")
    abline (h = 1, col = "orange", lwd = 2)

    # Scatterplot Uniform:
    r = runif.pseudo(n = 1000, dimension = 2)
    plot(r, cex = 0.5, main = "Scatterplot Uniform Pseudo")

    # Histogram Normal:
    rnorm.pseudo(n = 10, dimension = 5)
    r = rnorm.pseudo(n = 1000, dimension = 1)
    hist(r, probability = TRUE, xlim = c(-3, 3), main = "Normal Pseudo",
        xlab = "x", col = "steelblue", border = "white")
    x = seq(-3, 3, length = 301)
    lines(x, dnorm(x), col = "orange", lwd = 2)

    # Scatterplot Normal:
    r = rnorm.pseudo(n = 1000, dimension = 2)
    plot(r, cex = 0.5, main = "Scatterplot Normal Pseudo")

    # Return Value:
    return()
}


# ------------------------------------------------------------------------------


test.halton =
function()
{
    # Halton Sequence:
    #   Uniform and Normal Halton low discrepancy sequences

    # RVs:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")

    # Graphics Frame:
    par(mfrow = c(2, 2), cex = 0.75)

    # Histogram Uniform:
    runif.halton(n = 10, dimension = 5)
    r = runif.halton(n = 5000, dimension = 1)
    hist(r, probability = TRUE, main = "Uniform Halton", xlab = "x",
        col = "steelblue", border = "white")
    abline (h = 1, col = "orange", lwd = 2)

    # Scatterplot Uniform:
    r = runif.halton(n = 1000, dimension = 2)
    plot(r, cex = 0.5, main = "Scatterplot Uniform Halton")

    # Histogram Normal:
    rnorm.halton(n = 10, dimension = 5)
    r = rnorm.halton(n = 5000, dimension = 1)
    hist(r, probability = TRUE, xlim = c(-3, 3), main = "Normal Halton",
        xlab = "x", col = "steelblue", border = "white")
    x = seq(-3, 3, length = 301)
    lines(x, dnorm(x), col = "orange", lwd = 2)

    # Scatterplot Normal:
    r = rnorm.halton(n = 1000, dimension = 2)
    plot(r, cex = 0.5, main = "Scatterplot Normal Halton")

    # Return Value:
    return()
}


# ------------------------------------------------------------------------------


test.sobol =
function()
{
    # Sobol Sequence:
    #   Uniform and Normal Sobol low discrepancy sequences

    # RVs:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")

    # Graphics Frame:
    par(mfrow = c(2, 2), cex = 0.75)

    # Histogram Uniform:
    runif.sobol(n = 10, dimension = 5)
    r = runif.sobol(5000, 1)
    hist(r, probability = TRUE, main = "Uniform Sobol",
        xlab = "x", col = "steelblue", border = "white")
    abline (h = 1, col = "orange", lwd = 2)

    # Scatterplot Uniform:
    r = runif.sobol(n = 1000, dimension = 2)
    plot(r, cex = 0.5, main = "Scatterplot Uniform Sobol")

    # Histogram Normal:
    rnorm.sobol(n = 10, dimension = 5)
    r = rnorm.sobol(1000, 1)
    hist(r, probability = TRUE, main = "Normal Sobol",
        xlab = "x", col = "steelblue", border = "white")
    x = seq(-3, 3, length = 301)
    lines(x, dnorm(x), col = "orange", lwd = 2)

    # Scatterplot Normal:
    r = rnorm.sobol(n = 1000, dimension = 2)
    plot(r, cex = 0.5, main = "Scatterplot Normal Sobol")
    
    # Return Value:
    return()
}


# ------------------------------------------------------------------------------


test.scrambling =
function()
{
    # Sobol Scrambling:

    # RVs:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")

    # runif.sobol(n, dimension, init = TRUE, scrambling = 0, seed = 4711)

    # Unscrambled:
    runif.sobol(10, 5)

    # Owen Type Scrambling:
    runif.sobol(10, 5, scrambling = 1)

    # Faure-Tezuka  Type Scrambling:
    runif.sobol(10, 5, scrambling = 2)

    # Combined Owen and Faure-Tezuka Type Scrambling:
    runif.sobol(10, 5, scrambling = 3)

    # Return Value:
    return()
}


# ------------------------------------------------------------------------------


test.restart =
function()
{
    # Sobol Restart:

    # RVs:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")

    # runif.sobol(n, dimension, init = TRUE, scrambling = 0, seed = 4711)
    runif.sobol(10, 5, init = TRUE)
    runif.sobol(10, 5, init = FALSE)

    # Seed:
    print(.getfOptionsEnv(".runif.sobol.seed"))

    # Return Value:
    return()
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


###############################################################################

.onAttach <- 
  function(libname, pkgname)
  {
    # do whatever needs to be done when the package is loaded
    # some people use it to bombard users with 
    # messages using 
    
    packageStartupMessage( "\n" )
    packageStartupMessage( "Rmetrics Package fOptions" ) 
    packageStartupMessage( "Pricing and Evaluating Basic Options" )
    packageStartupMessage( "Copyright (C) 2005-2014 Rmetrics Association Zurich" )  
    packageStartupMessage( "Educational Software for Financial Engineering and Computational Science" ) 
    packageStartupMessage( "Rmetrics is free software and comes with ABSOLUTELY NO WARRANTY." ) 
    packageStartupMessage( "https://www.rmetrics.org --- Mail to: info@rmetrics.org" ) 
  }

###############################################################################

.onLoad <- 
  function(libname, pkgname) 
{
  .setfOptionsEnv(.runif.halton.seed = list())
  .setfOptionsEnv(.rnorm.halton.seed = list())
  .setfOptionsEnv(.runif.sobol.seed = list())
  .setfOptionsEnv(.rnorm.sobol.seed = list())
}

###############################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################
# FUNCTION:           DESCRIPTION:
#  HNGOption           Computes Option Price from the HN-GARCH Formula
#  HNGGreeks           Calculates one of the Greeks of the HN-GARCH Formula
#  HNGCharacteristics  Computes Option Price and all Greeks of HN-GARCH Model
################################################################################


HNGOption =
function(TypeFlag = c("c", "p"), model, S, X, Time.inDays, r.daily)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Calculates the price of a HN-GARCH option.

    # Details:
    #   The function calculates the price of a Heston-Nandi GARCH(1,1)
    #   call or put option.

    # FUNCTION:

    # Option Type:
    TypeFlag = TypeFlag[1]

    # Integrate:
    call1 = integrate(.fstarHN, 0, Inf, const = 1, model = model,
        S = S, X = X, Time.inDays = Time.inDays, r.daily = r.daily)
    # For SPlus Compatibility:
    if (is.null(call1$value)) call1$value = call1$integral
    call2 = integrate(.fstarHN, 0, Inf, const = 0, model = model,
        S = S, X = X, Time.inDays = Time.inDays, r.daily = r.daily)
    # For SPlus Compatibility:
    if (is.null(call2$value)) call2$value = call2$integral

    # Compute Call Price:
    call.price = S/2 + exp(-r.daily*Time.inDays) * call1$value -
        X * exp(-r.daily*Time.inDays) * ( 1/2 + call2$value )

    # Select Option Price:
    price = NA
    if (TypeFlag == "c" ) price = call.price
    if (TypeFlag == "p" ) price = call.price + X*exp(-r.daily*Time.inDays) - S

    # Return Value:
    option = list(
        price = price,
        call = match.call())
    class(option) = "option"
    option
}


.fstarHN <-
function(phi, const, model, S, X, Time.inDays, r.daily)
{
    # Internal Function:

    # Model Parameters:
    lambda = -1/2
    omega = model$omega
    alpha = model$alpha
    gamma = model$gamma + model$lambda + 1/2
    beta = model$beta
    sigma2 = (omega + alpha)/(1 - beta - alpha * gamma^2)
    # Function to be integrated:
    cphi0 = phi*complex(real = 0, imaginary = 1)
    cphi = cphi0 + const
    a = cphi * r.daily
    b = lambda*cphi + cphi*cphi/2
    for (i in 2:Time.inDays) {
        a = a + cphi*r.daily + b*omega - log(1-2*alpha*b)/2
        b = cphi*(lambda+gamma) - gamma^2/2 + beta*b +
            0.5*(cphi-gamma)^2/(1-2*alpha*b) }
    f = Re(exp(-cphi0*log(X)+cphi*log(S)+a+b*sigma2 )/cphi0)/pi

    # Return Value:
    f
}


# ------------------------------------------------------------------------------


HNGGreeks =
function(Selection = c("Delta", "Gamma"), TypeFlag = c("c", "p"), model,
S, X, Time.inDays, r.daily)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Calculates the Greeks of a HN-GARCH option.

    # Details:
    #   The function calculates the delta and gamma Greeks of
    #   a Heston Nandi GARCH(1,1) call or put option.

    # FUNCTION:

    # Type Flags:
    Selection = Selection[1]
    TypeFlag = TypeFlag[1]

    # Delta:
    if (Selection == "Delta") {
        # Integrate:
        delta1 = integrate(.fdeltaHN, 0, Inf, const = 1, model = model,
            S = S, X = X, Time.inDays = Time.inDays, r.daily = r.daily)
        # For SPlus Compatibility:
        if (is.null(delta1$value)) delta1$value = delta1$integral
        delta2 = integrate(.fdeltaHN, 0, Inf, const = 0, model = model,
            S = S, X = X, Time.inDays = Time.inDays, r.daily = r.daily)
        # For SPlus Compatibility:
        if (is.null(delta2$value)) delta2$value = delta2$integral
        # Compute Call and Put Delta :
        greek = 1/2 + exp(-r.daily*Time.inDays) * delta1$value -
            X * exp(-r.daily*Time.inDays) * delta2$value
        if (TypeFlag == "p") greek = greek - 1 }

    # Gamma:
    if (Selection == "Gamma") {
        # Integrate:
        gamma1 = integrate(.fgammaHN, 0, Inf, const = 1, model = model,
            S = S, X = X, Time.inDays = Time.inDays, r.daily = r.daily)
        # For SPlus Compatibility:
        if (is.null(gamma1$value)) gamma1$value = gamma1$integral
        gamma2 = integrate(.fgammaHN, 0, Inf, const = 0, model = model,
            S = S, X = X, Time.inDays = Time.inDays, r.daily = r.daily)
        # For SPlus Compatibility:
        if (is.null(gamma2$value)) gamma2$value = gamma2$integral
        # Compute Call and Put Gamma :
        greek = put.gamma = exp(-r.daily*Time.inDays) * gamma1$value -
            X * exp(-r.daily*Time.inDays) * gamma2$value }

    # Return Value:
    greek
}


.fdeltaHN <-
function(phi, const, model, S, X, Time.inDays, r.daily)
{
    # Function to be integrated:
    cphi0 = phi * complex(real = 0, imaginary = 1)
    cphi = cphi0 + const
    fdelta = cphi *
        .fHN(phi, const, model, S, X, Time.inDays, r.daily) / S

    # Return Value:
    Re(fdelta)
}


.fgammaHN <-
function(phi, const, model, S, X, Time.inDays, r.daily)
{
    # Function to be integrated:
    cphi0 = phi * complex(real = 0, imaginary = 1)
    cphi = cphi0 + const
    fgamma = cphi * ( cphi - 1 ) *
        .fHN(phi, const, model, S, X, Time.inDays, r.daily) / S^2

    # Return Value:
    Re(fgamma)
}



.fHN <-
function(phi, const, model, S, X, Time.inDays, r.daily)
{
    # Internal Function:

    # Model Parameters:
    lambda = -1/2
    omega = model$omega
    alpha = model$alpha
    gamma = model$gamma + model$lambda + 1/2
    beta = model$beta
    sigma2 = (omega + alpha)/(1 - beta - alpha * gamma^2)
    # Function to be integrated:
    cphi0 = phi*complex(real = 0, imaginary = 1)
    cphi = cphi0 + const
    a = cphi * r.daily
    b = lambda*cphi + cphi*cphi/2
    for (i in 2:Time.inDays) {
        a = a + cphi*r.daily + b*omega - log(1-2*alpha*b)/2
        b = cphi*(lambda+gamma) - gamma^2/2 + beta*b +
            0.5*(cphi-gamma)^2/(1-2*alpha*b) }
    fun = exp(-cphi0*log(X)+cphi*log(S)+a+b*sigma2)/cphi0/pi

    # Return Value:
    fun
}


# ------------------------------------------------------------------------------


HNGCharacteristics =
function(TypeFlag = c("c", "p"), model, S, X, Time.inDays, r.daily)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   The function calculates the option price for the Heston
    #   Nandi Garch(1,1) option model together with the delta
    #   and gamma option sensitivies.

    # FUNCTION:

    # Premium and Function Call to all Greeks
    TypeFlag = TypeFlag[1]
    premium = HNGOption(TypeFlag, model, S, X, Time.inDays, r.daily)
    delta = HNGGreeks("Delta", TypeFlag, model, S, X, Time.inDays, r.daily)
    gamma = HNGGreeks("Gamma", TypeFlag, model, S, X, Time.inDays, r.daily)

    # Return Value:
    list(premium = premium, delta = delta, gamma = gamma)
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################
# FUNCTION:                  DESCRIPTION:
#  'fOPTION'                  S4 Class Representation
# FUNCTION:                  DESCRIPTION:
#  NDF                        Normal distribution function
#  CND                        Cumulative normal distribution function
#  CBND                       Cumulative bivariate normal distribution
# FUNCTION:                  DESCRIPTION:
#  GBSOption                  Computes Option Price from the GBS Formula
#  GBSCharacteristics         Computes Option Price and all Greeks of GBS Model
#   BlackScholesOption         Synonyme Function Call to GBSOption
#  GBSGreeks                  Computes one of the Greeks of the GBS formula
# FUNCTION:                  DESCRIPTION:
#  Black76Option              Computes Prices of Options on Futures
#  MiltersenSchwartzOption    Pricing a Miltersen Schwartz Option
# S3 METHODS:                DESCRIPTION:
#  print.option               Print Method
#  summary.otion              Summary Method
################################################################################


setClass("fOPTION",
    representation(
        call = "call",
        parameters = "list",
        price = "numeric",
        title = "character",
        description = "character"
    )
)


################################################################################


NDF =
function(x)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Calculate the normal distribution function.

    # FUNCTION:

    # Compute:
    result = exp(-x*x/2)/sqrt(8*atan(1))

    # Return Value:
    result
}


# ------------------------------------------------------------------------------


CND =
function(x)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Calculate the cumulated normal distribution function.

    # References:
    #   Haug E.G., The Complete Guide to Option Pricing Formulas

    # FUNCTION:

    # Compute:
    k  = 1 / ( 1 + 0.2316419 * abs(x) )
    a1 =  0.319381530; a2 = -0.356563782; a3 =  1.781477937
    a4 = -1.821255978; a5 =  1.330274429
    result = NDF(x) * (a1*k + a2*k^2 + a3*k^3 + a4*k^4 + a5*k^5) - 0.5
    result = 0.5 - result*sign(x)

    # Return Value:
    result
}


# ------------------------------------------------------------------------------


CBND =
function(x1, x2, rho)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Calculate the cumulative bivariate normal distribution function.

    # References:
    #   Haug E.G., The Complete Guide to Option Pricing Formulas

    # FUNCTION:

    # Compute:
    # Take care for the limit rho = +/- 1
    a = x1
    b = x2
    if (abs(rho) == 1) rho = rho - (1e-12)*sign(rho)
    # cat("\n a - b - rho :"); print(c(a,b,rho))
    X = c(0.24840615, 0.39233107, 0.21141819, 0.03324666, 0.00082485334)
    y = c(0.10024215, 0.48281397, 1.0609498, 1.7797294, 2.6697604)
    a1 = a / sqrt(2 * (1 - rho^2))
    b1 = b / sqrt(2 * (1 - rho^2))
    if (a <= 0 && b <= 0 && rho <= 0) {
       Sum1 = 0
       for (I in 1:5) {
            for (j in 1:5) {
            Sum1 = Sum1 + X[I] * X[j] *
              exp(a1*(2*y[I]-a1) + b1*(2*y[j]-b1) +
              2*rho*(y[I]-a1)*(y[j]-b1)) } }
       result = sqrt(1 - rho^2) / pi * Sum1
       return(result) }
    if (a <= 0 && b >= 0 && rho >= 0) {
        result = CND(a) - CBND(a, -b, -rho)
        return(result) }
    if (a >= 0 && b <= 0 && rho >= 0) {
        result = CND(b) - CBND(-a, b, -rho)
        return(result) }
    if (a >= 0 && b >= 0 && rho <= 0) {
        result = CND(a) + CND(b) - 1 + CBND(-a, -b, rho)
        return(result) }
    if (a * b * rho >= 0 ) {
        rho1 = (rho*a - b) * sign(a) / sqrt(a^2 - 2*rho*a*b + b^2)
        rho2 = (rho*b - a) * sign(b) / sqrt(a^2 - 2*rho*a*b + b^2)
        delta = (1 - sign(a) * sign(b)) / 4
        result = CBND(a, 0, rho1) + CBND(b, 0, rho2) - delta
        return(result) }

    # Return Value:
    invisible()
}


# ******************************************************************************


GBSOption =
function(TypeFlag = c("c", "p"), S, X, Time, r, b, sigma, title = NULL,
description = NULL)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Calculate the Generalized Black-Scholes option
    #   price either for a call or a put option.

    # References:
    #   Haug E.G., The Complete Guide to Option Pricing Formulas

    # FUNCTION:

    # Compute:
    TypeFlag = TypeFlag[1]
    d1 = ( log(S/X) + (b+sigma*sigma/2)*Time ) / (sigma*sqrt(Time))
    d2 = d1 - sigma*sqrt(Time)
    if (TypeFlag == "c")
        result = S*exp((b-r)*Time)*CND(d1) - X*exp(-r*Time)*CND(d2)
    if (TypeFlag == "p")
        result = X*exp(-r*Time)*CND(-d2) - S*exp((b-r)*Time)*CND(-d1)

    # Parameters:
    param = list()
    param$TypeFlag = TypeFlag
    param$S = S
    param$X = X
    param$Time = Time
    param$r = r
    param$b = b
    param$sigma = sigma

    # Add title and description:
    if (is.null(title)) title = "Black Scholes Option Valuation"
    if (is.null(description)) description = as.character(date())

    # Return Value:
    new("fOPTION",
        call = match.call(),
        parameters = param,
        price = result,
        title = title,
        description = description
        )
}


# ------------------------------------------------------------------------------


GBSCharacteristics =
function(TypeFlag = c("c", "p"), S, X, Time, r, b, sigma)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Calculate the Options Characterisitics (Premium
    #   and Greeks for a Generalized Black-Scholes option
    #   either for a call or a put option.

    # References:
    #   Haug E.G., The Complete Guide to Option Pricing Formulas

    # FUNCTION:

    # Premium and Function Call to all Greeks
    TypeFlag = TypeFlag[1]
    premium = GBSOption(TypeFlag, S, X, Time, r, b, sigma)@price
    delta = GBSGreeks("Delta", TypeFlag, S, X, Time, r, b, sigma)
    theta = GBSGreeks("Theta", TypeFlag, S, X, Time, r, b, sigma)
    vega = GBSGreeks("Vega", TypeFlag, S, X, Time, r, b, sigma)
    rho = GBSGreeks("Rho", TypeFlag, S, X, Time, r, b, sigma)
    lambda = GBSGreeks("Lambda", TypeFlag, S, X, Time, r, b, sigma)
    gamma = GBSGreeks("Gamma", TypeFlag, S, X, Time, r, b, sigma)

    # Return Value:
    list(premium = premium, delta = delta, theta = theta,
        vega = vega, rho = rho, lambda = lambda, gamma = gamma)
}


# ------------------------------------------------------------------------------


BlackScholesOption =
function(...)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   A synonyme for GBSOption

    # FUNCTION:

    # Return Value:
    GBSOption(...)
}



# ******************************************************************************


GBSGreeks =
function(Selection = c("Delta", "Theta", "Vega", "Rho", "Lambda", "Gamma",
"CofC"), TypeFlag = c("c", "p"), S, X, Time, r, b, sigma)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Calculate the Options Greeks for a Generalized
    #   Black-Scholes option either for a call or a put option.

    # References:
    #   Haug E.G., The Complete Guide to Option Pricing Formulas

    # FUNCTION:

    # Settings:
    TypeFlag = TypeFlag[1]
    Selection = Selection[1]

    # Function Call to all Greeks via selection parameter
    result = NA
    if (Selection == "Delta" || Selection == "delta")
            result = .GBSDelta (TypeFlag, S, X, Time, r, b, sigma)
    if (Selection == "Theta" || Selection == "theta")
            result = .GBSTheta (TypeFlag, S, X, Time, r, b, sigma)
    if (Selection == "Vega" || Selection == "vega")
            result = .GBSVega  (TypeFlag, S, X, Time, r, b, sigma)
    if (Selection == "Rho" || Selection == "rho")
            result = .GBSRho   (TypeFlag, S, X, Time, r, b, sigma)
    if (Selection == "Lambda" || Selection == "lambda")
            result = .GBSLambda(TypeFlag, S, X, Time, r, b, sigma)
    if (Selection == "Gamma" || Selection == "gamma")
            result = .GBSGamma (TypeFlag, S, X, Time, r, b, sigma)
    if (Selection == "CofC" || Selection == "cofc")
            result = .GBSCofC  (TypeFlag, S, X, Time, r, b, sigma)

    # Return Value:
    result
}


# Internal Functions:

.GBSDelta <-
function(TypeFlag, S, X, Time, r, b, sigma)
{
    d1 = ( log(S/X) + (b+sigma*sigma/2)*Time ) / (sigma*sqrt(Time))
    if (TypeFlag == "c") result = exp((b-r)*Time)*CND(d1)
    if (TypeFlag == "p") result = exp((b-r)*Time)*(CND(d1)-1)
    result
}


.GBSTheta <-
function(TypeFlag, S, X, Time, r, b, sigma)
{
    d1 = ( log(S/X) + (b+sigma*sigma/2)*Time ) / (sigma*sqrt(Time))
    d2 = d1 - sigma*sqrt(Time)
    Theta1 = -(S*exp((b-r)*Time)*NDF(d1)*sigma)/(2*sqrt(Time))
    if (TypeFlag == "c") result = Theta1 -
        (b-r)*S*exp((b-r)*Time)*CND(+d1) - r*X*exp(-r*Time)*CND(+d2)
    if (TypeFlag == "p") result = Theta1 +
        (b-r)*S*exp((b-r)*Time)*CND(-d1) + r*X*exp(-r*Time)*CND(-d2)
    result
}


.GBSVega <-
function(TypeFlag, S, X, Time, r, b, sigma)
{
    d1 = ( log(S/X) + (b+sigma*sigma/2)*Time ) / (sigma*sqrt(Time))
    result = S*exp((b-r)*Time)*NDF(d1)*sqrt(Time) # Call,Put
    result
}


.GBSRho <-
function(TypeFlag, S, X, Time, r, b, sigma)
{
    d1 = ( log(S/X) + (b+sigma*sigma/2)*Time ) / (sigma*sqrt(Time))
    d2 = d1 - sigma*sqrt(Time)
    CallPut = GBSOption(TypeFlag, S, X, Time, r, b , sigma)@price
    if (TypeFlag == "c") {
        if (b != 0) {result =  Time * X * exp(-r*Time)*CND( d2)}
        else {result = -Time * CallPut } }
    if (TypeFlag == "p") {
        if (b != 0) {result = -Time * X * exp(-r*Time)*CND(-d2)}
        else { result = -Time * CallPut } }
    result
}


.GBSLambda <-
function(TypeFlag, S, X, Time, r, b, sigma)
{
    d1 = ( log(S/X) + (b+sigma*sigma/2)*Time ) / (sigma*sqrt(Time))
    CallPut = GBSOption(TypeFlag,S,X,Time,r,b,sigma)@price
    if (TypeFlag == "c") result = exp((b-r)*Time)* CND(d1)*S / CallPut
    if (TypeFlag == "p") result = exp((b-r)*Time)*(CND(d1)-1)*S / CallPut
    result
}


.GBSGamma <-
function(TypeFlag, S, X, Time, r, b, sigma)
{
    d1 = ( log(S/X) + (b+sigma*sigma/2)*Time ) / (sigma*sqrt(Time))
    result = exp((b-r)*Time)*NDF(d1)/(S*sigma*sqrt(Time)) # Call,Put
    result
}


.GBSCofC <-
function(TypeFlag, S, X, Time, r, b, sigma)
{
    d1 = ( log(S/X) + (b+sigma*sigma/2)*Time ) / (sigma*sqrt(Time))
    if (TypeFlag == "c") result = Time*S*exp((b-r)*Time)*CND(d1)
    if (TypeFlag == "p") result = -Time*S*exp((b-r)*Time)*CND(-d1)
    result }


# ------------------------------------------------------------------------------


Black76Option =
function(TypeFlag = c("c", "p"), FT, X, Time, r, sigma, title = NULL,
description = NULL)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Calculate Options Price for Black (1977) Options
    #   on futures/forwards

    # References:
    #   Haug E.G., The Complete Guide to Option Pricing Formulas

    # FUNCTION:

    # Settings:
    TypeFlag = TypeFlag[1]

    # Result:
    result = GBSOption(TypeFlag = TypeFlag, S = FT, X = X, Time = Time,
        r = r, b = 0, sigma = sigma)@price

    # Parameters:
    param = list()
    param$TypeFlag = TypeFlag
    param$FT = FT
    param$X = X
    param$Time = Time
    param$r = r
    param$sigma = sigma

    # Add title and description:
    if (is.null(title)) title = "Black 76 Option Valuation"
    if (is.null(description)) description = as.character(date())

    # Return Value:
    new("fOPTION",
        call = match.call(),
        parameters = param,
        price = result,
        title = title,
        description = description
        )
}


# ******************************************************************************


MiltersenSchwartzOption =
function (TypeFlag = c("c", "p"), Pt, FT, X, time, Time, sigmaS, sigmaE,
sigmaF, rhoSE, rhoSF, rhoEF, KappaE, KappaF, title = NULL,
description = NULL)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Miltersen Schwartz (1997) commodity option model.

    # References:
    #   Haug E.G., The Complete Guide to Option Pricing Formulas

    # FUNCTION:

    # Settings:
    TyoeFlag = TypeFlag[1]

    # Compute:
    vz = sigmaS^2*time+2*sigmaS*(sigmaF*rhoSF*1/KappaF*(time-1/KappaF*
      exp(-KappaF*Time)*(exp(KappaF*time)-1))-sigmaE*rhoSE*1/KappaE*
      (time-1/KappaE*exp(-KappaE*Time)*(exp(KappaE*time)-1)))+sigmaE^2*
      1/KappaE^2*(time+1/(2*KappaE)*exp(-2*KappaE*Time)*(exp(2*KappaE*time)-
      1)-2*1/KappaE*exp(-KappaE*Time)*(exp(KappaE*time)-1))+sigmaF^2*
      1/KappaF^2*(time+1/(2*KappaF)*exp(-2*KappaF*Time)*(exp(2*KappaF*time)-
      1)-2*1/KappaF*exp(-KappaF*Time)*(exp(KappaF*time)-1))-2*sigmaE*
      sigmaF*rhoEF*1/KappaE*1/KappaF*(time-1/KappaE*exp(-KappaE*Time)*
      (exp(KappaE*time)-1)-1/KappaF*exp(-KappaF*Time)*(exp(KappaF*time)-
      1)+1/(KappaE+KappaF)*exp(-(KappaE+KappaF)*Time)*(exp((KappaE+KappaF)*
      time)-1))
    vxz = sigmaF*1/KappaF*(sigmaS*rhoSF*(time-1/KappaF*(1-exp(-KappaF*
      time)))+sigmaF*1/KappaF*(time-1/KappaF*exp(-KappaF*Time)*(exp(KappaF*
      time)-1)-1/KappaF*(1-exp(-KappaF*time))+1/(2*KappaF)*exp(-KappaF*
      Time)*(exp(KappaF*time)-exp(-KappaF*time)))-sigmaE*rhoEF*1/KappaE*
      (time-1/KappaE*exp(-KappaE*Time)*(exp(KappaE*time)-1)-1/KappaF*(1-
      exp(-KappaF*time))+1/(KappaE+KappaF)*exp(-KappaE*Time)*
      (exp(KappaE*time)-exp(-KappaF*time))))
    vz = sqrt(vz)
    d1 = (log(FT/X)-vxz+vz^2/2)/vz
    d2 = (log(FT/X)-vxz-vz^2/2)/vz

    # Call/Put:
    if (TypeFlag == "c") {
        result = Pt*(FT*exp(-vxz)*CND(d1)-X*CND(d2)) }
    if (TypeFlag == "p") {
        result = Pt*(X*CND(-d2)-FT*exp(-vxz)*CND(-d1)) }

    # Parameters:
    param = list()
    param$TypeFlag = TypeFlag
    param$Pt = Pt
    param$FT = FT
    param$X = X
    param$time = time
    param$Time = Time
    param$sigmaS = sigmaS
    param$sigmaE = sigmaE
    param$sigmaF = sigmaF
    param$rhoSE = rhoSE
    param$rhoSF = rhoSF
    param$rhoEF = rhoEF
    param$KappaE = KappaE
    param$KappaF = KappaF

    # Add title and description:
    if (is.null(title)) title = "Miltersen Schwartz Option Valuation"
    if (is.null(description)) description = as.character(date())

    # Return Value:
    new("fOPTION",
        call = match.call(),
        parameters = param,
        price = result,
        title = title,
        description = description
        )
}


# ******************************************************************************


GBSVolatility = function(price, TypeFlag = c("c", "p"), S, X, Time, r, b,
tol = .Machine$double.eps, maxiter = 10000)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Compute implied volatility

    # Example:
    #   sigma = GBSVolatility(price=10.2, "c", S=100, X=90, Time=1/12, r=0, b=0)
    #   sigma
    #   GBSOption("c", S=100, X=90, Time=1/12, r=0, b=0, sigma=sigma)@price

    # FUNCTION:

    # Option Type:
    TypeFlag = TypeFlag[1]

    # Search for Root:
    volatility = uniroot(.fGBSVolatility, interval = c(-10,10), price = price,
        TypeFlag = TypeFlag, S = S, X = X, Time = Time, r = r, b = b,
        tol = tol, maxiter = maxiter)$root

    # Return Value:
    volatility
}



# Internal Function:
.fGBSVolatility <-
function(x, price, TypeFlag, S, X, Time, r, b, ...)
{
    GBS = GBSOption(TypeFlag = TypeFlag, S = S, X = X, Time = Time,
        r = r, b = b, sigma = x)@price
    price - GBS
}


# ------------------------------------------------------------------------------


print.option =
function(x, ...)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Print method for objects of class "option".

    # FUNCTION:

    # Print Method:
    object = x
    cat("\nCall:", deparse(object$call), "", sep = "\n")
    cat("Option Price:\n")
    cat(object$price, "\n")
}


# ------------------------------------------------------------------------------


summary.option =
function(object, ...)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Summary method for objects of class "option".

    # FUNCTION:

    # Summary Method:
    print(object, ...)
}


################################################################################



setMethod("show", "fOPTION",
    function(object)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Print method for objects of class "fOPTION".

    # FUNCTION:

    # Print Method:
    Parameter = unlist(object@parameters)
    Names = names(Parameter)
    Parameter = cbind(as.character(Parameter))
    rownames(Parameter) = paste("", Names)
    colnames(Parameter) = "Value:"

    # Title:
    cat("\nTitle:\n ")
    cat(object@title, "\n")

    # Call:
    cat("\nCall:", paste("", deparse(object@call)), "", sep = "\n")

    # Parameters:
    cat("Parameters:\n")
    print(Parameter, quote = FALSE)

    # Price:
    cat("\nOption Price:\n ")
    cat(object@price, "\n")

    # Description:
    cat("\nDescription:\n ")
    cat(object@description, "\n\n")

    # Return Value:
    invisible()
})


# ------------------------------------------------------------------------------


summary.fOPTION =
function(object, ...)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Summary method for objects of class "option".

    # FUNCTION:

    # Summary Method:
    print(object, ...)
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA


###############################################################################
# FUNCTION:                 DESCRIPTION:
#  CRRBinomialTreeOption     Cox-Ross-Rubinstein Binomial Tree Option Model
#  JRBinomialTreeOption      JR Modfication to the Binomial Tree Option
#  TIANBinomialTreeOption    Tian's Modification to the Binomial Tree Option
# FUNCTION:
#  BinomialTreeOption        CRR Binomial Tree Option with Cost of Carry Term
#  BinomialTreePlot          Plots results from the CRR Option Pricing Model
###############################################################################


CRRBinomialTreeOption = 
function(TypeFlag = c("ce", "pe", "ca", "pa"), S, X, Time, r, b, sigma, n,
title = NULL, description = NULL)
{   # A function implemented by Diethelm Wuertz           
    
    # Description:
    #   Cox-Ross-Rubinstein Binomial Tree Option Model
    
    # FUNCTION:
    
    # Check Flags:
    TypeFlag = TypeFlag[1]
    z = NA
    if (TypeFlag == "ce" || TypeFlag == "ca") z = +1
    if (TypeFlag == "pe" || TypeFlag == "pa") z = -1
    if (is.na(z)) stop("TypeFlag misspecified: ce|ca|pe|pa")
  
    # Parameters:
    dt = Time/n
    u  = exp(sigma*sqrt(dt))
    d  = 1/u
    p  = (exp(b*dt)-d)/(u-d)
    Df = exp(-r*dt)
    
    # Iteration:
    OptionValue = z*(S*u^(0:n)*d^(n:0) - X)
    OptionValue = (abs(OptionValue) + OptionValue) / 2
    
    # European Option:
    if (TypeFlag == "ce" || TypeFlag == "pe") {
        for ( j in seq(from = n-1, to = 0, by = -1) ) 
            for ( i in 0:j )         
                OptionValue[i+1] = 
                (p*OptionValue[i+2] + (1-p)*OptionValue[i+1]) * Df }
    
    # American Option:
    if (TypeFlag == "ca" || TypeFlag == "pa") {
        for ( j in seq(from = n-1, to = 0, by = -1) )  
            for ( i in 0:j )  
                OptionValue[i+1] = max((z * (S*u^i*d^(abs(i-j)) - X)), 
                    (p*OptionValue[i+2] + (1-p)*OptionValue[i+1]) * Df) }
    
    # Return Value:
    
    
    # Parameters:
    # TypeFlag = c("ce", "pe", "ca", "pa"), S, X, Time, r, b, sigma, n
    param = list()
    param$TypeFlag = TypeFlag
    param$S = S
    param$X = X
    param$Time = Time
    param$r = r
    param$b = b
    param$sigma = sigma
    param$n = n
    
    # Add title and description:
    if (is.null(title)) title = "CRR Binomial Tree Option"
    if (is.null(description)) description = as.character(date())
    
    # Return Value:
    new("fOPTION", 
        call = match.call(),
        parameters = param,
        price = OptionValue[1], 
        title = title,
        description = description
        )     
}


# ------------------------------------------------------------------------------


JRBinomialTreeOption = 
function(TypeFlag = c("ce", "pe", "ca", "pa"), S, X, Time, r, b, sigma, n,
title = NULL, description = NULL)
{   # A function implemented by Diethelm Wuertz           
    
    # Description:
    #   JR Modfication to the Binomial Tree Option
    
    # FUNCTION:
    
    # Check Flags:
    TypeFlag = TypeFlag[1]
    if (TypeFlag == "ce" || TypeFlag == "ca") z = +1
    if (TypeFlag == "pe" || TypeFlag == "pa") z = -1
    
    # Parameters:
    dt = Time/n
    # DW Bug Fix: r -> b
    u = exp( (b-sigma^2/2)*dt+sigma*sqrt(dt) )
    d = exp( (b-sigma^2/2)*dt-sigma*sqrt(dt) )
    # DW End of Bug Fix
    p = 1/2
    Df = exp(-r*dt)
    
    # Iteration:
    OptionValue = z*(S*u^(0:n)*d^(n:0) - X)
    OptionValue = (abs(OptionValue) + OptionValue) / 2
    
    # European Option:
    if (TypeFlag == "ce" || TypeFlag == "pe") {
        for ( j in seq(from = n-1, to = 0, by = -1) ) 
            for ( i in 0:j )         
                OptionValue[i+1] = 
                (p*OptionValue[i+2] + (1-p)*OptionValue[i+1]) * Df }
    
                # American Option:
    if (TypeFlag == "ca" || TypeFlag == "pa") {
        for ( j in seq(from = n-1, to=0, by = -1) )  
            for ( i in 0:j )  
                OptionValue[i+1] = max((z * (S*u^i*d^(abs(i-j)) - X)), 
                    (p*OptionValue[i+2] + (1-p)*OptionValue[i+1]) * Df) }
    
    # Return Value:
    OptionValue[1]
    
    # Parameters:
    # TypeFlag = c("ce", "pe", "ca", "pa"), S, X, Time, r, b, sigma, n
    param = list()
    param$TypeFlag = TypeFlag
    param$S = S
    param$X = X
    param$Time = Time
    param$r = r
    param$b = b
    param$sigma = sigma
    param$n = n
    
    # Add title and description:
    if (is.null(title)) title = "JR Binomial Tree Option"
    if (is.null(description)) description = as.character(date())
    
    # Return Value:
    new("fOPTION", 
        call = match.call(),
        parameters = param,
        price = OptionValue[1], 
        title = title,
        description = description
        )     
}


# ------------------------------------------------------------------------------


TIANBinomialTreeOption = 
function(TypeFlag = c("ce", "pe", "ca", "pa"), S, X, Time, r, b, sigma, n,
title = NULL, description = NULL)
{   # A function implemented by Diethelm Wuertz           
    
    # Description:
    #   Tian's Modification to the Binomial Tree Option
    
    # FUNCTION:
    
    # Check Flags:
    TypeFlag = TypeFlag[1]
    if (TypeFlag == "ce" || TypeFlag == "ca") z = +1
    if (TypeFlag == "pe" || TypeFlag == "pa") z = -1  
    
    # Parameters:
    dt = Time/n 
    M = exp ( b*dt )
    V = exp ( sigma^2 * dt )
    u = (M*V/2) * ( V + 1 + sqrt(V*V + 2*V - 3) )
    d = (M*V/2) * ( V + 1 - sqrt(V*V + 2*V - 3) )
    p = (M-d)/(u-d)
    Df = exp(-r*dt)
    
    # Iteration:
    OptionValue = z*(S*u^(0:n)*d^(n:0) - X)
    OptionValue = (abs(OptionValue) + OptionValue) / 2
    
    # European Option:
    if (TypeFlag == "ce" || TypeFlag == "pe") {
        for ( j in seq(from = n-1, to = 0, by = -1) ) 
            for ( i in 0:j )         
                OptionValue[i+1] = 
                (p*OptionValue[i+2] + (1-p)*OptionValue[i+1]) * Df }
    
    # American Option:
    if (TypeFlag == "ca" || TypeFlag == "pa") {
        for ( j in seq(from = n-1, to = 0, by = -1) )  
            for ( i in 0:j )  
                OptionValue[i+1] = max((z * (S*u^i*d^(abs(i-j)) - X)), 
                    (p*OptionValue[i+2] + (1-p)*OptionValue[i+1]) * Df) }
                    
    # Return Value:
    OptionValue[1]
    
    # Parameters:
    # TypeFlag = c("ce", "pe", "ca", "pa"), S, X, Time, r, b, sigma, n
    param = list()
    param$TypeFlag = TypeFlag
    param$S = S
    param$X = X
    param$Time = Time
    param$r = r
    param$b = b
    param$sigma = sigma
    param$n = n
    
    # Add title and description:
    if (is.null(title)) title = "TIAN Binomial Tree Option"
    if (is.null(description)) description = as.character(date())
    
    # Return Value:
    new("fOPTION", 
        call = match.call(),
        parameters = param,
        price = OptionValue[1], 
        title = title,
        description = description
        )     
}


# ******************************************************************************


BinomialTreeOption = 
function(TypeFlag = c("ce", "pe", "ca", "pa"), S, X, Time, r, b, sigma, n,
title = NULL, description = NULL)
{   # A function implemented by Diethelm Wuertz           
    
    # Description:
    #   Calculates option prices from the Cox-Ross-Rubinstein
    #   Binomial tree model.
    
    # Note:
    #   The model described here is a version of the CRR Binomial
    #   Tree model. Including a cost of carry term b, the model can
    #   used to price European and American Options on
    #     b=r       stocks
    #     b=r-q     stocks and stock indexes paying a continuous  
    #               dividend yield q
    #     b=0       futures
    #     b=r-rf    currency options with foreign interst rate rf
    
    # Example:
    #   par(mfrow=c(1,1))
    #   Tree = BinomialTree("pa", 100, 95, 0.5, 0.08, 0.08, 0.3, 5)
    #   print(round(Tree, digits=3))
    #   BinomialTreePlot(Tree, main="American Put Option")
    #
    # Reference:
    #   E.G. Haug, The Complete Guide to Option Pricing Formulas, 
    #   1997, Chapter 3.1.1
    
    # FUNCTION:
    
    # Check Flags:
    TypeFlag = TypeFlag[1]
    if (TypeFlag == "ce" || TypeFlag == "ca") z = +1
    if (TypeFlag == "pe" || TypeFlag == "pa") z = -1    
    
    # Parameters:
    dt = Time / n
    u  = exp(sigma*sqrt(dt))
    d  = 1 / u
    p  = (exp(b*dt) - d) / (u - d)
    Df = exp(-r*dt)
    
    # Algorithm:
    OptionValue = z*(S*u^(0:n)*d^(n:0) - X)
    offset = 1
    Tree = OptionValue = (abs(OptionValue)+OptionValue)/2   
    
    # European Type:
    if (TypeFlag == "ce" || TypeFlag == "pe") {
        for (j in (n-1):0) {
            Tree <-c(Tree, rep(0, times=n-j))
            for (i in 0:j) {         
                OptionValue[i+offset] = 
                    (p*OptionValue[i+1+offset] + 
                (1-p)*OptionValue[i+offset]) * Df 
                Tree = c(Tree, OptionValue[i+offset]) } } }
                
    # American Type:
    if (TypeFlag == "ca" || TypeFlag == "pa") {
        for (j in (n-1):0) { 
            Tree <-c(Tree, rep(0, times=n-j))
            for (i in 0:j) { 
                OptionValue[i+offset] = 
                max((z * (S*u^i*d^(abs(i-j)) - X)), 
                        (p*OptionValue[i+1+offset] + 
                (1-p)*OptionValue[i+offset]) * Df ) 
                Tree = c(Tree, OptionValue[i+offset]) } } } 
                
    # Tree-Matrix of form (here n=4):
    # x x x x
    # . x x x
    # . . x x
    # . . . x
    Tree = matrix(rev(Tree), byrow = FALSE, ncol = n+1)
    
    # Tree Output:
    # if (doprint) print(Tree)
    
    # Parameters:
    # TypeFlag = c("ce", "pe", "ca", "pa"), S, X, Time, r, b, sigma, n
    # param = list()
    # param$TypeFlag = TypeFlag
    # param$S = S
    # param$X = X
    # param$Time = Time
    # param$r = r
    # param$b = b
    # param$sigma = sigma
    # param$n = n
    
    # Add title and description:
    # if (is.null(title)) title = "Binomial Tree Option"
    # if (is.null(description)) description = as.character(date())
    
    # Return Value:
    # new("fOPTION", 
    #    call = match.call(),
    #    parameters = param,
    #    price = Tree[1], 
    #    title = title,
    #    description = description
    #    )
    
    # Return Value:
    invisible(Tree)     
}


# ------------------------------------------------------------------------------


BinomialTreePlot = 
function(BinomialTreeValues, dx = -0.025, dy = 0.4, cex = 1, digits = 2, ...) 
{   # A function implemented by Diethelm Wuertz           
    
    # Description:
    #   Plots the binomial tree of the Cox-Ross-Rubinstein
    #   binomial tree model.
    
    # Example:
    #   par(mfrow=c(1,1))
    #   Tree = BinomialTree("a", "p", 100, 95, 0.5, 0.08, 0.08, 0.3, 5)
    #   print(round(Tree, digits = 3))
    #   BinomialTreePlot(Tree, main = "American Put Option")

    # FUNCTION:
    
    # Tree:
    Tree = round(BinomialTreeValues, digits = digits)
    depth = ncol(Tree)
    plot(x = c(1,depth), y = c(-depth+1, depth-1), type = "n", col = 0, ...)
    points(x = 1, y = 0)
    text(1+dx, 0+dy, deparse(Tree[1, 1]), cex = cex)
    for (i in 1:(depth-1) ) {
        y = seq(from = -i, by = 2, length = i+1)
        x = rep(i, times = length(y))+1
        points(x, y, col = 1) 
        for (j in 1:length(x))
            text(x[j]+dx, y[j]+dy, deparse(Tree[length(x)+1-j,i+1]), cex = cex)   
        y = (-i):i
        x = rep(c(i+1,i), times = 2*i)[1:length(y)]
        lines(x, y, col = 2)
    }
    
    # Return Value:
    invisible()
}


# --- 3.1.2 --------------------------------------------------------------------


# Options on a Stock Paying a Known Dividend Yield
# not yet implemented


# --- 3.1.3 --------------------------------------------------------------------


# BarrierBinomialTree
# not yet implemented


# --- 3.1.4 --------------------------------------------------------------------


# ConvertibleBond
# not yet implemented


# --- 3.2 ----------------------------------------------------------------------


# TrinomialTree
# not yet implemented


# --- 3.3 ----------------------------------------------------------------------


# ThreeDimensionalBinomialTree
# PayoffFunction
# not yet implemented


# --- 3.4.1 --------------------------------------------------------------------


# ImpliedBinomialTree
# not yet implemented


# --- 3.4.2 --------------------------------------------------------------------


# ImpliedTrinomialTree
# not yet implemented


# ******************************************************************************

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA


###############################################################################


.fOptionsEnv <- new.env(hash = TRUE)

.setfOptionsEnv <-
    function(...)
{
    x <- list(...)
    nm <- names(x)
     if (is.null(nm) || "" %in% nm)
        stop("all arguments must be named")
    sapply(nm, function(nm) assign(nm, x[[nm]],
                                 envir = .fOptionsEnv))
    invisible()
}

.getfOptionsEnv <-
    function(x = NULL, unset = "")
{
    if (is.null(x))
        x <- ls(all.names = TRUE, envir = .fOptionsEnv)
###     unlist(mget(x, envir = .fOptionsEnv, mode = "any",
###                 ifnotfound = as.list(unset)), recursive = FALSE)
    get(x, envir = .fOptionsEnv, mode = "any")
}


###############################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA

# Copyrights (C)
# for this R-port: 
#   1999 - 2007, Diethelm Wuertz, GPL
#   Diethelm Wuertz <wuertz@itp.phys.ethz.ch>
#   info@rmetrics.org
#   www.rmetrics.org
# for the code accessed (or partly included) from other R-ports:
#   see R's copyright and license files
# for the code accessed (or partly included) from contributed R-ports
# and other sources
#   see Rmetrics's copyright file


################################################################################
# FUNCTION:           DESCRIPTION:
#  HNGOption           Computes Option Price from the HN-GARCH Formula
#  HNGGreeks           Calculates one of the Greeks of the HN-GARCH Formula
#  HNGCharacteristics  Computes Option Price and all Greeks of HN-GARCH Model
################################################################################


test.HNGOption = 
function()
{
    # HNGOption - Computes Option Price from the HN-GARCH Formula
    
    # Define the Model Parameters for a Heston-Nandi Option:
    model = list(lambda = -0.5, omega = 2.3e-6, alpha = 2.9e-6, 
        beta = 0.85, gamma = 184.25) 
    S = X = 100
    Time.inDays = 252
    r.daily = 0.05/Time.inDays
    sigma.daily = sqrt((model$omega + model$alpha) /
        (1 - model$beta - model$alpha * model$gamma^2))
    data.frame(S, X, r.daily, sigma.daily)
    
    # HNGOption:
    
    # Compute HNG Call-Put and compare with GBS Call-Put:
    HNG = GBS = Diff = NULL
    for (TypeFlag in c("c", "p")) {
        HNG = c(HNG, HNGOption(TypeFlag, model = model, S = S, X = X, 
            Time.inDays = Time.inDays, r.daily = r.daily)$price )
        GBS = c(GBS, GBSOption(TypeFlag, S = S, X = X, Time = Time.inDays, 
            r = r.daily, b = r.daily, sigma = sigma.daily)@price) 
    }
    Options = cbind(HNG, GBS, Diff = round(100*(HNG-GBS)/GBS, digits = 2))
    row.names(Options) <- c("Call", "Put")
    data.frame(Options)
    
    # TODO: HNG not yet a S4 Class Member !!!

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.HNGGreeks = 
function()
{       
    # HNGGreeks - Calculates one of the Greeks of the HN-GARCH Formula
    
    # Define the Model Parameters for a Heston-Nandi Option:
    model = list(lambda = -0.5, omega = 2.3e-6, alpha = 2.9e-6, 
        beta = 0.85, gamma = 184.25) 
    S = X = 100
    Time.inDays = 252
    r.daily = 0.05/Time.inDays
    sigma.daily = sqrt((model$omega + model$alpha) /
        (1 - model$beta - model$alpha * model$gamma^2))
    data.frame(S, X, r.daily, sigma.daily)
    
    # Compute HNG Greeks and compare with GBS Greeks:
    Selection = c("Delta", "Gamma")
    HNG = GBS = NULL
    for (i in 1:2){
        HNG = c(HNG, HNGGreeks(Selection[i], TypeFlag = "c", model = model, 
            S = 100, X = 100, Time = Time.inDays, r = r.daily)) 
        GBS = c(GBS, GBSGreeks(Selection[i], TypeFlag = "c", S = 100, X = 100, 
            Time = Time.inDays, r = r.daily, b = r.daily, sigma = sigma.daily))
    }
    Greeks = cbind(HNG, GBS, Diff = round(100*(HNG-GBS)/GBS, digits = 2))
    row.names(Greeks) <- Selection
    data.frame(Greeks)

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.HNGCharacteristics = 
function()
{ 
    # HNGCharacteristics  
    #   Computes Option Price and all Greeks of HN-GARCH Model
    
    NA
    
    # Return Value:
    return()    
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA

# Copyrights (C)
# for this R-port: 
#   1999 - 2007, Diethelm Wuertz, GPL
#   Diethelm Wuertz <wuertz@itp.phys.ethz.ch>
#   info@rmetrics.org
#   www.rmetrics.org
# for the code accessed (or partly included) from other R-ports:
#   see R's copyright and license files
# for the code accessed (or partly included) from contributed R-ports
# and other sources
#   see Rmetrics's copyright file


################################################################################
# FUNCTION:             DESCRIPTION:
#  hngarchSim            Simulates an HN-GARCH(1,1) Time Series Process
#  hngarchFit            Fits a HN-GARCH model by Gaussian Maximum Likelihood
#  print.hngarch         Print method, reports results
#  summary.hngarch       Summary method, diagnostic analysis
#  hngarchStats          Computes Unconditional Moments of a HN-GARCH Process
################################################################################


test.hngarchSim = 
function()
{
    # Simulate a Heston-Nandi Garch(1,1) Process
    
    # RVs:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")
    
    # Symmetric Model - Parameters:
    model = list(lambda = 4, omega = 8e-5, alpha = 6e-5, 
        beta = 0.7, gamma = 0, rf = 0)
        
    # Series:
    x = hngarchSim(model = model, n = 500, n.start = 100)
    
    # Plot:
    par(mfrow = c(2, 1), cex = 0.75)
    plot(x, type = "l", col = "steelblue", main = "HN Garch Symmetric Model")
    grid()

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.hngarchFit = 
function()
{    
    # Simulate a Heston-Nandi Garch(1,1) Process:
    
    # RVs:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")
    
    # Symmetric Model - Parameters:
    model = list(lambda = 4, omega = 8e-5, alpha = 6e-5, 
        beta = 0.7, gamma = 0, rf = 0)
    x = hngarchSim(model = model, n = 500, n.start = 100)
                                                                     
    # Estimate Parameters:
    # HN-GARCH log likelihood Parameter Estimation:
    # To speed up, we start with the simulated model ...
    
    # Fit Symmetric Case:
    mle = hngarchFit(x = x, model = model, trace = TRUE, symmetric = TRUE)
    print(mle)
    
    # Assymmetric Case:
    mle = hngarchFit(x = x, model = model, trace = TRUE, symmetric = FALSE)
    print(mle)
        
    # HN GARCH Plot:
    # ... there is no plot - plotting is done in summary 
    
    # HN-GARCH Diagnostic Analysis:
    # Note, residuals are still missing ...
    par(mfrow = c(3, 1))
    summary(mle, col = "steelblue")                                             
    
    # HN-GARCH Moments:
    hngarchStats(mle$model)    

    # Return Value:
    return()    
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA


################################################################################
# FUNCTION:                  DESCRIPTION:
#  MonteCarloOption           Valuate Options by Monte Carlo Simulation
################################################################################


MonteCarloOption = function(delta.t, pathLength, mcSteps, mcLoops, 
init = TRUE, innovations.gen, path.gen, payoff.calc, antithetic = TRUE, 
standardization = FALSE, trace = TRUE, ...)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Valuates Options by Monte Carlo Simulation

    # Arguments:
    #   delta.t    - The length of the time interval, by default one day.
    #   pathLength - Number of Time Intervals which add up to the path.
    #   mcSteps    - The number of Monte Carlo Steps performed in one loop.
    #   mcLoops    - The number of Monte Carlo Loops
    #   init       - Should the random number generator be initialized ?
    #                This variable must appear in the argument list of the
    #                random number generator, even it will not ne used
    #   innovations.gen 
    #              - the generator function for the innovations
    #   path.gen   - the generator for the MC paths
    #   payoff.calc
    #              - the payoff claculator function
    #   antithetic - if TRUE, antithetic paths are used in the MC simulation
    #   standardization
    #              - if TRUE, the random numbers will be standardized so that
    #                their mean is zero and their variance is zero
    #   trace      - a logical, should the iteration path be traced ?
    #   ...        - additional parameters passed to innovations.gen.
    
    # Notes:
    #   Global Variables:
    #     The options parameter must be globally available. 
    #     For a Black-Scholes or a simple Asian Option these are:
    #     TypeFlag, S, X, Time, r, b, sigma
    #   Required Functions:
    #     The user must specify the following functions:
    #     innovations.gen()
    #     path.gen()
    #     payoff.calc()
    
    # FUNCTION
        
    # Monte Carlo Simulation:
    delta.t <<- delta.t
    if (trace) cat("\nMonte Carlo Simulation Path:\n\n")
        iteration = rep(0, length = mcLoops)
        # MC Iteration Loop:
        cat("\nLoop:\t", "No\t")
        for ( i in 1:mcLoops ) {
            if ( i > 1) init = FALSE
            # Generate Innovations:
              eps =  innovations.gen(mcSteps, pathLength, init = init, ...)
            # Use Antithetic Variates if requested:
              if (antithetic) 
                  eps = rbind(eps, -eps)
            # Standardize Variates if requested:
              if (standardization) eps = 
                 (eps-mean(eps))/sqrt(var(as.vector(eps)))
            # Calculate for each path the option price:
              path = t(path.gen(eps))
              payoff = NULL
              for (j in 1:dim(path)[1]) 
                  payoff = c(payoff, payoff.calc(path[, j])) 
              iteration[i] = mean(payoff)
            # Trace the Simualtion if desired:
              if (trace) 
                 cat("\nLoop:\t", i, "\t:", iteration[i], sum(iteration)/i ) 
        }
        if (trace) cat("\n")

    # Return Value:
    iteration
}


# ******************************************************************************

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################
# FUNCTION:             DESCRIPTION:
#  hngarchSim            Simulates an HN-GARCH(1,1) Time Series Process
#  hngarchFit            Fits a HN-GARCH model by Gaussian Maximum Likelihood
#  print.hngarch         Print method, reports results
#  summary.hngarch       Summary method, diagnostic analysis
#  hngarchStats          Computes Unconditional Moments of a HN-GARCH Process
################################################################################



hngarchSim =
function(model = list(lambda = 4, omega = 4*0.0002, alpha = 0.3*0.0002,
beta = 0.3, gamma = 0, rf = 0), n = 1000, innov = NULL, n.start = 100,
start.innov = NULL, rand.gen = rnorm, ...)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Simulates a HN-GARCH time series with user supplied innovations.

    # Details:
    #   The function simulates a Heston Nandi Garch(1,1) process with
    #   structure parameters specified through the list
    #   `model(lambda, omega, alpha, beta, gamma, rf)'
    #   The function returns the simulated time series points
    #   neglecting those from the first "start.innov" innovations.

    # Example:
    #   x = hngarch()
    #   plot(100*x, type="l", xlab="Day numbers",
    #     ylab="Daily Returns %", main="Heston Nandi GARCH")
    #   S0 = 1
    #   plot(S0*exp(cumsum(x)), type="l", xlab="Day Numbers",
    #     ylab="Daily Prices", main="Heston Nandi GARCH") }

    # FUNCTION:

    # Innovations:
    if (is.null(innov)) innov = rand.gen(n, ...)
    if (is.null(start.innov)) start.innov = rand.gen(n.start, ...)

    # Parameters:
    lambda = model$lambda
    omega = model$omega
    alpha = model$alpha
    beta = model$beta
    gamma = model$gamma
    rfr = model$rf

    # Start values:
    x = h = Z = c(start.innov, innov)
    nt = n.start + n

    # Recursion:
    h[1] = ( omega + alpha )/( 1 - alpha*gamma*gamma - beta )
    x[1] = rfr + lambda*h[1] + sqrt(h[1]) * Z[1]
    for (i in 2:nt) {
        h[i] = omega + alpha*(Z[i-1] - gamma*sqrt(h[i-1]))^2 + beta*h[i-1]
        x[i] = rfr + lambda*h[i] + sqrt(h[i]) * Z[i] }

    # Series:
    x = x[-(1:n.start)]

    # Return Value:
    x
}


# ------------------------------------------------------------------------------


hngarchFit =
function(x, model = list(lambda = -0.5, omega = var(x), alpha = 0.1*var(x),
beta = 0.1, gamma = 0, rf = 0), symmetric = TRUE, trace = FALSE, title =
NULL, description = NULL, ...)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Fits Heston-Nandi Garch(1,1) time series model

    # FUNCTION:

    # Parameters:
    rfr = model$rf
    lambda = model$lambda
    omega = model$omega
    alpha = model$alpha
    beta = model$beta
    gam = model$gamma

    # Continue:
    params = c(lambda = lambda, omega = omega, alpha = alpha,
        beta = beta, gamma = gam, rf = rfr)

    # Transform Parameters and Calculate Start Parameters:
    par.omega = -log((1-omega)/omega)  # for 2
    par.alpha = -log((1-alpha)/alpha)  # for 3
    par.beta = -log((1-beta)/beta)     # for 4
    par.start = c(lambda, par.omega, par.alpha, par.beta)
    if (!symmetric) par.start = c(par.start, gam)

    # Initial Log Likelihood:
    opt = list()
    opt$value = .llhHNGarch(par = par.start,
        trace = trace, symmetric = symmetric, rfr = rfr, x = x)
    opt$estimate = par.start
    if (trace) {
        print(c(lambda, omega, alpha, beta, gam))
        print(opt$value)
    }

    # Estimate Parameters:
    opt = nlm(.llhHNGarch, par.start,
        trace = trace, symmetric = symmetric, rfr = rfr, x = x, ...)

    # Log-Likelihood:
    opt$minimum = -opt$minimum + length(x)*sqrt(2*pi)
    opt$params = params
    opt$symmetric = symmetric

    # LLH, h, and z for Final Estimates:
    final = .llhHNGarch(opt$estimate, trace = FALSE, symmetric, rfr, x)
    opt$h = attr(final, "h")
    opt$z = attr(final, "Z")

    # Backtransform Estimated parameters:
    lambda = opt$estimate[1]
    omega = opt$estimate[2] = (1 / (1+exp(-opt$estimate[2])))
    alpha = opt$estimate[3] = (1 / (1+exp(-opt$estimate[3])))
    beta = opt$estimate[4] = (1 / (1+exp(-opt$estimate[4])))
    if (symmetric) opt$estimate[5] = 0
    gam = opt$estimate[5]
    names(opt$estimate) = c("lambda", "omega", "alpha", "beta", "gamma")

    # Add to Output:
    opt$model = list(lambda = lambda, omega = omega, alpha = alpha,
        beta = beta, gamma = gam, rf = rfr)
    opt$x = x

    # Statistics - Printing:
    opt$persistence = beta + alpha*gam*gam
    opt$sigma2 = ( omega + alpha ) / ( 1 - opt$persistence )

    # Print Estimated Parameters:
    if (trace) print(opt$estimate)

    # Call:
    opt$call = match.call()

    # Add title and description:
    if (is.null(title))
        title = "Heston-Nandi Garch Parameter Estimation"
    opt$title = title
    if (is.null(description))
        description = description()
    opt$description = description

    # Return Value:
    class(opt) = "hngarch"
    invisible(opt)
}


# ------------------------------------------------------------------------------


.llhHNGarch =
function(par, trace, symmetric, rfr, x)
{
    # h = sigma^2
    h = Z = x
    lambda = par[1]

    # Transform - to keep them between 0 and 1:
    omega = 1 / (1+exp(-par[2]))
    alpha = 1 / (1+exp(-par[3]))
    beta = 1 / (1+exp(-par[4]))

    # Add gamma if selected:
    if (!symmetric) gam = par[5] else gam = 0

    # HN Garch Filter:
    h[1] = ( omega + alpha )/( 1 - alpha*gam*gam - beta)
    Z[1] = ( x[1] - rfr - lambda*h[1] ) / sqrt(h[1])
    for ( i in 2:length(Z) ) {
        h[i] = omega + alpha * ( Z[i-1] - gam * sqrt(h[i-1]) )^2 +
            beta * h[i-1]
        Z[i] = ( x[i] - rfr - lambda*h[i] ) / sqrt(h[i])
    }

    # Calculate Log - Likelihood for Normal Distribution:
    llhHNGarch = -sum(log( dnorm(Z)/sqrt(h) ))
    if (trace) {
        cat("Parameter Estimate\n")
        print(c(lambda, omega, alpha, beta, gam))
    }

    # Attribute Z and h to the result:
    attr(llhHNGarch, "Z") = Z
    attr(llhHNGarch, "h") = h

    # Return Value:
    llhHNGarch
}


# ------------------------------------------------------------------------------


print.hngarch =
function(x, ...)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Print method for the  HN-GARCH time series model.

    # Arguments:
    #   x - an object of class "hngarch" as returned by the
    #   function "hngarchFit"

    # FUNCTION:

    # Print:
    object = x
    if (!inherits(object, "hngarch"))
        stop("method is only for garch objects")

    # Title:
    cat("\nTitle:\n ")
    cat(object$title, "\n")

    # Call:
    cat("\nCall:\n ", deparse(object$call), "\n", sep = "")

    # Parameters:
    cat("\nParameters:\n")
    print(format(object$params, digits = 4, ...), print.gap = 2,
        quote = FALSE)

    # Coefficients:
    cat("\nCoefficients: lambda, omega, alpha, beta, gamma\n")
    print(format(object$estimate, digits = 4, ...), print.gap = 2,
        quote = FALSE)

    # Likelihood:
    cat("\nLog-Likelihood:\n ")
    cat(object$minimum, "\n")

    # Persisitence and Variance:
    cat("\nPersistence and Variance:\n ")
    cat(object$persistence, "\n ")
    cat(object$sigma2, "\n")

    # Description:
    cat("\nDescription:\n ")
    cat(object$description, "\n\n")

    # Return Value:
    invisible()
}


# ------------------------------------------------------------------------------


summary.hngarch =
function(object, ...)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Summary method,
    #   Computes diagnostics for a HN-GARCH time series model.

    # Arguments:
    #   object - an object of class "hngarch" as returned by the
    #   function "hngarchFit"

    # FUNCTION:

    # Print:
    if (!inherits(object, "hngarch"))
        stop("method is only for garch objects")

    # Title:
    cat("\nTitle:\n")
    cat(object$title, "\n")

    # Call:
    cat("\nCall:\n", deparse(object$call), "\n", sep = "")

    # Parameters:
    cat("\nParameters:\n")
    print(format(object$params, digits = 4, ...), print.gap = 2,
        quote = FALSE)

    # Coefficients:
    cat("\nCoefficients: lambda, omega, alpha, beta, gamma\n")
    print(format(object$estimate, digits = 4, ...), print.gap = 2,
        quote = FALSE)

    # Likelihood:
    cat("\nLog-Likelihood:\n")
    cat(object$minimum, "\n")

    # Persisitence and Variance:
    cat("\nPersistence and Variance:\n")
    cat(object$persistence, "\n")
    cat(object$sigma2, "\n")

    # Create Graphs:
    plot(x = object$x, type = "l", xlab = "Days", ylab = "log-Returns",
        main = "Log-Returns", ...)
    plot(sqrt(object$h), type = "l", xlab = "Days", ylab = "sqrt(h)",
        main = "Conditional Standard Deviations", ...)
    # ... there are not resiudal yet implemented:
    # plot(object$residuals, type = "l", xlab = "Days", ylab = "Z",
    #     main = "Residuals", ...)

    # Return Value:
    invisible()
}


################################################################################


hngarchStats =
function(model)
{   # A function implemented by Diethelm Wuertz

    # Description:

    # Details:
    #   Calculates the first 4 moments of the unconditional log
    #   return distribution for a stationary HN GARCH(1,1) process
    #   with standard normally distributed innovations. The function
    #   returns a list with the theoretical values for the mean, the
    #   variance, the skewness and the kurtosis} of the (unconditional)
    #   log return distribution. We have also access to the persistence
    #   of the corresponding HN GARCH(1,1) process and to the values
    #   for E[sigma^2], E[sigma^4], E[sigma^6], and E[sigma^8], which are
    #   needed for the computation of the moments of the unconditional
    #   log return distribution. The only arguments are the risk free
    #   interest rate r and the structure parameters of the HN GARCH(1,1)
    #   process, which are specified in the model list model=list(alpha,
    #   beta, omega, gamma, lambda)}.

    # Reference:
    #   A function originally written by Reto Angliker
    #   License: GPL

    # Arguments:
    #   model - a moel specification for a Heston-Nandi Garch
    #       process.

    # FUNCTION:

    # Check:
    if (model$alpha < 0) {
        warning("Negative value for the parameter alpha")}
    if (model$beta < 0)
        {warning("Negative value for the parameter beta") }
    if (model$omega < 0)
        {warning("Negative value for the parameter omega")}

    # Short:
    lambda = model$lambda
    omega = model$omega
    alpha = model$alpha
    beta = model$beta
    gamma = model$gamma

    # Moments of the Normal Distribution
    expect2 = 1
    expect4 = 3
    expect6 = 15
    expect8 = 105

    # Symmetric Case:
    if(model$gamma == 0) {
        persistence = beta
        meansigma2 = (omega+alpha) /(1-beta)
        meansigma4 = (omega^2 + 2*omega*alpha + 2*omega*beta*meansigma2 +
            3*alpha^2 + 2*alpha*beta*meansigma2) / (1 - beta^2)
        meansigma6 = (omega^3 + 3*omega^2*alpha + 3*omega^2*beta*meansigma2 +
            9*omega*alpha^2 + 6*omega*alpha*beta*meansigma2 +
            3*omega*beta^2*meansigma4 + 15*alpha^3 +
            9*alpha^2*beta*meansigma2 + 3*alpha*beta^2*meansigma4) / (1-beta^3)
        meansigma8 =
            (omega^4 + expect8*alpha^4 + 12*omega^2*alpha*beta*meansigma2 +
            60*alpha^3*beta*meansigma2 + 18*alpha^2*beta^2*meansigma4 +
            4*alpha*beta^3*meansigma6 + 36*omega*alpha^2*beta*meansigma2 +
            12*omega*alpha*beta^2*meansigma4 + 4*omega^3*alpha +
            4*omega^3*beta*meansigma2 + 18*omega^2*alpha^2 +
            6*omega^2*beta^2*meansigma4 + 60*omega*alpha^3 +
            4*omega*beta^3*meansigma6)/ (1 - beta^4) }

    # Asymmetric Case:
    if(gamma != 0) {
        persistence = beta + alpha*gamma^2
        meansigma2 = (omega+alpha) / (1-beta-alpha*gamma^2)
        meansigma4 = (omega^2 + 2*omega*beta*meansigma2 +
            alpha^2*expect4 + 2*beta*meansigma2*alpha*expect2 +
            6*alpha^2*expect2*gamma^2*meansigma2 +
            2*omega*alpha*gamma^2*meansigma2 + 2*omega*alpha*expect2) /
            (1 - beta^2 - 2*beta*alpha*gamma^2 - alpha^2*gamma^4)
        meansigma6 =
            (3*omega*alpha^2*expect4 + 3*omega^2*alpha*gamma^2*meansigma2 +
            3*beta*meansigma2*alpha^2*expect4 +
            3*beta^2*meansigma4*alpha*expect2 +
            15*alpha^3*expect4*gamma^2*meansigma2 +
            15*alpha^3*expect2*gamma^4*meansigma4 +
            3*omega*alpha^2*gamma^4*meansigma4 +
            3*omega^2*beta*meansigma2 + 3*omega^2*alpha*expect2 +
            3*omega*beta^2*meansigma4 + omega^3 + alpha^3*expect6 +
            18*beta*meansigma4*alpha^2*expect2*gamma^2 +
            6*omega*beta*meansigma2*alpha*expect2 +
            6*omega*beta*meansigma4*alpha*gamma^2 +
            18*omega*alpha^2*expect2*gamma^2*meansigma2) /
            (1 - 3*beta^2*alpha*gamma^2 - 3*beta*alpha^2*gamma^4 -
            alpha^3*gamma^6 - beta^3)
        meansigma8 = (omega^4 + alpha^4*expect8 +
            6*omega^2*alpha^2*expect4 + 4*omega^3*beta*meansigma2 +
            4*omega^3*alpha*expect2 + 6*omega^2*beta^2*meansigma4 +
            4*omega*beta^3*meansigma6 + 4*omega*alpha^3*expect6 +
            12*omega^2*beta*meansigma2*alpha*expect2 +
            12*omega^2*beta*meansigma4*alpha*gamma^2 +
            36*omega^2*alpha^2*expect2*gamma^2*meansigma2 +
            4*omega^3*alpha*gamma^2*meansigma2 +
            6*omega^2*alpha^2*gamma^4*meansigma4 +
            6*beta^2*meansigma4*alpha^2*expect4 +
            4*beta^3*meansigma6*alpha*expect2 +
            4*beta*meansigma2*alpha^3*expect6 +
            28*alpha^4*expect6*gamma^2*meansigma2 +
            70*alpha^4*expect4*gamma^4*meansigma4 +
            28*alpha^4*expect2*gamma^6*meansigma6 +
            4*omega*alpha^3*gamma^6*meansigma6 +
            60*beta*meansigma4*alpha^3*expect4*gamma^2 +
            60* beta*meansigma6*alpha^3*expect2*gamma^4 +
            36*beta^2*meansigma6*alpha^2*expect2*gamma^2 +
            12*omega*beta*meansigma2*alpha^2*expect4 +
            12*omega*beta^2*meansigma4*alpha*expect2 +
            12*omega*beta^2*meansigma6*alpha*gamma^2 +
            12*omega*beta*meansigma6*alpha^2*gamma^4 +
            60*omega*alpha^3*expect4*gamma^2*meansigma2 +
            60*omega*alpha^3*expect2*gamma^4*meansigma4 +
            72*omega*beta*meansigma4*alpha^2*expect2*gamma^2) /
            (1 - beta^4 - alpha^4*gamma^8 - 4*beta^3*alpha*gamma^2 -
            6*beta^2*alpha^2*gamma^4 - 4*beta*alpha^3*gamma^6 ) }
    if (persistence > 1) { warning(paste(
        "The selected HN GARCH model is not stationary and",
        "the expressions for the moments are no more valid")) }

    # Leverage:
    leverage = -2*alpha*gamma*meansigma2

    # Unconditional Values:
    uc.mean = lambda*meansigma2
    uc.variance = lambda^2*(meansigma4 - meansigma2^2) + meansigma2
    uc.skewness = (3*lambda*meansigma4 - 3*lambda*meansigma2^2 +
        lambda^3*meansigma6 - 3*lambda^3*meansigma2*meansigma4 +
        2*lambda^3*meansigma2^3 ) / sqrt(uc.variance)^3
    uc.kurtosis = (meansigma4*3 + 6*lambda^2*meansigma6 -
        12*lambda^2*meansigma2*meansigma4 + 6*lambda^2*meansigma2^3 +
        lambda^4*meansigma8 - 4*lambda^4*meansigma2*meansigma6 +
        6*lambda^4*meansigma2^2*meansigma4 -
        3*lambda^4*meansigma2^4 ) / uc.variance^2

    # Return Value:
    list(mean = uc.mean, variance = uc.variance, skewness = uc.skewness,
        kurtosis = uc.kurtosis, persistence = persistence, leverage = leverage,
        meansigma2 = meansigma2, meansigma4 = meansigma4, meansigma6 =
        meansigma6, meansigma8 = meansigma8)
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA


################################################################################
# FUNCTION:                  DESCRIPTION:
#  RollGeskeWhaleyOption      Roll-Geske-Whaley Calls on Dividend Paying Stocks
#  BAWAmericanApproxOption    Barone-Adesi and Whaley Approximation
#  BSAmericanApproxOption     Bjerksund and Stensland Approximation
################################################################################


RollGeskeWhaleyOption = 
function(S, X, time1, Time2, r, D, sigma, title = NULL, description = NULL) 
{   # A function implemented by Diethelm Wuertz
 
    # Description:
    #   Calculates the option price of an American call on a stock
    #   paying a single dividend with specified time to divident
    #   payout. The option valuation formula derived by Roll, Geske 
    #   and Whaley is used.
    
    # References:
    #   Haug E.G., The Complete Guide to Option Pricing Formulas
    
    # FUNCTION:
    
    # Settings:
    big = 100000000
    eps = 1.0e-5
    t1 = time1
    T2 = Time2
    
    # Compute:
    Sx = S - D * exp(-r * t1)
    if(D <= X * (1 - exp(-r*(T2-t1)))) {         
        result = GBSOption("c", Sx, X, T2, r, b=r, sigma)@price
        cat("\nWarning: Not optimal to exercise\n")
        return(result) }
    ci = GBSOption("c", S, X, T2-t1, r, b=r, sigma)@price
    HighS = S
    while ( ci-HighS-D+X > 0 && HighS < big ) {
        HighS = HighS * 2
        ci = GBSOption("c", HighS, X, T2-t1, r, b=r, sigma)@price }
    if(HighS > big) {
        result = GBSOption("c", Sx, X, T2, r, b=r, sigma)@price
        stop()}
    LowS = 0
    I = HighS * 0.5
    ci = GBSOption("c", I, X, T2-t1, r, b=r, sigma)@price 
    # Search algorithm to find the critical stock price I
    while ( abs(ci-I-D+X) > eps && HighS - LowS > eps ) {
         if(ci-I-D+X < 0 ) { HighS = I }
        else { LowS = I }
        I = (HighS + LowS) / 2
        ci = GBSOption("c", I, X, T2-t1, r, b=r, sigma)@price }
    a1 = (log(Sx/X) + (r+sigma^2/2)*T2) / (sigma*sqrt(T2))
    a2 = a1 - sigma*sqrt(T2)
    b1 = (log(Sx/I) + (r+sigma^2/2)*t1) / (sigma*sqrt(t1))
    b2 = b1 - sigma*sqrt(t1)
    result = Sx*CND(b1) + Sx*CBND(a1,-b1,-sqrt(t1/T2)) -
        X*exp(-r*T2)*CBND(a2,-b2,-sqrt(t1/T2)) - 
            (X-D)*exp(-r*t1)*CND(b2)
    
    # Parameters:
    # S, X, time1, Time2, r, D, sigma
    param = list()
    param$S = S
    param$X = X
    param$time1 = time1
    param$Time2 = Time2
    param$r = r
    param$D = D
    param$sigma = sigma
    
    # Add title and description:
    if(is.null(title)) title = "Roll Geske Whaley Option"
    if(is.null(description)) description = as.character(date())
    
    # Return Value:
    new("fOPTION", 
        call = match.call(),
        parameters = param,
        price = result, 
        title = title,
        description = description
        )      
}


# ******************************************************************************


BAWAmericanApproxOption = 
function(TypeFlag = c("c", "p"), S, X, Time, r, b, sigma, title = NULL, 
description = NULL)
{   # A function implemented by Diethelm Wuertz
 
    # Description:
    #   Calculates the option price of an American call or put
    #   option on an underlying asset for a given cost-of-carry rate.
    #   The quadratic approximation method by Barone-Adesi and
    #   Whaley is used.

    # References:
    #   Haug E.G., The Complete Guide to Option Pricing Formulas
    
    # FUNCTION:
    
    # Settings:
    TypeFlag = TypeFlag[1]
    
    # Compute:
    if(TypeFlag == "c") {
        result = .BAWAmCallApproxOption(S, X, Time, r, b, sigma) }
    if(TypeFlag == "p") {      
        result = .BAWAmPutApproxOption(S, X, Time, r, b, sigma) }
       
    # Parameters:
    # TypeFlag = c("c", "p"), S, X, Time, r, b, sigma
    param = list()
    param$TypeFlag = TypeFlag
    param$S = S
    param$X = X
    param$Time = Time
    param$r = r
    param$b = b
    param$sigma = sigma
    
    # Add title and description:
    if(is.null(title)) title = "BAW American Approximated Option"
    if(is.null(description)) description = as.character(date())
    
    # Return Value:
    new("fOPTION", 
        call = match.call(),
        parameters = param,
        price = result, 
        title = title,
        description = description
        )      
}


.BAWAmCallApproxOption <- 
function(S, X, Time, r, b, sigma) 
{
    # Internal Function - The Call:
        
    # Compute:
    if(b >= r) {
        result = GBSOption("c", S, X, Time, r, b, sigma)@price }
    else {
        Sk = .bawKc(X, Time, r, b, sigma)
        n = 2*b/sigma^2
        K = 2*r/(sigma^2*(1-exp(-r*Time)))
        d1 = (log(Sk/X)+(b+sigma^2/2)*Time)/(sigma*sqrt(Time))
        Q2 = (-(n-1)+sqrt((n-1)^2+4*K))/2
        a2 = (Sk/Q2)*(1-exp((b-r)*Time)*CND(d1))
        if(S < Sk) {
            result = GBSOption("c", S, X, Time, r, b, sigma)@price +
                a2*(S/Sk)^Q2 
        } else {
            result = S-X 
        } 
    }
    
    # Return Value:
    result 
}


.bawKc <- 
function(X, Time, r, b, sigma) 
{   
    # Newton Raphson algorithm to solve for the critical commodity 
    # price for a Call.
    # Calculation of seed value, Si
    n = 2*b/sigma^2
    m = 2*r/sigma^2
    q2u = (-(n-1)+sqrt((n-1)^2+4*m))/2
    Su = X/(1-1/q2u)
    h2 = -(b*Time+2*sigma*sqrt(Time))*X/(Su-X)
    Si = X+(Su-X)*(1-exp(h2))
    K = 2*r/(sigma^2*(1-exp(-r*Time)))
    d1 = (log(Si/X)+(b+sigma^2/2)*Time)/(sigma*sqrt(Time))
    Q2 = (-(n-1)+sqrt((n-1)^2+4*K))/2
    LHS = Si-X
    RHS = GBSOption("c", Si, X, Time, r, b, sigma)@price + 
        (1-exp((b-r)*Time)*CND(d1))*Si/Q2
    bi = exp((b-r)*Time)*CND(d1)*(1-1/Q2) +
        (1-exp((b-r)*Time)*CND(d1)/(sigma*sqrt(Time)))/Q2
    E = 0.000001
    
    # Newton Raphson algorithm for finding critical price Si
    while (abs(LHS-RHS)/X > E) {
        Si = (X+RHS-bi*Si)/(1-bi)
        d1 = (log(Si/X)+(b+sigma^2/2)*Time)/(sigma*sqrt(Time))
        LHS = Si-X
        RHS = GBSOption("c", Si, X, Time, r, b, sigma)@price + 
            (1-exp((b-r)*Time)*CND(d1))*Si/Q2
        bi = exp((b-r)*Time)*CND(d1)*(1-1/Q2) + 
        (   1-exp((b-r)*Time)*CND(d1)/(sigma*sqrt(Time)))/Q2 }
    
    # Return Value:
    Si
}


.BAWAmPutApproxOption <- 
function(S, X, Time, r, b, sigma) 
{
    # Internal Function - The Put:
    
    # Compute:
    Sk = .bawKp(X, Time, r, b, sigma)
    n = 2*b/sigma^2
    K = 2*r/(sigma^2*(1-exp(-r*Time)))
    d1 = (log(Sk/X)+(b+sigma^2/2)*Time)/(sigma*sqrt(Time))
    Q1 = (-(n-1)-sqrt((n-1)^2+4*K))/2
    a1 = -(Sk/Q1)*(1-exp((b-r)*Time)*CND(-d1))
    if(S > Sk) {
        result = GBSOption("p", S, X, Time, r, b, sigma)@price + a1*(S/Sk)^Q1 
    } else {
        result = X-S 
    }  
    
    # Return Value:
    result
}


.bawKp <- 
function(X, Time, r, b, sigma) 
{   
    # Internal Function - used for the Put:
    
    # Newton Raphson algorithm to solve for the critical commodity 
    # price for a Put.
    # Calculation of seed value, Si
    n = 2*b/sigma^2
    m = 2*r/sigma^2
    q1u = (-(n-1)-sqrt((n-1)^2+4*m))/2
    Su = X/(1-1/q1u)
    h1 = (b*Time-2*sigma*sqrt(Time))*X/(X-Su)
    Si = Su+(X-Su)*exp(h1) 
    K = 2*r/(sigma^2*(1-exp(-r*Time)))
    d1 = (log(Si/X)+(b+sigma^2/2)*Time)/(sigma*sqrt(Time))
    Q1 = (-(n-1)-sqrt((n-1)^2+4*K))/2
    LHS = X-Si
    RHS = GBSOption("p", Si, X, Time, r, b, sigma)@price -
        (1-exp((b-r)*Time)*CND(-d1))*Si/Q1
    bi = -exp((b-r)*Time)*CND(-d1)*(1-1/Q1) -
        (1+exp((b-r)*Time)*CND(-d1)/(sigma*sqrt(Time)))/Q1
    E = 0.000001
    # Newton Raphson algorithm for finding critical price Si
    while (abs(LHS-RHS)/X > E ) {
        Si = (X-RHS+bi*Si)/(1+bi)
        d1 = (log(Si/X)+(b+sigma^2/2)*Time)/(sigma*sqrt(Time))
        LHS = X-Si
        RHS = GBSOption("p", Si, X, Time, r, b, sigma)@price -
            (1-exp((b-r)*Time)*CND(-d1))*Si/Q1
        bi = -exp((b-r)*Time)*CND(-d1)*(1-1/Q1) -
            (1+exp((b-r)*Time)*CND(-d1)/(sigma*sqrt(Time)))/Q1 }
    # Return Value:
    Si
}


# ------------------------------------------------------------------------------


BSAmericanApproxOption = 
function(TypeFlag = c("c", "p"), S, X, Time, r, b, sigma, title = NULL, 
description = NULL)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Calculates the option price of an American call or 
    #   put option stocks, futures, and currencies. The 
    #   approximation method by Bjerksund and Stensland is used.
    
    # References:
    #   Haug E.G., The Complete Guide to Option Pricing Formulas
    
    # FUNCTION:
    
    # Settings:
    TypeFlag = TypeFlag[1]
    
    # The Bjerksund and Stensland (1993) American approximation:
    if(TypeFlag == "c") {
      result = .BSAmericanCallApprox(S, X, Time, r, b, sigma) }
    if(TypeFlag == "p") {
      # Use the Bjerksund and Stensland put-call transformation
      result = .BSAmericanCallApprox(X, S, Time, r - b, -b, sigma) }
    
    # Parameters:
    # TypeFlag = c("c", "p"), S, X, Time, r, b, sigma
    param = list()
    param$TypeFlag = TypeFlag
    param$S = S
    param$X = X
    param$Time = Time
    param$r = r
    param$b = b
    param$sigma = sigma
    if(!is.na(result$TriggerPrice)) param$TrigerPrice = result$TriggerPrice 
    
    # Add title and description:
    if(is.null(title)) title = "BS American Approximated Option"
    if(is.null(description)) description = as.character(date())
    
    # Return Value:
    new("fOPTION", 
        call = match.call(),
        parameters = param,
        price = result$Premium, 
        title = title,
        description = description
        )      
}


.BSAmericanCallApprox <- 
function(S, X, Time, r, b, sigma) 
{ 
    # Call Approximation:
    
    if(b >= r) { 
        # Never optimal to exersice before maturity
        result = list(
            Premium = GBSOption("c", S, X, Time, r, b, sigma)@price,
            TriggerPrice = NA)
    } else {
    Beta = (1/2 - b/sigma^2) + sqrt((b/sigma^2 - 1/2)^2 + 2*r/sigma^2)
    BInfinity = Beta/(Beta-1) * X
    B0 = max(X, r/(r-b) * X)
    ht = -(b*Time + 2*sigma*sqrt(Time)) * B0/(BInfinity-B0)
    # Trigger Price I:
    I = B0 + (BInfinity-B0) * (1 - exp(ht))
    alpha = (I-X) * I^(-Beta)
    if(S >= I) { 
        result = list(
            Premium = S-X, 
            TriggerPrice = I) }
    else {
        result = list(
            Premium = alpha*S^Beta - alpha*.bsPhi(S,Time,Beta,I,I,r,b,sigma) + 
            .bsPhi(S,Time,1,I,I,r,b,sigma) - .bsPhi(S,Time,1,X,I,r,b,sigma) - 
            X*.bsPhi(S,Time,0,I,I,r,b,sigma) + X*.bsPhi(S,Time,0,X,I,r,b,sigma), 
            TriggerPrice = I) } }
    result}
      

.bsPhi <- 
function(S, Time, gamma, H, I, r, b, sigma) 
{
    # Utility function phi:

    lambda = (-r + gamma*b + 0.5*gamma * (gamma-1)*sigma^2) * Time
    d = -(log(S/H) + (b + (gamma-0.5)*sigma^2)*Time) / 
        (sigma*sqrt(Time))
    kappa = 2 * b / (sigma^2) + (2*gamma - 1)
    result = exp(lambda)*S^gamma * 
    (CND(d)-(I/S)^kappa*CND(d-2*log(I/S)/(sigma*sqrt(Time))))
    
    # Return Value:
    result 
}


################################################################################

\name{MonteCarloOptions}

\alias{MonteCarloOptions}

\alias{wienerMCPath}
\alias{plainVanillaMCPayoff}
\alias{arithmeticAsianMCPayoff}
\alias{MonteCarloOption}


\title{Monte Carlo Valuation of Options}


\description{

    A collection and description of functions to valuate 
    options by Monte Carlo methods. The functions include 
    beside the main Monte Carlo Simulator, example functions 
    to generate Monte Carlo price paths and to compute 
    Monte Carlo price payoffs.
    \cr
    
    The functions are:

    \tabular{ll}{
    \code{sobolInnovations} \tab Example for scrambled Sobol innovations, \cr
    \code{wienerPath} \tab Example for a Wiener price path, \cr
    \code{plainVanillaPayoff} \tab Example for the plain vanilla option's payoff, \cr
    \code{arithmeticAsianPayoff} \tab Example for the arithmetic Asian option's payoff, \cr
    \code{MonteCarloOption} \tab Monte Carlo Simulator for options. }
    
}


\usage{
MonteCarloOption(delta.t, pathLength, mcSteps, mcLoops, init = TRUE, 
    innovations.gen, path.gen, payoff.calc, antithetic = TRUE, 
    standardization = FALSE, trace = TRUE, \dots)
}

\arguments{
  
    \item{antithetic}{
        a logical flag, should antithetic variates be used? 
        By default TRUE.
        }
    \item{delta.t}{
        the time step interval measured as a fraction of one
        year, by default one day, i.e. \code{delta.t=1/360}.
        }
    \item{init}{
        a logical flag, should the random number generator be 
        initialized? By default TRUE.
        }
    \item{innovations.gen}{
        a user defined function to generate the innovations, this can 
        be the normal random number generator \code{rnorm.pseudo} with 
        mean zero and variance one. For the usage of low discrepancy
        sequences alternativey \code{rnorm.halton} and \code{rnorm.sobol}
        can be called. The generator must deliver a normalized
        matrix of innovations with dimension given by the number of
        Monte Carlo steps and the path length. The first three
        arguments of the generator are the the number of Monte Carlo 
        steps \code{mcSteps}, the path length \code{pathLength} and the
        initialization flag \code{init}. Optional arguments can be passed
        through the argument \code{\dots}, e.g. the type of scrambling 
        for low discrepancy numbers.
        }
    \item{mcLoops, mcSteps}{
        the number of Monte Carlo loops and Monte Carlo Steps.
        In total \code{mcLoops*mcSteps} samples are included in
        one MC simulation.
        }
    \item{path.gen}{
        the user defined function to generate the price path.
        As the only input argument serves the matrix of innovations,
        the option parameters must be available as global variables.
        }
    \item{pathLength}{
        the length of the price path. This may be calculated
        as \code{floor(Time/delta.t)}, where \code{Time} denotes the 
        time to maturation measured in years.
        }
    \item{payoff.calc}{
        a user defined function to calculate the payoff of the option.
        As the only input argument serves the path matrix as returned
        by the path generator. The option parameters must be available 
        as global variables.
        }
    \item{standardization}{
        a logical flag, should the innovations for one loop be
        standardized? By default TRUE.
        }
    \item{trace}{
        a logical flag, should the Monte Carlo simulation be traced?
        By default TRUE.
        }
    \item{\dots}{
        additional arguments passed to the innovations generator.
        }   

}


\value{
  
    \emph{The user defined innovation generator}
    \cr
    returns a numeric matrix of (random) innovations to build the Monte 
    Carlo Paths.
    \cr
    
    \emph{The user defined path generator}
    \cr
    returns a numeric matrix of the Monte Carlo paths for the calculation
    of the option's payoffs.
    To be more precise, as an example the function returns for a Wiener
    process the matrix 
    \code{(b-sigma*sigma/2)*delta.t + sigma*sqrt(delta.t)*innovations}, 
    where the first term corresponds to the drift and the second to the 
    volatility.
    \cr
    
    
    \emph{The user defined payoff calculator},
    \cr
    returns the vector of the option's payoffs calculated from the generated
    paths. As an example this becomes for an arithmetic Asian call option
    with a Wiener Monte Carlo path \code{payoff = exp(-r*Time)*max(SM-X, 0)} 
    where \code{SM = mean(S*exp(cumsum(path)))} and \code{path} denotes
    the MC price paths.
    \cr
    
    
    \bold{MonteCarloOption:}
    \cr  
    returns a vector with the option prices for each Monte Carlo loop.
    
}


\details{
    
    \bold{The Innovations:}
    \cr\cr
    The innovations must created by the user defined innovation generator.
    The Generator has to return a numeric matrix of (random) innovations 
    of size \code{mcSteps} times the \code{pathLength}. The example
    section shows how to write sa function for scrambled Quasi Monte Carlo
    Sobol numbers. The package comes with three generators
    \code{rnorm.pseudo}, \code{rnorm.halton} and \code{rnorm.sobol}
    which can easily be used for simulations. 
    \cr
    
    \bold{The Price Paths:}
    \cr\cr
    The user must provide a function which generates the price paths.
    In the example section the function \code{wienerPath} creates a 
    Wiener Monte Carlo path from random innovations.
    The Wiener price path requires as input \code{b}, the annualized 
    cost-of-carry rate, and \code{sigma}, the annualized volatility of 
    the underlying security, to compute the drift and variance of the 
    path, these variables must be globally defined.
    \cr
    
    \bold{The Payoff Function:}
    \cr\cr
    The user must also provide a function which computes the payoff 
    value of the option. The example sections show how to write 
    payoff calculators for the plain vanilla option and for the 
    arithmetic Asian Option. As the only input argument the path matrix 
    is required. Again, the option parameters must be globally available.
    \cr
    
    \bold{The Monte Carlo Simulator:}
    \cr\cr   
    The simulator is the heart of the Monte Carlo valuation process. 
    This simulator performs \code{mcLoops} Monte Carlo loops each with 
    \code{mcSteps} Monte Carlo steps. In each loop the following steps
    are done: first the innovation matrix is created from the specified
    innovation generator (usually build from the normal pseudo random 
    number or low discrepancy generators), then anththetic innovations 
    are added if desired (by default \code{anththetic=TRUE}), then the 
    innovations can be standardized within each loop (by default 
    \code{standardization=FALSE}), and finally the average payoff of 
    all samples in the loop is computed. The simulation can be traced 
    loop by loop setting the argument \code{trace=TRUE}.
     
}


\author{

    Diethelm Wuertz for the Rmetrics \R-port.
    
}


\references{
Birge J.R. (1994);  
    \emph{Quasi-Monte Carlo Approaches to Option Pricing}, 
    Department of Industrial and Operations Engineering, 
    Technical Report 94--19, University of Michigan.

Boyle P. (1977);
    \emph{Options: A Monte Carlo approach},
    Journal of Finance, 32, 323--338.

Glasserman P. (2004); 
    \emph{Monte Carlo Methods in Financial Engineering},
    Springer-Verlag New York, Inc., 596 pp.

Jaeckel P. (2002); 
    \emph{Monte Carlo Methods in Finance}, 
    John Wiley and Sons Ltd, 222 pp. 

}


\examples{  
## How to perform a Monte Carlo Simulation?
   
## First Step:
   # Write a function to generate the option's innovations. 
   # Use scrambled normal Sobol numbers:
   sobolInnovations = function(mcSteps, pathLength, init, ...) {
     # Create Normal Sobol Innovations:
     innovations = rnorm.sobol(mcSteps, pathLength, init, ...)
     # Return Value:
     innovations }
    
## Second Step: 
   # Write a function to generate the option's price paths.  
   # Use a Wiener path:
   wienerPath = function(eps) { 
     # Note, the option parameters must be globally defined!
     # Generate the Paths:
     path = (b-sigma*sigma/2)*delta.t + sigma*sqrt(delta.t)*eps
     # Return Value:
     path }
      
## Third Step: 
   # Write a function for the option's payoff
   
   # Example 1: use the payoff for a plain Vanilla Call or Put:
   plainVanillaPayoff = function(path) { 
     # Note, the option parameters must be globally defined!
     # Compute the Call/Put Payoff Value:
     ST = S*exp(sum(path))
     if (TypeFlag == "c") payoff = exp(-r*Time)*max(ST-X, 0)
     if (TypeFlag == "p") payoff = exp(-r*Time)*max(0, X-ST)
     # Return Value:
     payoff }
   
   # Example 2: use the payoff for an arithmetic Asian Call or Put:
   arithmeticAsianPayoff = function(path) { 
     # Note, the option parameters must be globally defined!
     # Compute the Call/Put Payoff Value:
     SM = mean(S*exp(cumsum(path)))
     if (TypeFlag == "c") payoff = exp(-r*Time)*max(SM-X, 0)
     if (TypeFlag == "p") payoff = exp(-r*Time)*max(0, X-SM)
     # Return Value:
     payoff }

## Final Step: 
   # Set Global Parameters for the plain Vanilla / arithmetic Asian Options:
   TypeFlag <- "c"; S <- 100; X <- 100
   Time <- 1/12; sigma <- 0.4; r <- 0.10; b <- 0.1
   
   # Do the Asian Simulation with scrambled random numbers:
   mc = MonteCarloOption(delta.t = 1/360, pathLength = 30, mcSteps = 5000, 
     mcLoops = 50, init = TRUE, innovations.gen = sobolInnovations, 
     path.gen = wienerPath, payoff.calc = arithmeticAsianPayoff, 
     antithetic = TRUE, standardization = FALSE, trace = TRUE, 
     scrambling = 2, seed = 4711)
   
   # Plot the MC Iteration Path:
   par(mfrow = c(1, 1))
   mcPrice = cumsum(mc)/(1:length(mc))
   plot(mcPrice, type = "l", main = "Arithmetic Asian Option", 
     xlab = "Monte Carlo Loops", ylab = "Option Price") 
    
   # Compare with Turnbull-Wakeman Approximation:
   # TW = TurnbullWakemanAsianApproxOption(TypeFlag = "c", S = 100, SA = 100, 
   #    X = 100, Time = 1/12, time = 1/12, tau = 0 , r = 0.1, b = 0.1, 
   #    sigma = 0.4) 
   # print(TW)
   # abline(h = TW, col = 2)
}


\keyword{programming}
    

\name{BinomialTreeOptions}

\alias{BinomialTreeOptions}

\alias{CRRBinomialTreeOption}
\alias{JRBinomialTreeOption}
\alias{TIANBinomialTreeOption}
\alias{BinomialTreeOption}
\alias{BinomialTreePlot}


\title{Binomial Tree Option Model}


\description{
  
    A collection and description of functions to valuate 
    options in the framework of the Binomial tree option 
    approach.
    \cr
    
    The functions are:

    \tabular{ll}{
    \code{CRRBinomialTreeOption} \tab CRR Binomial Tree Option, \cr
    \code{JRBinomialTreeOption} \tab JR Binomial Tree Option, \cr
    \code{TIANBinomialTreeOption} \tab TIAN Binomial Tree Option, \cr
    \code{BinomialTreeOption} \tab Binomial Tree Option, \cr
    \code{BinomialTreePlot} \tab Binomial Tree Plot. }
    
}


\usage{
CRRBinomialTreeOption(TypeFlag = c("ce", "pe", "ca", "pa"), S, X, 
    Time, r, b, sigma, n, title = NULL, description = NULL)
JRBinomialTreeOption(TypeFlag = c("ce", "pe", "ca", "pa"), S, X, 
    Time, r, b, sigma, n, title = NULL, description = NULL)
TIANBinomialTreeOption(TypeFlag = c("ce", "pe", "ca", "pa"), S, X, 
    Time, r, b, sigma, n, title = NULL, description = NULL)

BinomialTreeOption(TypeFlag = c("ce", "pe", "ca", "pa"), S, X, 
    Time, r, b, sigma, n, title = NULL, description = NULL)
BinomialTreePlot(BinomialTreeValues, dx = -0.025, dy = 0.4, 
    cex = 1, digits = 2, \dots)
}


\arguments{
  
    \item{b}{
        the annualized cost-of-carry rate, a numeric value; 
        e.g. 0.1 means 10\% pa.
        }
    \item{BinomialTreeValues}{
        the return value from the \code{BinomialTreeOption} function.
        }
    \item{cex}{
        a numerical value giving the amount by which the plotting text
        and symbols should be scaled relative to the default.
        }
    \item{description}{
        a character string which allows for a brief description.
        }
    \item{digits}{
        an integer value, how many digits should be displayed in the
        option tree?
        }
    \item{dx, dy}{
        numerical values, an offset fine tuning for the placement of
        the option values in the option tree.
        }
    \item{n}{
        number of time steps; an integer value.
        }
    \item{r}{
        the annualized rate of interest, a numeric value; 
        e.g. 0.25 means 25\% pa.
        }
    \item{S}{
        the asset price, a numeric value.
        }
    \item{sigma}{
        the annualized volatility of the underlying security, 
        a numeric value; e.g. 0.3 means 30\% volatility pa.
        }
    \item{Time}{
        the time to maturity measured in years, a numeric 
        value; e.g. 0.5 means 6 months.
        }
    \item{title}{
        a character string which allows for a project title.
        }
    \item{TypeFlag}{
        a character string either \code{"ce"}, \code{"ca"} for an 
        European or American call option or a \code{"pe"}, \code{"pa"} 
        for a put option, respectively.
        }
    \item{X}{
        the exercise price, a numeric value.
        }
    \item{\dots}{
        arguments to be passed.
        }

}


\details{
  
    \bold{CRR Binomial Tree Model:}
    \cr\cr
    Binomial models were first suggested by Cox, Ross and Rubinstein (1979),
    CRR, and then became widely used because of its intuition and easy 
    implementation. Binomial trees are constructed on a discrete-time 
    lattice. With the time between two trading events shrinking to zero, 
    the evolution of the price converges weakly to a lognormal diffusion. 
    Within this mode the European options value converges to the value 
    given by the Black-Scholes formula. 
    \cr
    
    
    \bold{JR Binomial Tree Model:}
    \cr\cr
    There exist many extensions of the CRR model. Jarrow and Rudd (1983), 
    JR, adjusted the CRR model to account for the local drift term. They 
    constructed a binomial model where the first two moments of the 
    discrete and continuous time return processes match. As a consequence 
    a probability measure equal to one half results. Therefore the CRR and
    JR models are sometimes atrributed as equal jumps binomial trees and
    equal probabilities binomial trees.
    \cr
    

    \bold{TIAN Binomial Tree Model:}
    \cr\cr Tian (1993) suggested to match discrete and continuous local 
    moments up to third order. 
    
    Leisen and Reimer (1996) proved that the order of convergence in 
    pricing European options for all three methods is equal to one, and 
    thus the three models are equivalent.

}


\note{

    Note, the \code{BinomialTree} and \code{BinomialTreePlot} are preliminary 
    implementations.
        
}


\value{

    The option price, a numeric value.
    
}


\references{
    
Broadie M., Detemple J. (1994);
    \emph{American Option Evaluation: New Bounds, Approximations, 
        and a Comparison of Existing Methods}, 
    Working Paper, Columbia University, New York. 

Cox J., Ross S.A., Rubinstein M. (1979);
    \emph{Option Pricing: A Simplified Approach}, 
    Journal of Financial Economics 7, 229--263. 

Haug E.G. (1997); 
    \emph{The complete Guide to Option Pricing Formulas}, 
    McGraw-Hill, New York.
    
Hull J.C. (1998);
    \emph{Introduction to Futures and Options Markets},
    Prentice Hall, London.
    
Jarrow R., Rudd A. (1983); 
    \emph{Option Pricing}, 
    Homewood, Illinois, 183--188. 
    
Leisen D.P., Reimer M., (1996); 
    \emph{Binomial Models for Option Valuation -- Examining and 
        Improving Convergence}, 
    Applied Mathematical Finanace 3, 319--346.

Tian Y. (1993);
    \emph{A Modified Lattice Approach to Option Pricing}, 
    Journal of Futures Markets 13, 563--577. 

}


\author{

    Diethelm Wuertz for the Rmetrics \R-port.
    
}


\examples{
## Cox-Ross-Rubinstein Binomial Tree Option Model:
   # Example 14.1 from Hull's Book:
   CRRBinomialTreeOption(TypeFlag = "pa", S = 50, X = 50, 
     Time = 5/12, r = 0.1, b = 0.1, sigma = 0.4, n = 5)
   # Example 3.1.1 from Haug's Book:
    CRRBinomialTreeOption(TypeFlag = "pa", S = 100, X = 95, 
        Time = 0.5, r = 0.08, b = 0.08, sigma = 0.3, n = 5)
   # A European Call - Compare with Black Scholes: 
   CRRBinomialTreeOption(TypeFlag = "ce", S = 100, X = 100, 
     Time = 1, r = 0.1, b = 0.1, sigma = 0.25, n = 50)
   GBSOption(TypeFlag = "c", S = 100, X = 100, 
     Time = 1, r = 0.1, b = 0.1, sigma = 0.25)@price
     
## CRR - JR - TIAN Model Comparison:  
   # Hull's Example as Function of "n":
   par(mfrow = c(2, 1), cex = 0.7)
   steps = 50
   CRROptionValue =  JROptionValue = TIANOptionValue = 
     rep(NA, times = steps)
   for (n in 3:steps) { 
     CRROptionValue[n] = CRRBinomialTreeOption(TypeFlag = "pa", S = 50, 
       X = 50, Time = 0.4167, r = 0.1, b = 0.1, sigma = 0.4, n = n)@price
     JROptionValue[n] = JRBinomialTreeOption(TypeFlag = "pa", S = 50, 
       X = 50, Time = 0.4167, r = 0.1, b = 0.1, sigma = 0.4, n = n)@price 
     TIANOptionValue[n] = TIANBinomialTreeOption(TypeFlag = "pa", S = 50, 
       X = 50, Time = 0.4167, r = 0.1, b = 0.1, sigma = 0.4, n = n)@price 
   }           
   plot(CRROptionValue[3:steps], type = "l", col = "red", ylab = "Option Value")
   lines(JROptionValue[3:steps], col = "green")
   lines(TIANOptionValue[3:steps], col = "blue")
   # Add Result from BAW Approximation:
   BAWValue =  BAWAmericanApproxOption(TypeFlag = "p", S = 50, X = 50, 
     Time = 0.4167, r = 0.1, b = 0.1, sigma = 0.4)@price
   abline(h = BAWValue, lty = 3)
   title(main = "Convergence")
   data.frame(CRROptionValue, JROptionValue, TIANOptionValue)
   
## Plot CRR Option Tree:
   # Again Hull's Example:
   CRRTree = BinomialTreeOption(TypeFlag = "pa", S = 50, X = 50, 
     Time = 0.4167, r = 0.1, b = 0.1, sigma = 0.4, n = 5)
   BinomialTreePlot(CRRTree, dy = 1, cex = 0.8, ylim = c(-6, 7),
     xlab = "n", ylab = "Option Value")
   title(main = "Option Tree")

}


\keyword{math}

\name{fOptions-package}

\alias{fOptions-package}
\alias{fOptions}


\docType{package}


\title{Basic Option Valuation}


\description{

    The Rmetrics "Options" package is a collection of functions to 
    valuate basic pptions. 
    
}


\details{

    \tabular{ll}{
        Package:    \tab fOptions\cr
        Type:       \tab Package\cr
        Version:    \tab R 3.0.1\cr
        Date:       \tab 2014\cr
        License:    \tab GPL Version 2 or later\cr
        Copyright:  \tab (c) 1999-2014 Rmetrics Assiciation\cr
        URL:        \tab \url{https://www.rmetrics.org}
  }

}


\section{1 Introduction}{

    The \code{fOptions} package provides function for pricing
    and evaluationg basic options.

}


\section{2 Plain Vanilla Option}{

    This section provides a collection of functions to valuate 
    plain vanilla options. Included are functions for the 
    Generalized Black-Scholes option pricing model, for options 
    on futures, some utility functions, and print and summary 
    methods for options.

    \preformatted{
    GBS*                      the generalized Black-Scholes option
    BlackScholesOption        a synonyme for the GBSOption
    Black76Option             options on Futures
    MiltersenSchwartzOption   options on commodity futures
    }
    
    \preformatted{
    NDF, CND, CBND  distribution functions
    }
    
    \preformatted{
    print                     print method for Options
    summary                   summary method for Options
    }

}


\section{3 Binomial Tree Options}{

    This section offers a collection of functions to valuate options in 
    the framework of the Binomial tree option approach.
    
    \preformatted{
    CRRBinomialTreeOption     CRR Binomial Tree Option
    JRBinomialTreeOption      JR Binomial Tree Option
    TIANBinomialTreeOption    TIAN Binomial Tree Option
    BinomialTreeOption        Binomial Tree Option
    BinomialTreePlot          Binomial Tree Plot
    }
    
}


\section{4 Monte Carlo Options}{
    
    In this section we provide functions to valuate options by Monte 
    Carlo methods. The functions include beside the main Monte Carlo 
    Simulator, example functions to generate Monte Carlo price paths 
    and to compute Monte Carlo price payoffs.
    
    \preformatted{
    sobolInnovations          Example for scrambled Sobol innovations
    wienerPath                Example for a Wiener price path
    plainVanillaPayoff        Example for the plain vanilla option's payoff
    arithmeticAsianPayoff     Example for the arithmetic Asian option's payoff
    MonteCarloOption          Monte Carlo Simulator for options
    }

}

 
\section{5 Low Discrepancy Sequences}{

    This section provides three types of random number generators for
    univorm and normal distributed deviates. These area pseudo random
    number generator and a halton and sobol generator for low discrepancy
    sequences.
    
    \preformatted{
    runif.pseudo    Uniform pseudo random numbers
    rnorm.pseudo    Normal pseudo random numbers
    }
    
    \preformatted{
    runif.halton    Uniform Halton sequence
    rnorm.halton    Normal Halton sequence
    }
    
    \preformatted{
    runif.sobol     Uniform scrambled Sobol sequence
    rnorm.sobol     Normal scrambled Sobol sequence
    }r
    
}


\section{6 Heston Nandi Garch Fit}{

    Her we provide functions to model the GARCH(1,1) price paths which 
    underly Heston and Nandi's option pricing model. The functions are:

    \preformatted{  
    hngarchSim           simulates a Heston-Nandi Garch(1,1) process
    hngarchFit           fits parameters of a Heston Nandi Garch(1,1) model
    }
    
    \preformatted{
    hngarchStats         returns true moments of the log-Return distribution
    }
    
    \preformatted{
    print.hngarch        print method, \cr
    summary.hngarch      diagnostic summary
    }
}


\section{7 Heston Nandi Garch Options}{

    This section comes with functions to valuate Heston-Nandi options. 
    Provided are functions to compute the option price and the delta 
    and gamma sensitivities for call and put options. 
    
    \preformatted{
    HNGOption            Heston-Nandi GARCH(1,1) option price
    HNGGreeks            Heston-Nandi GARCH(1,1) option sensitivities
    HNGCharacteristics   combines option prices and sensitivities
    }
    
}


\section{About Rmetrics}{

    The \code{fOptions} Rmetrics package is written for educational 
    support in teaching "Computational Finance and Financial Engineering" 
    and licensed under the GPL.
    
}


\keyword{package}

\name{PlainVanillaOptions}

\alias{PlainVanillaOptions}

\alias{fOPTION}
\alias{fOPTION-class}

\alias{GBSOption}
\alias{GBSCharacteristics}
\alias{BlackScholesOption}
\alias{GBSGreeks}
\alias{GBSVolatility}

\alias{Black76Option}
\alias{MiltersenSchwartzOption}

\alias{NDF}
\alias{CND}
\alias{CBND}

\alias{print.option}
\alias{summary.option}

\alias{show,fOPTION-method}
\alias{summary.fOPTION}


\title{Valuation of Plain Vanilla Options}


\description{

    A collection and description of functions to valuate plain vanilla 
    options. Included are functions for the Generalized Black-Scholes 
    option pricing model, for options on futures, some utility functions, 
    and print and summary methods for options.
    \cr

    The functions are:

    \tabular{ll}{
    \code{GBS*} \tab the generalized Black-Scholes option, \cr
    \code{BlackScholesOption} \tab a synonyme for the GBSOption, \cr
    \code{Black76Option} \tab options on Futures, \cr
    \code{MiltersenSchwartzOption} \tab options on commodity futures, \cr
    \code{NDF, CND, CBND} \tab distribution functions, \cr
    \code{print} \tab print method for Options, \cr
    \code{summary} \tab summary method for Options. }

}


\usage{
GBSOption(TypeFlag, S, X, Time, r, b, sigma,
    title = NULL, description = NULL)
GBSGreeks(Selection, TypeFlag, S, X, Time, r, b, sigma)
GBSCharacteristics(TypeFlag, S, X, Time, r, b, sigma)
GBSVolatility(price, TypeFlag, S, X, Time, r, b, tol, maxiter)
BlackScholesOption(\dots)

Black76Option(TypeFlag, FT, X, Time, r, sigma,
    title = NULL, description = NULL)

MiltersenSchwartzOption(TypeFlag, Pt, FT, X, time, Time,
    sigmaS, sigmaE, sigmaF, rhoSE, rhoSF, rhoEF, KappaE, KappaF,
    title = NULL, description = NULL)

NDF(x)
CND(x)
CBND(x1, x2, rho)

\S4method{show}{fOPTION}(object)
\method{summary}{fOPTION}(object, \dots)

\method{print}{option}(x, \dots)
\method{summary}{option}(object, \dots)
}


\arguments{

    \item{b}{
        the annualized cost-of-carry rate, a numeric value;
        e.g. 0.1 means 10\% pa.
        }
    \item{description}{
        a character string which allows for a brief description.
        }
    \item{FT}{
        [Black76*][MiltersenSchwartz*] - \cr
        the futures price, a numeric value.
        }
    \item{KappaE, KappaF}{
        [MiltersenSchwartz*] - \cr
        the speed of mean reversion of the forward interest rate (E),
        the speed of mean reversion of the convenience yield (F),
        a numeric value.
        }
    \item{maxiter, tol}{
        [GBSVolatility*] - \cr
        the maximum number of iterations and the tolerance to compute
        the root of the GBS volatility equation, see \code{uniroot}.
        }
    \item{object}{
        an object of class \code{"option"}.
        }
    \item{price}{
        [GBSVolatility*] - \cr
        the price of the GBS option, a numerical value.
        }
    \item{Pt}{
        [MiltersenSchwartz*] - \cr
        the zero coupon bond that expires on the option
        maturity; a numeric value.
        }
    \item{r}{
        the annualized rate of interest, a numeric value;
        e.g. 0.25 means 25\% pa.
        }
    \item{rhoSE, rhoSF, rhoEF}{
        [MiltersenSchwartz*] - \cr
        the correlations
        between the spot commodity price and the future convenience yield (SE),
        between the spot commodity price and the forward interest rate (SF),
        between the forward interest rate and the future convenience yield (EF),
        a numeric value.
        }
    \item{S}{
        the asset price, a numeric value.
        }
    \item{Selection}{
        [GBSGreeks] - \cr
        sensitivity to be computed, one of \code{"delta"}, \code{"gamma"},
        \code{"vega"}, \code{"theta"}, \code{"rho"}, or \code{"CoC"},
        a string value.
        }
    \item{sigma}{
        the annualized volatility of the underlying security,
        a numeric value; e.g. 0.3 means 30\% volatility pa.
        }
    \item{sigmaS, sigmaE, sigmaF}{
        [MiltersenSchwartz*] - \cr
        numeric values, the annualized volatility
        of the spot commodity price (S),
        of the future convenience yield (E), and
        of the forward interest rate (F),
        e.g. 0.25 means 25\% pa.
        }
    \item{time, Time}{
        the time to maturity measured in years, a numeric value.
        }
    \item{title}{
        a character string which allows for a project title.
        }
    \item{TypeFlag}{
        a character string either \code{"c"} for a call option or
        a \code{"p"} for a put option.
        }
    \item{x, x1, x2, rho}{
        [NDF][CND][CBND] - \cr
        the function argument \code{x} for the normal distribution
        function \code{NDF} and the cumulated normal distribution
        \code{CND}. The arguments for the bivariate function are
        named \code{x1} and \code{x2}; \code{rho} is the correlation
        coefficient. \cr
        [print] - \cr
        the object \code{x} to be printed.
        }
    \item{X}{
        a numeric value, the exercise price.
        }
    \item{\dots}{
        arguments to be passed.
        }

}


\value{

    \code{GBSOption}\cr
    \code{BlackScholesOption}
    \cr
    returns an object of class \code{"fOption"}.
    \cr

    \code{GBSGreeks}
    \cr
    returns the option sensitivity for the selected Greek, a
    numeric value.
    \cr

    \code{GBSCharacteristics}
    \cr
    returns a list with the following entries:
    \code{premium}, the option price,
    \code{delta}, the delta sensitivity,
    \code{gamma}, the gamma sensitivity,
    \code{theta}, the theta sensitivity,
    \code{vega}, the vega sensitivity,
    \code{rho}, the rho sensitivity,
    \code{lambda}, the lambda sensitivity.
    \cr

    \code{GBSVolatility}
    \cr
    returns the GBS option implied volatility for a given price.
    \cr

    \code{Black76Option},\cr
    \code{MiltersenSchwartzOption}
    \cr
    return an object of class \code{"fOption"}.


    The option valuation programs return an object of class
    \code{"fOPTION"} with the following slots:

    \item{@call}{
        the function call.
        }
    \item{@parameters}{
        a list with the input parameters.
        }
    \item{@price}{
        a numeric value with the value of the option.
        }
    \item{@title}{
        a character string with the name of the test.
        }
    \item{@description}{
        a character string with a brief description of the
        test.
        }

}


\details{

    \bold{Generalized Black Scholes Options:}
    \cr\cr
    \code{GBSOption} calculates the option price, \code{GBSGreeks}
    calculates option sensitivities delta, theta, vega, rho, lambda
    and gamma, and \code{GBScharacterisitics} does both.
    \code{GBSVolatility} computes the implied volatility.
    \cr
    Note, that setting \code{b = r} we get Black and Scholes' stock option
    model, \code{b = r-q} we get Merton's stock option model with continuous
    dividend yield \code{q}, \code{b = 0} we get Black's futures option
    model, and \code{b = r-rf} we get Garman and Kohlhagen's currency
    option model with foreign interest rate \code{rf}.
    \cr


    \bold{Options on Futures:}
    \cr\cr
    The \code{Black76Option} pricing formula is applicable for valuing
    European call and European put options on commodity futures. The
    exact nature of the underlying commodity varies and may be anything
    from a precious metal such as gold or silver to agricultural products.
    \cr
    The \code{Miltersen Schwartz Option} model is a three factor model
    with stochastic futures prices, term structures and convenience
    yields, and interest rates. The model is based on lognormal
    distributed commodity prices and normal distributed continuously
    compounded forward interest rates and future convenience yields.
    \cr


    \bold{Miltersen Schwartz Options:}
    \cr\cr
    The \code{MiltersenSchwartzOption} function allows for pricing
    options on commodity futures. The model is a three factor model
    with stochastic futures prices, term structures of convenience
    yields, and interest rates. The model is based on lognormal
    distributed commodity prices and normal distributed continuously
    compounded forward interest rates and futures convenience yields.
    \cr


    \bold{Distribution Functions:}
    \cr\cr
    The functions \code{NDF}, \code{CND}, and \code{CBND} compute
    vlues for the Normal density functions, for the normal
    probability function, and for the bivariate normal probability
    functions. The functions are implemented as described in the
    book of E.G. Haug.
    \cr


    \bold{Print and Summary Method:}
    \cr\cr
    Thes are two methods to print and sumarize an object of class
    \code{"fOPTION"} or of \code{"option"}. The second is used
    for the older class representation.

}


\note{

    The functions implement algorithms to valuate plain vanilla
    options and to compute option Greeks as described in Chapter 1
    of Haug's Option Guide (1997).

}


\references{

Black F., Scholes M. (1973);
    \emph{The Pricing of Options and Corporate Liabilities},
    Journal of Political Economy 81, 637--654.

Haug E.G. (1997);
    \emph{The Complete Guide to Option Pricing Formulas},
    Chapter 1, McGraw-Hill, New York.

Hull J.C. (1998);
    \emph{Introduction to Futures and Options Markets},
    Prentice Hall, London.

Miltersen K., Schwartz E.S. (1998);
    \emph{Pricing of Options on Commodity Futures with
    Stochastic Term Structuures of Convenience Yields and
    Interest Rates},
    Journal of Financial and Quantitative Analysis 33, 33--59.

}


\author{

    Diethelm Wuertz for the Rmetrics \R-port.

}


\examples{
## All the examples are from Haug's Option Guide (1997)

## CHAPTER 1.1: ANALYTICAL FORMULAS FOR EUROPEAN OPTIONS:

## Black Scholes Option [Haug 1.1.1]
   GBSOption(TypeFlag = "c", S = 60, X = 65, Time = 1/4, r = 0.08,
     b = 0.08, sigma = 0.30)

## European Option on a Stock with Cash Dividends [Haug 1.1.2]
   S0  =  100; r  =  0.10; D1  =  D2  =  2; t1  =  1/4; t2  =  1/2
   S  =  S0 - 2*exp(-r*t1) - 2*exp(-r*t2)
   GBSOption(TypeFlag = "c", S = S, X = 90, Time = 3/4, r = r, b = r,
     sigma = 0.25)

## Options on Stock Indexes [Haug 1.2.3]
   GBSOption(TypeFlag = "p", S = 100, X = 95, Time = 1/2, r = 0.10,
     b = 0.10-0.05, sigma = 0.20)

## Option on Futures [Haug 1.1.4]
   FuturesPrice  =  19
   GBSOption(TypeFlag = "c", S = FuturesPrice, X = 19, Time = 3/4,
     r = 0.10, b = 0, sigma = 0.28)

## Currency Option [Haug 1.1.5]
   r  =  0.06; rf  =  0.08
   GBSOption(TypeFlag = "c", S = 1.5600, X = 1.6000,
     Time = 1/2, r = 0.06, b = 0.06-0.08, sigma = 0.12)

## Delta of GBS Option [Haug 1.3.1]
   GBSGreeks(Selection = "delta", TypeFlag = "c", S = 105, X = 100,
     Time = 1/2, r = 0.10, b = 0, sigma = 0.36)

## Gamma of GBS Option [Haug 1.3.3]
   GBSGreeks(Selection = "gamma", TypeFlag = "c", S = 55, X = 60,
     Time = 0.75, r = 0.10, b = 0.10, sigma = 0.30)

## Vega of GBS Option [Haug 1.3.4]
   GBSGreeks(Selection = "vega", TypeFlag = "c", S = 55, X = 60,
     Time = 0.75, r = 0.10, b = 0.10, sigma = 0.30)

## Theta of GBS Option [Haug 1.3.5]
    GBSGreeks(Selection = "theta", TypeFlag = "p", S = 430, X = 405,
     Time = 0.0833, r = 0.07, b = 0.07-0.05, sigma = 0.20)

## Rho of GBS Option [Haug 1.3.5]
   GBSGreeks(Selection = "rho", TypeFlag = "c", S = 72, X = 75,
     Time = 1, r = 0.09, b = 0.09, sigma = 0.19)

## CHAPTER 1.3 OPTIONS SENSITIVITIES:

## The Generalized Black Scholes Option Formula
   GBSCharacteristics(TypeFlag = "p", S = 1.5600, X = 1.6000,
     Time = 1, r = 0.09, b = 0.09, sigma = 0.19)

## CHAPTER 1.5: RECENT DEVELOPMENTS IN COMMODITY OPTIONS

## Miltersen Schwartz Option vs. Black76 Option on Futures:
   MiltersenSchwartzOption(TypeFlag = "c", Pt = exp(-0.05/4), FT = 95,
     X = 80, time = 1/4, Time = 1/2, sigmaS = 0.2660, sigmaE = 0.2490,
     sigmaF = 0.0096, rhoSE = 0.805, rhoSF = 0.0805, rhoEF = 0.1243,
     KappaE = 1.045, KappaF = 0.200)
   Black76Option(TypeFlag = "c", FT = 95, X = 80, Time = 1/2, r = 0.05,
     sigma = 0.266)

}


\keyword{math}

\name{HestonNandiGarchFit}


\alias{HestonNandiGarchFit}

\alias{hngarchSim}
\alias{hngarchFit}

\alias{hngarchStats}
\alias{print.hngarch}
\alias{summary.hngarch}


\title{Heston-Nandi Garch(1,1) Modelling}


\description{

    A collection and description of functions to model 
    the GARCH(1,1) price paths which underly Heston and 
    Nandi's option pricing model.
    \cr
    
    The functions are:

    \tabular{ll}{  
    \code{hngarchSim} \tab Simulates a Heston-Nandi Garch(1,1) process, \cr
    \code{hngarchFit} \tab MLE for a Heston Nandi Garch(1,1) model, \cr
    \code{hngarchStats} \tab True moments of the log-Return distribution, \cr
    \code{print.hngarch} \tab Print method, \cr
    \code{summary.hngarch} \tab Diagnostic summary.}
    
}


\usage{
hngarchSim(model, n, innov, n.start, start.innov, rand.gen, \dots)
hngarchFit(x, model = list(lambda = -0.5, omega = var(x), alpha =
    0.1 * var(x), beta = 0.1, gamma = 0, rf = 0), symmetric = TRUE, 
    trace = FALSE, title = NULL, description = NULL, \dots)
hngarchStats(model)

\method{print}{hngarch}(x, \dots)
\method{summary}{hngarch}(object, \dots)
}


\arguments{

    \item{description}{
        a brief description of the porject of type character.
        }
    \item{innov}{
        [hngarchSim] - \cr
        is a univariate time series or vector of innovations to produce 
        the series. If not provided, \code{innov} will be generated using 
        the random number generator specified by \code{rand.gen}. 
        Missing values are not allowed. By default the normal
        random number generator will be used.
        }
    \item{model}{
        a list of GARCH model parameters with the following entries:
        \code{lambda},
        \code{omega}, the constant coefficient of the variance equation, 
        \code{alpha} the autoregressive coefficient,
        \code{beta} the variance coefficient,
        \code{gamma} the asymmetry coefficient,
        and \code{rf}, the risk free rate, numeric values.  
        }
    \item{n}{
        [hngarchSim] - \cr
        is the length of the series to be simulated. The default 
        value is 1000.
        }
    \item{n.start}{
        [hngarchSim] - \cr
        gives the number of start-up values to be discarded.
        The default value is 100.
        } 
    \item{object}{
        [summary] - \cr
        a fitted HN-GARCH(1,1) time series object of class \code{"hngarch"} 
        as returned from the function \code{hngarchFit}.
        }
    \item{rand.gen}{
        [hngarchSim] - \cr
        is the function which is called to generate the innovations. 
        Usually, \code{rand.gen} will be a random number generator. 
        Additional arguments required by the random number generator 
        \code{rand.gen}, usually the location, scale and/or shape 
        parameter of the underlying distribution function, have to be 
        passed through the \code{dots} argument.
        }
    \item{start.innov}{
        [hngarchSim] - \cr
        is a univariate time series or vector of innovations to be used 
        as start up values. Missing values are not allowed.
        }
    \item{symmetric}{
        [hngarchFit] - \cr
        a logical, if TRUE a symmetric model is estimated, otherwise 
        the parameters are estimated for an asymmetric HN Garch(1,1) model.
        }
    \item{title}{
        a character string which allows for a project title.
        }
    \item{trace}{
        [hngarchFit] - \cr
        a logical value. Should the optimizarion be traced?
        If \code{trace=FALSE}, no tracing is done of the 
        iteration path.
        }
    \item{x}{
        [hngarchFit] - \cr
        an univariate vector or time series. \cr
        [print] - \cr
        a fitted HN-GARCH(1,1) time series object of class \code{"hngarch"} 
        as returned from the function \code{hngarchFit}.
        }
    \item{\dots}{
        additional arguments to be passed.
        }
    
}


\details{

    \bold{Path Simulation:}
    \cr\cr
    The function \code{hngarchSim} simulates a Heston-Nandi Garch(1,1) 
    process with structure parameters specified through the list 
    \code{model(lambda, omega, alpha, beta, gamma, rf)}.
    \cr

    
    \bold{Parameter Estimation:}
    \cr\cr
    The function \code{hngarchFit} estimates by the maximum log-likelihood
    approach the parameters either for a symmetric or an asymmetric 
    Heston-Nandi Garch(1,1) model from the log returns \code{x} of a 
    financial time series. For optimization R's \code{optim} function is
    used. Additional optimization parameters may be passed throught the 
    \code{\dots} argument.
    \cr
  
    
    \bold{Diagnostic Analysis:}
    \cr\cr
    The function \code{summary.hngarch} performs a diagnostic analysis
    and recalculates conditional variances and innovations from the time 
    series.
    \cr
  
    
    \bold{Calculation of Moments:}
    \cr\cr
    The function \code{hngarchStats} calculates the first four true 
    moments of the unconditional log return distribution for a stationary 
    Heston-Nandi Garch(1,1) process with standard normally distributed 
    innovations. In addition the persistence and the expectation values 
    of sigma to the power 2, 4, 6, and 8 can be accessed.
    
}

\value{
  
    \code{hngarchSim}
    \cr
    returns numeric vector with the simulated time 
    series points  neglecting those from the first \code{start.innov} 
    innovations.  
    \cr
  
    \code{hngarchFit}
    \cr
    returns list with two entries: The estimated model parmeters 
    \code{model}, where \code{model} is a list of the parameters 
    itself, and \code{llh} the value of the log likelihood.
    \cr
    
    \code{hngarchStats}
    \cr
    returns a list with the following components:
    \code{persistence}, the value of the persistence,
    \code{meansigma2}, \code{meansigma4}, \code{meansigma6}, \code{meansigma8}, 
    the expectation value of sigma to the power of 2, 4, 6, and 8,
    \code{mean}, \code{variance}, \code{skewness}, \code{kurtosis},
    the mean, variance, skewness and kurtosis of the log returns.
    \cr

    \code{summary.hngarch}
    \cr
    returns list with the following elements: \code{h}, 
    a numeric vector with the conditional variances, \code{z}, a numeric 
    vector with the innovations.
    
}


\references{

Heston S.L., Nandi S. (1997);
    \emph{A Closed-Form GARCH Option Pricing Model},
    Federal Reserve Bank of Atlanta.
    
}


\author{

    Diethelm Wuertz for the Rmetrics \R-port.
    
}


\examples{
## hngarchSim -
   # Simulate a Heston Nandi Garch(1,1) Process:
   # Symmetric Model - Parameters:
   model = list(lambda = 4, omega = 8e-5, alpha = 6e-5, 
     beta = 0.7, gamma = 0, rf = 0)
   ts = hngarchSim(model = model, n = 500, n.start = 100)
   par(mfrow = c(2, 1), cex = 0.75)
   ts.plot(ts, col = "steelblue", main = "HN Garch Symmetric Model")
   grid()
   
## hngarchFit - 
   # HN-GARCH log likelihood Parameter Estimation:
   # To speed up, we start with the simulated model ...
   mle = hngarchFit(model = model, x = ts, symmetric = TRUE)
   mle
   
## summary.hngarch - 
   # HN-GARCH Diagnostic Analysis:
   par(mfrow = c(3, 1), cex = 0.75)
   summary(mle)    

## hngarchStats - 
   # HN-GARCH Moments:
   hngarchStats(mle$model)     
}


\keyword{models}

\name{BasicAmericanOptions}

\alias{BasicAmericanOptions}

\alias{RollGeskeWhaleyOption}
\alias{BAWAmericanApproxOption}
\alias{BSAmericanApproxOption}


\title{Valuation of Basic American Options}


\description{

    A collection and description of functions to valuate 
    basic American options. Approximative formulas for 
    American calls are given for the Roll, Geske and 
    Whaley Approximation, for the Barone-Adesi and Whaley 
    Approximation, and for the Bjerksund and Stensland 
    Approximation.
    \cr
    
    The functions are:

    \tabular{ll}{
    \code{RollGeskeWhaleyOption} \tab Roll, Geske and Whaley Approximation, \cr
    \code{BAWAmericanApproxOption} \tab Barone-Adesi and Whaley Approximation, \cr
    \code{BSAmericanApproxOption} \tab Bjerksund and Stensland Approximation. }
    
}


\usage{
RollGeskeWhaleyOption(S, X, time1, Time2, r, D, sigma,
    title = NULL, description = NULL) 
BAWAmericanApproxOption(TypeFlag, S, X, Time, r, b, sigma,
    title = NULL, description = NULL)
BSAmericanApproxOption(TypeFlag, S, X, Time, r, b, sigma,
    title = NULL, description = NULL) 
}


\arguments{

    \item{b}{
        the annualized cost-of-carry rate, a numeric value; 
        e.g. 0.1 means 10\% pa.
        }
    \item{D}{
        a single dividend with time to dividend payout \code{t1}.
        }
    \item{description}{
        a character string which allows for a brief description.
        }
    \item{r}{
        the annualized rate of interest, a numeric value; 
        e.g. 0.25 means 25\% pa.
        }
    \item{S}{
        the asset price, a numeric value.
        }
    \item{sigma}{
        the annualized volatility of the underlying security, 
        a numeric value; e.g. 0.3 means 30\% volatility pa.
        }
    \item{Time}{
        the time to maturity measured in years, a numeric value.
        }
    \item{time1, Time2}{
        [RollGeskeWhaley*] - 
        the first value measures time to dividend payout in years, 
        e.g. 0.25 denotes a quarter, and the second value measures 
        time to maturity measured in years, a numeric value; e.g. 
        0.5 means 6 months.
        }
    \item{title}{
        a character string which allows for a project title.
        }
    \item{TypeFlag}{
        a character string either "c" for a call option or a "p" 
        for a put option.
        }
    \item{X}{
        the exercise price, a numeric value.
        }

}


\value{
  
    \code{RollGeskeWhaleyOption} \cr
    \code{BAWAmericanApproxOption}
    \cr
    return the option price, a numeric value.
    \cr
    
    \code{BSAmericanApproxOption}
    \cr
    returns a list with the following two elements: \code{Premium} the 
    option price, and \code{TriggerPrice} the trigger price.  
    \cr
 
}


\details{
    
    \bold{Roll-Geske-Whaley Option:}
    \cr\cr
    The function \code{RollGeskeWhaleyOption} valuates American calls 
    on a stock paying a single dividend with specified time to dividend 
    payout according to the pricing formula derived by Roll, Geske and 
    Whaley (1977).
    \cr
    
    
    \code{Approximations for American Options:} 
    \cr\cr
    The function \code{BSAmericanApproxOption} valuates American calls 
    or puts on an underlying asset for a given cost-of-carry rate 
    according to the quadratic approximation method due to Barone-Adesi 
    and Whaley (1987). The function \code{BSAmericanApproxOption} valuates 
    American calls or puts on stocks, futures, and currencies due to 
    the approximation method of Bjerksund and Stensland (1993).
  
}


\note{
  
    The functions implement the algorithms to valuate basic American 
    options as described in Chapter 1.4 of Haug's Option Guide (1997).
    
}


\references{

Barone-Adesi G., Whaley R.E. (1987);
    \emph{Efficient Analytic Approximation of American Option Values},
    Journal of Finance 42, 301--320.
    
Bjerksund P., Stensland G. (1993);
    \emph{Closed Form Approximation of American Options},
    Scandinavian Journal of Management 9, 87--99.
    
Geske R. (1979);
    \emph{A Note on an Analytical Formula for Unprotected
    American Call Options on Stocks with known Dividends},
    Journal of Financial Economics 7, 63--81.

Haug E.G. (1997); 
    \emph{The Complete Guide to Option Pricing Formulas}, 
    Chapter 1, McGraw-Hill, New York.

Roll R. (1977);
    \emph{An Analytic Valuation Formula for Unprotected
    American Call Options on Stocks with known Dividends},
    Journal of Financial Economics 5, 251--258.
    
}


\author{

    Diethelm Wuertz for the Rmetrics \R-port.

}


\examples{
## All the examples are from Haug's Option Guide (1997)

## CHAPTER 1.4: ANALYTICAL MODELS FOR AMERICAN OPTIONS
       
## Roll-Geske-Whaley American Calls on Dividend Paying 
   # Stocks [Haug 1.4.1]
   RollGeskeWhaleyOption(S = 80, X = 82, time1 = 1/4, 
     Time2 = 1/3, r = 0.06, D = 4, sigma = 0.30)
      
## Barone-Adesi and Whaley Approximation for American 
   # Options [Haug 1.4.2] vs. Black76 Option on Futures:
   BAWAmericanApproxOption(TypeFlag = "p", S = 100, 
     X = 100, Time = 0.5, r = 0.10, b = 0, sigma = 0.25)
   Black76Option(TypeFlag = "c", FT = 100, X = 100, 
     Time = 0.5, r = 0.10, sigma = 0.25)  
     
## Bjerksund and Stensland Approximation for American Options:
   BSAmericanApproxOption(TypeFlag = "c", S = 42, X = 40, 
     Time = 0.75, r = 0.04, b = 0.04-0.08, sigma = 0.35)
}


\keyword{math}

\name{LowDiscrepancy}

\alias{LowDiscrepancy}

\alias{runif.halton}
\alias{rnorm.halton}
\alias{runif.sobol}
\alias{rnorm.sobol}
\alias{runif.pseudo}
\alias{rnorm.pseudo}


\title{Low Discrepancy Sequences}


\description{
    
    A collection and description of functions to compute 
    Halton's and Sobol's low discrepancy sequences, 
    distributed in form of a uniform or normal distribution. 
    \cr
    
    The functions are:

    \tabular{ll}{
    \code{runif.halton} \tab Uniform Halton sequence, \cr
    \code{rnorm.halton} \tab Normal Halton sequence, \cr
    \code{runif.sobol} \tab Uniform scrambled Sobol sequence, \cr
    \code{rnorm.sobol} \tab Normal scrambled Sobol sequence, \cr
    \code{runif.pseudo} \tab Uniform pseudo random numbers, \cr
    \code{norma.pseudo} \tab Normal pseudo random numbers.}
            
}


\usage{
runif.halton(n, dimension, init) 
rnorm.halton(n, dimension, init)

runif.sobol(n, dimension, init, scrambling, seed) 
rnorm.sobol(n, dimension, init, scrambling, seed)

runif.pseudo(n, dimension, init)
rnorm.pseudo(n, dimension, init)
}


\arguments{

    \item{dimension}{
        an integer value, the dimension of the sequence. The 
        maximum value for the Sobol generator is 1111.
        }
    \item{init}{
        a logical, if TRUE the sequence is initialized and
        restarts, otherwise not. By default TRUE.
        }
    \item{n}{
        an integer value, the number of random deviates.
        }
    \item{scrambling}{
        an integer value, if 1, 2 or 3 the sequence is scrambled
        otherwise not. If 1, Owen type type of scrambling is 
        applied, if 2, Faure-Tezuka type of scrambling, is
        applied, and if 3, both Owen+Faure-Tezuka type of
        scrambling is applied. By default 0.
        }
    \item{seed}{
        an integer value, the random seed for initialization
        of the scrambling process. By default 4711. On effective
        if \code{scrambling>0}.
        }
        
}


\value{
  
    All generators return a numeric matrix of size \code{n} 
    by \code{dimension}.
    
}


\details{
    
    \bold{Halton's Low Discrepancy Sequences:}
    \cr\cr
    Calculates a matrix of uniform or normal deviated halton low 
    discrepancy numbers.
    \cr
    
    
    \bold{Scrambled Sobol's Low Discrepancy Sequences:}
    \cr\cr
    Calculates a matrix of uniform and normal deviated Sobol low 
    discrepancy numbers. Optional scrambling of the sequence can 
    be selected.
    \cr
    
    
    \bold{Pseudo Random Number Sequence:}
    \cr\cr
    Calculates a matrix of uniform or normal distributed pseudo 
    random numbers. This is a helpful function for comparing 
    investigations obtained from a low discrepancy series with 
    those from a pseudo random number.

}


\note{

    The global variables \code{runif.halton.seed} and 
    \code{runif.sobol.seed} save the status to restart the 
    generators. Note, that only one instance of a generators 
    can be run at the same time.
    
    The ACM Algorithm 659 implemented to generate scrambled 
    Sobol sequences is under the License of the ACM restricted 
    for academic and noncommerical usage. Please consult the 
    ACM License agreement included in the \code{doc} directory.
    
}


\author{
    
    P. Bratley and B.L. Fox for the Fortran Sobol Algorithm 659,\cr
    S. Joe for the Fortran extension to 1111 dimensions,\cr
    Diethelm Wuertz for the Rmetrics \R-port.
    
}


\references{

Bratley P., Fox B.L. (1988);
    \emph{Algorithm 659: Implementing Sobol's Quasirandom
    Sequence Generator},
    ACM Transactions on Mathematical Software 14, 88--100.

Joe S., Kuo F.Y. (1998);
    \emph{Remark on Algorithm 659: Implementing Sobol's Quaisrandom
    Seqence Generator}.
    
}


\examples{
## *.halton - 
   par(mfrow = c(2, 2), cex = 0.75)
   runif.halton(n = 10, dimension = 5)
   hist(runif.halton(n = 5000, dimension = 1), main = "Uniform Halton", 
     xlab = "x", col = "steelblue3", border = "white")
   rnorm.halton(n = 10, dimension = 5)
   hist(rnorm.halton(n = 5000, dimension = 1), main = "Normal Halton", 
     xlab = "x", col = "steelblue3", border = "white")
   
## *.sobol - 
   runif.sobol(n = 10, dimension = 5, scrambling = 3)
   hist(runif.sobol(5000, 1, scrambling = 2), main = "Uniform Sobol", 
     xlab = "x", col = "steelblue3", border = "white")
   rnorm.sobol(n = 10, dimension = 5, scrambling = 3)
   hist(rnorm.sobol(5000, 1, scrambling = 2), main = "Normal Sobol", 
     xlab = "x", col = "steelblue3", border = "white")
   
## *.pseudo - 
   runif.pseudo(n = 10, dimension = 5)
   rnorm.pseudo(n = 10, dimension = 5) 
}


\keyword{programming}

\name{HestonNandiOptions}

\alias{HestonNandiOptions}

\alias{HNGOption}
\alias{HNGGreeks}
\alias{HNGCharacteristics}


\title{Option Price for the Heston-Nandi Garch Option Model}


\description{
  
    A collection and description of functions to valuate 
    Heston-Nandi options. Included are functions to compute 
    the option price and the delta and gamma sensitivities 
    for call and put options. 
    \cr
    
    The functions are:
    
    \tabular{ll}{
    \code{HNGOption} \tab Heston-Nandi GARCH(1,1) option price, \cr
    \code{HNGGreeks} \tab Heston-Nandi GARCH(1,1) option sensitivities, \cr
    \code{HNGCharacteristics} \tab option prices and sensitivities. }
    
}


\usage{
HNGOption(TypeFlag, model, S, X, Time.inDays, r.daily)
HNGGreeks(Selection, TypeFlag, model, S, X, Time.inDays, r.daily)
HNGCharacteristics(TypeFlag, model, S, X, Time.inDays, r.daily)
}


\arguments{

    \item{model}{
        a list of model parameters with the following entries:
        \code{lambda}, \code{omega}, \code{alpha}, \code{beta}, 
        and \code{gamma}, numeric values.
        }
    \item{r.daily}{
        the daily rate of interest, a numeric value; 
        e.g. 0.25/252 means about 0.001\% per day.
        }
    \item{S}{
        the asset price, a numeric value.
        }
    \item{Selection}{
        sensitivity to be computed, one of \code{"delta"}, \code{"gamma"},
        \code{"vega"}, \code{"theta"}, \code{"rho"}, or \code{"CoC"}, 
        a string value.
        }
    \item{Time.inDays}{
        the time to maturity measured in days, a numerical 
        value; e.g. 5/252 means 1 business week.
        }
    \item{TypeFlag}{
        a character string either \code{"c"} for a call option or a 
        \code{"p"} for a put option.
        }
    \item{X}{
        the exercise price, a numeric value.
        }
  
}


\value{

    \code{HNGOption}
    \cr
    returns a list object of class \code{"option"} with \code{$price}
    denoting the option price, a numeric value, and \code{$call} a 
    character string which matches the function call.
    \cr

    
    \code{HNGOGreeks} 
    \cr
    returns the option sensitivity for the selected Greek, either
    \code{"delta"} or \code{"gamma"}; a numeric value.
  
    
    \code{HNGCharacteristics} 
    \cr
    returns a list with the following entries:
    
    \item{premium}{
        the option price, a numeric value.}
    \item{delta}{
        the delta sensitivity, a numeric value.}
    \item{gamma}{
        the gamma sensitivity, a numeric value.}
    
}


\details{

    \bold{Option Values:}
    \cr\cr
    \code{HNGOption}calculates the option price, \code{HNGGreeks}
    allows to compute the option sensitivity Delta or Gamma, and 
    \code{HNGcharacterisitics} summarizes both in one function call.
    
}


\references{
Heston S.L., Nandi S. (1997);
    \emph{A Closed-Form GARCH Option Pricing Model},
    Federal Reserve Bank of Atlanta.
}


\author{

    Diethelm Wuertz for the Rmetrics \R-port.
    
}


\examples{
## model -
   # Define the Model Parameters for a Heston-Nandi Option:
   model = list(lambda = -0.5, omega = 2.3e-6, alpha = 2.9e-6, 
     beta = 0.85, gamma = 184.25) 
   S = X = 100
   Time.inDays = 252
   r.daily = 0.05/Time.inDays
   sigma.daily = sqrt((model$omega + model$alpha) /
     (1 - model$beta - model$alpha * model$gamma^2))
   data.frame(S, X, r.daily, sigma.daily)

## HNGOption -
   # Compute HNG Call-Put and compare with GBS Call-Put:
   HNG = GBS = Diff = NULL
   for (TypeFlag in c("c", "p")) {
     HNG = c(HNG, HNGOption(TypeFlag, model = model, S = S, X = X, 
       Time.inDays = Time.inDays, r.daily = r.daily)$price )
     GBS = c(GBS, GBSOption(TypeFlag, S = S, X = X, Time = Time.inDays, 
       r = r.daily, b = r.daily, sigma = sigma.daily)@price) }
   Options = cbind(HNG, GBS, Diff = round(100*(HNG-GBS)/GBS, digits=2))
   row.names(Options) <- c("Call", "Put")
   data.frame(Options)
     
## HNGGreeks -
   # Compute HNG Greeks and compare with GBS Greeks:
   Selection = c("Delta", "Gamma")
   HNG = GBS = NULL
   for (i in 1:2){
     HNG = c(HNG, HNGGreeks(Selection[i], TypeFlag = "c", model = model, 
       S = 100, X = 100, Time = Time.inDays, r = r.daily) ) 
     GBS = c(GBS, GBSGreeks(Selection[i], TypeFlag = "c", S = 100, X = 100, 
       Time = Time.inDays, r = r.daily, b = r.daily, sigma = sigma.daily) ) }
   Greeks = cbind(HNG, GBS, Diff = round(100*(HNG-GBS)/GBS, digits = 2))
   row.names(Greeks) <- Selection
   data.frame(Greeks)
}


\keyword{math}
